C     PROGRAM XX2TAR3: DRIVER ROUTINE X2TAR FOR MONTE CARLO EXPERIMENT
C     FOR ESTIMATION OF 2 REGIMES THRESHOLD AUTOREGRESSIVE MODEL 
C     UNLIKE THE VERSION XX2TAR2.FOR, THAT USES THE METHOD OF
C     TONG, 1990, P. 385 (7 THRESHOLDS ARE TRIED AND MIN AIC IS CHOSEN)
C     HERE THE EMPIRICAL PERCENTILES ARE USED, AS SUGGESTED BY
C     TONG AND LIM (1980). ALL TIME SERIES VALUES BETWEEN THE FIRST AND
C     THIRD QUARTILE ARE TRIED (MOEANADDIN AND TONG, 1988) 
C     -> THIS VERSION IS USED FOR COMPARISON WITH SETARMA MODELS:
C        ORIGINAL PROGRAM IS XX2TAR.FOR 
C     INPUT DATA TIME SERIES Z WITH NOB OBSERVATIONS IN COMMON /TSOBS/
C     COMPUTATION STARTS FROM OBSERVATION NM+1
                                                                        
      PARAMETER(MOB=5500, MP= 30, MP1= MP+1, MK= 10, nmx= 100, mlagh=36
     +, mk1 = mk + 1,  mnp = mk * mp1)
      IMPLICIT REAL*8(A - H , O - Z)
      CHARACTER*72  PNAME
      dimension  Y(mob), yhhy(mob), etilda(mob), RHO(mlagh), COV(mlagh)
     +,RES(MOB),E9(MK,MOB),fz(mob),fitx(mob),fity(mob),kkn(mob),kng(mob)
     +, PXA(MNP) , RXA(MK1), thdiff(mnp), par(mp1), PYY(MNP), RQUAD(MK)
     +, PHj(mk,mp1), SPHj(mk,mp1), ssvj(mk), ssqj(mk), nikj(mk)
     +,QTQ(MK,MLAGH),QTTQ(MLAGH),NDFPI(MK),CD2(MK),ntkj(mk),lhlag(mlagh)
      dimension   wphi(mp1), wphi2(mp1), WRK(MK1), WRK2(MK1)
     +, KONTOK(MK), wsssv(mk), wnnik(mk), WR2(MK), WR22(MK)
     +, wntik(mk), wmaenk(mk), wmaer(mk), wmaer2(mk)
     +, wd2(mk), wd22(mk), wcod2(mk)
     +, wq(mk, mlagh), wq2(mk, mlagh), wdf(mk, mlagh), wcoq(mk, mlagh)    
     +, wwq(mlagh), wwq2(mlagh), wwdf(mlagh), wwcoq(mlagh)    

C     k = no. of regimes, k1 = k-1 = no. of threshold constants r(.)
C
C             1                2               ...             k     
C     _________________|_________________|____ ...  ____|_______________
C                     r(1)              r(2)           r(k-1)
C      z(t-d) < r(1)    r(1)<=z(t-d)<r(2)               z(t-d) >= r(k-1)
C
C     icri = 1 Akaike's AIC criterion; icri = 2 Schwartz's BIC criterion
C  Akaike, H. (1974) A new look at the statistical model identification,
C     IEEE Trans. Automatic Control, AC-19, 716-723, 1974.
C  Schwartz, G. (1978) Estimating the dimension of a model, Ann.Statist.
C     6, 461-464, 1978.
C
C      icflag = -1 : mean subtracted (not recommended for TAR models)
C      icflag =  0 : no constant terms are estimated
C      icflag =  1 : a constant for each regime is estimated
C      ..... input model must include the constant, even if it is zero 

      COMMON/TSOBS/ NHB, Z(5500), KKHN(5500), ZO(5500), ZH(5500)
     +, NJ(10), XMAT(5500, 31), PHI(31), STDPHI(31), SSKP, SSV
     +, AUX1(31), VC1(31 , 31), BB(31), CC(31), IP(31), IQ(31)                                     
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)
     +, stdppa(10, 31), sssv(10), sssq(10), nnik(10)                                     
      COMMON /chost/ icflag, nm, xeta
	common /rand/  ix, iy,  iz
      data   tol , big / 8.43D-37 ,  3.37D+38/
      IMODEL =  4
      LPRINT  =  6

      OPEN(UNIT=5, FILE='xx2tar3.txt')
      READ(5,*)   NOB, NAC, ND, NK, NP, MSPAN, NM
      READ(5, *)  ISEVEN, CHC, ICRI, ICFLAG
      READ(5, *)  MCIT, NSCART, IMODEL, VARE, NREGP1, NOPXA
      READ(5, *) (RXA(I), I =1 , NREGP1)
      READ(5, *) (PXA(I), I =1 , NOPXA)
      READ(5 , *)   TOLER, ALPHA
      READ(5 , *) NHLAG
      READ(5, *) (LHLAG(I) , I =1 , NHLAG)
      READ(5, *)  (CD2(I) , I =1 , NK)
      READ(5, *)  iseed1, iseed2, ix, iy, iz
      read(5,*)   iprint
      read(5 , 470)      pname
470    format(A72) 
       close(unit  =  5)

       open(unit= LPRINT, file=pname)

       write(LPRINT  ,  200)  
200    format(1h  ,  'XX2TAR3.FOR (mainpgm) December 2002'
     +/1h ,'Estimate of 2-regimes TAR model - Setarma comparison')
      WRITE(LPRINT, 204) NOB, NAC, ND, NK, NP, MSPAN, NM
204   FORMAT(1H ,'NOB,NAC,ND,NK,NP,MSPAN,NM= '/1H  , 7I7)
       WRITE(LPRINT, 1275) ISEVEN, CHC, ICRI, ICFLAG
1275    FORMAT(1H  ,'ISEVEN,CHC,ICRI,ICFLAG', I2, F10.4, 2I2) 
      write(LPRINT, *)  'iseed1, iseed2, ix, iy, iz'
      write(LPRINT, 1276)  iseed1, iseed2, ix, iy, iz
1276  FORMAT(1H  ,5I10)
      write(LPRINT, *)  'MCIT, NSCART, IMODEL, VARE, NREGP1, NOPXA'
      write(LPRINT, 1277)  MCIT, NSCART, IMODEL, VARE, NREGP1, NOPXA
1277  FORMAT(1H   ,2I8, I3, F10.4, I4, I5)
      write(LPRINT, *) '(RXA(I), I =1 , NREGP1)'
      write(LPRINT, 1278) (RXA(I), I =1 , NREGP1)
1278  FORMAT(1H   ,10F7.4)
      write(LPRINT, *) '(PXA(I), I =1 , NOPXA)'
      write(LPRINT, 1279) (PXA(I), I =1 , NOPXA)
1279  FORMAT(1H   ,10F7.4)
      write(LPRINT, *) 'TOLER ', TOLER
      write(LPRINT, *) 'ALPHA ', ALPHA
      WRITE(LPRINT, *) NHLAG , ' lag test Q'
      WRITE(LPRINT, 1274) (LHLAG(I), I =1 , NHLAG)
1274  FORMAT(1H  ,10I7)
      WRITE(LPRINT, *) 'critical values test d2 for regime '
      WRITE(LPRINT, 1273) (CD2(I) , I =1 ,  NK)
1273  FORMAT(1H    ,   7F10.4)
       write(LPRINT , 274)  
274    format(1h , 'data printout file')
       write(LPRINT , 275)      pname
275    format(1h  ,  A72)
      write(lprint, 10027) iprint
10027 format(1h  ,'stampa serie originale e stimata iprint ', I6)
      WRITE(LPRINT, 309)
309   FORMAT(1H  ,'//')

      iseed1 =  531919
      iseed2 =  531977
c  iseed1 = prevprime(531971); iseed2 = nextprime(531971);       
	call set_uniform(iseed1, iseed2)

      NHB  =  NOB
      if(icflag.eq.1) then
      jch =  1
      else
      jch =  0
      endif
      NTP  =  NK  * (NP + jch)
      NK11 =  NK + 1
      NK12 = NK -1
      NM1  =  NM  +  1

C     main program main loop Monte Carlo iterations

      KITER = 0
      WSSVH =  0D0
      WSSVH2 =  0D0
      WSSQH  =  0D0
      WSSQH2  =  0D0
      do  6419  i  =1  ,  nk
      wsssv(i)  =  0D0 
      wnnik(i) =  0D0 
      WNTIK(I)  =  0D0
6419  WMAENK(I) =  0D0
      DO  415  I =1 ,  NTP
      WPHI(I) = 0D0
415   WPHI2(I)  = 0D0
      DO  417  I =1 ,  NK11
      WRK(I) = 0D0
417   WRK2(I)  = 0D0
      DO  413  I =1 ,  NK12
      WMAER(I)  = 0D0
      WMAER2(I)  =  0D0
413   KONTOK(I)  = 0D0
      WNK  =   0D0
      WNK2  =  0D0
      WNP = 0D0
      WNP2  =  0D0
      WSSQi  =  0D0
      WSSQi2  =  0D0
      WSSQ  =  0D0
      WSSQ2  =  0D0
      wsse =  0d0
      wsse2  =  0d0
      waic =  0d0
      waic2 = 0d0      
      DO  403  I = 1 ,  NK
      DO  403 J = 1 , NHLAG
      WQ(I , J)  =  0D0
      WQ2(I , J)  =  0D0
      WDF(I , J)  =  0D0
403   WCOQ(I , J)  =  0D0
      DO  404  J = 1 , NHLAG
      WWQ(J)  =  0D0
      WWQ2(J)  =  0D0
      WWDF(J)  =  0D0
404   WWCOQ(J)  =  0D0
      DO  409  I  =  1 , NK
      WD2(I)  =  0D0
      WD22(I)  =  0D0
      WCOD2(I)  =  0D0
      WR2(I)  =  0D0
409   WR22(I)  =  0D0
      WWD2  =  0D0
      WWD22  =  0D0
      difmin =  big

      DO  501  IREPL  =  1  ,  MCIT

      WRITE(*,*)   'repl.' ,  IREPL

c      write(6, 276)  IREPL
c276   format(1h  ,'Monte Carlo replication ', I5)

C     generate the random noise time series N(0 , VARE) for pseudo-
C     historical data Y 

      NTOT = NOB + NSCART
      NDR1 =  NOB - NM
      DO  401  I  =  1  ,  NTOT
402   PPX0 =  uniform()
      PPX1 =  PPND16(PPX0 , IZAULT)
      IF(IZAULT .NE. 0)  GOTO  402
401   ETILDA(I) =  PPX1 * DSQRT(VARE)   

       sse = 0D0
       nscar1 =  nscart +  NM  + 1
       do 1401 i = nscar1, ntot
1401   sse  =  sse  +  etilda(i) ** 2
       sse  =  sse/ dble(NDR1)

c       write(lprint, 90) (etilda(i), i=1, ntot)
c90     format(1h   , 10F7.4)
c       write(lprint, 91)  NDR1, sse, vare
c91     format(1h  ,'Error variance ndr, sse, vare = ',I10,2D12.4) 

C   k - regimes threshold autoregressive model TAR(nd,nnp(1)..nnp(k))
C      r(1) =  min(Y(1)..Y(nob))
C   Y(t)=ppa(1,1)+ppa(1,2)Y(t-1)+...ppa(1,nnp(1)+1)Y(t-nnp(1))+etilda(t)
C      Y(t-nd) <= r(2)
C   Y(t)=ppa(2,1)+ppa(2,2)Y(t-1)+...ppa(2,nnp(2)+1)Y(t-nnp(2))+etilda(t)
C    r(2)<Y(t-nd)<=r(3)
C      .............
C   Y(t)=ppa(k,1)+ppa(k,2)Y(t-1)+...ppa(k,nnp(k)+1)Y(t-nnp(k))+etilda(t)
C      Y(t-nd) > r(k)    
C      r(k + 1) = max(Y(1)..Y(nob))

      k =  nregp1 - 1
      k1  =  k + 1
      do  99991  i = 1 ,  k1
99991     r(i) = rxa(i)
      npxx =  nopxa / k - 1
      do  99992  j =  1  ,  k
99992     nnp(j)   =   npxx
      i1=0
      do  99995 i  =  1  ,  k
      nkp1  =  nnp(i) + 1 
      do  99994  j  =  1  ,  nkp1
      i1  =  i1  +  1
99994     ppa(i, j)  = pxa(i1)
99995      continue

      do  14171  i  =1  ,  nm
14171  Y(i)  =  etilda(i)

C   The k-regimes TAR generates the z values time series after t = NM+1 

      DO  6400 I  =  NM1  ,  NTOT

C       regime choice depends on x(t - nd)

        jj =  i - nd
        km1  =   k - 1
       do 411 iiii =  1 ,  km1
       if(Y(jj) .le. r(iiii + 1)) goto  414
411    continue
       iiii  =  k
414     continue
       nkp  =  nnp(iiii)
       nkp1  =  nnp(iiii) + 1
       do  6412  j =1  ,  nkp1
6412    par(j)  =  ppa(iiii ,  j)
      Y(I) =  ETILDA(I) +  par(1)
      DO  4101  J  =  1  ,  nkp
      IF(J .GE. I)  GOTO  4101
      j1  =  j + 1
      Y(I) =  Y(I) + PAR(J1) * Y(I - J)
4101   CONTINUE
6400   CONTINUE

C       discard the first nscart pseudo-historical data

      DO  38729  I  =  1  ,  NOB
38729 Y(I)  =   Y(I + NSCART)
      do  38728  i = 1 ,  nob
38728 Z(i)  =  Y(i)

c       Preliminary statistics computation

       dhm = 0D0
      ssql  =  0D0
      nm1 = nm + 1
      do  510  i = nm1 , nob
      dhm = dhm + z(i)
510   ssql = ssql + z(i) * z(i)
      dhm  =  dhm / dble(nob - nm)
	vhv  = ssql / dble(nob - nm) - dhm * dhm
      SSQL  =  vhv * dble(nob - nm)

C       descriptive statistics -> observations in ascending order

      IK  =  0
      do  38727  I  = NM1 , NOB
      IK =  IK + 1
38727 Yhhy(IK) =  Y(I)
      NDR = NOB -  NM
      CALL  ZCOR(Yhhy, NDR, NAC, RHO, COV, DM, DSD, IEXIT)
      if(icflag.eq.-1) CALL SMEADL(Y,Nob,dm)                                      
       DO  33881 I  = 1  ,  NOB
33881  FZ(I)  =  Y(I)
        CALL GRADU(FZ,FITX,FITY,KKN,KNG,NOB)
c        NBEST  =   KNG(N)
c        FBEST   =   FZ(NBEST)
c        NWOST  =  KNG(1)
c        FWOST  =   FZ(NWOST)
       DO  33888 I  = 1  ,  NOB
33888  KKHN(I)  =  KNG(I)
       r(1)  =   fity(1)
       r(k1)  =  fity(nob)

c      WRITE(LPRINT,  187) IEXIT
c187   FORMAT(1H ,'Time series Y statistics ZCOR : IEXIT ', I5)
c      write(LPRINT, 207) dm, cov(1), dsd 
c207   format(1h  ,'Input data mean, var, sqm =', 3D12.4)
c      write(LPRINT, 208) 
c208   format(1h ,'Autocorrelation function')
       nac1  =  nac +  1
c      write(LPRINT, 203) (rho(j), j=1, nac1)
c203    format(1h  , 7f10.4)
      nmedn =  nob / 2
c      write(lprint, 220) 
c220   format(1h  ,'time series minimum, median, maximum')
c      write(lprint,  221)  fity(1), fity(nmedn), fity(nob) 
c221    format(1h   ,3F16.4)
c      write(lprint, 218) 
c218   format(1h  ,'time series values, ordered values, kkn, kkg')
c       do  72881  i  =1  ,  nob
c72881 write(lprint, 219) i, fz(i), fity(i), kkn(i), kng(i)
c219    format(1h   ,I10, 2F12.4, 2I10)
c      write(LPRINT, 608) 
c608   format(1h ,'Labels vector of observations in increasing ord KKHN')
c      write(LPRINT, 603) (kkhn(j), j=1, nob)
c603    format(1h  , 10I7)
c      write(lprint, 129) 
c129    format(1h    ,'//'  )

C    2-REGIMES THRESHOLD AUTOREGRESSIVE MODEL (d, p1, ..., pk) ESTIMATE
C    ALL TIME SERIES DATA BETWEEN THE FIRST AND THIRD QUARTILE ARE TRIED 

      K =  NK
      CRITER  =  BIG
      JQ1 = MIN0(MAX0(1, NOB/4), NOB)
      JQ2 = MIN0(MAX0(1, 3*NOB/4), NOB)

      DO  711  ITHRE  =  JQ1, JQ2

      THREH1 = FITY(ITHRE)
       
c       write(lprint, 12994) dm,chc,ithre,iseven,dsd
c12994 format(1h    , 'dm,chc,ithre,iseven,dsd,threh1 '/
c     + 1h    ,2F10.4, 2i8, 2f10.4)

       if(threh1 .le.  r(1) .or.  threh1  .ge.  r(k+1))  goto  711

C       regime 1, Y(t - d) < R(1) :: regime 2, Y(t - d) > R(1)

      CRKI =  0D0

      DO  714  IJREG = 1 , k

c      write(lprint , 119)  IJREG, np, threh1, nd, nm, nm1, nob
c119   format(1h ,'regime,np,threh1,nd,nm,nm1,nob '/1h ,2I6, F10.4, 4i8)

      IF(IJREG  .EQ. 1)  THEN
      II  =  0
      DO  712  J =  NM1, NOB
      IF(Y(J - ND) .LE. threh1)  THEN
      II  =  II + 1
      ZO(II) = Y(J)
      IHCI  = 0
      IF(ICFLAG .EQ. 1) THEN
      IHCI =  IHCI  + 1
      XMAT(II , IHCI) =  1D0
      ENDIF
      DO   713  LAGHH  =  1 , NP
      IHCI =  IHCI  + 1
713   XMAT(II , IHCI) =  Y(J - LAGHH)
      ENDIF
712   CONTINUE
      ELSE
      II  =  0
      DO  715  J =  NM1, NOB
      IF(Y(J - ND) .GT. threh1)  THEN
      II  =  II + 1
      ZO(II) = Y(J)
      IHCI  = 0
      IF(ICFLAG .EQ. 1) THEN
      IHCI =  IHCI  + 1
      XMAT(II , IHCI) =  1D0
      ENDIF
      DO   716  LAGHH  =  1 , NP
      IHCI =  IHCI  + 1
716   XMAT(II , IHCI) =  Y(J - LAGHH)
      ENDIF
715   CONTINUE
       ENDIF

      NZZB  =  II
      NHPI =  IHCI
      CALL REGRES(ZO, XMAT, 5500, NZZB, PHI, NHPI, AUX1, VC1, 31, BB, CC
     +, IP, IQ, TOL, MSING)
      IF(MSING  .EQ.  2)  THEN
      IFAULT  =  -1
      GOTO  711
      ENDIF

      dhm = RMEAN(zo, NZZB)
      ssv  =  0D0
      sskp =  0D0
      do  9  jj =  1  ,  NZZB
      ssv  =  ssv + (zo(jj) - dhm) * (zo(jj) - dhm)
      zo1 =  0D0
      do  10  ij  =  1 , NHPI
10    zo1 = zo1 +  phi(ij) * xmat(jj, ij)
      RES(JJ) =  ZO(JJ) -  ZO1
9      sskp =  sskp + (zo(jj) -  zo1) * (zo(jj) - zo1)
      hsigma =  dsqrt(dabs(sskp / dble(NZZB)))
      do  12  ij =  1  , NHPI
12    stdphi(ij) = hsigma * dsqrt(dabs(VC1(ij , ij))) 
      if(icri  .eq.  1)  then
      CRKI  =
     +CRKI +  dble(NZZB) *dlog(sskp / dble(NZZB)) + dble(NHPI) * 2D0 
      else
      CRKI  =
     +CRKI+dble(NZZB)*dlog(sskp/dble(NZZB))+ dble(NHPI)*dlog(dble(NZZB))
      endif      

c      write(lprint,  77117)
c77117 format(1h    ,'parameter estimates (line 1) and stder (line 2)')
c      write(lprint, 117) (phi(jj),  jj=1 , NHPI)
c      write(lprint, 117) (stdphi(jj),  jj=1 , NHPI)
c117 	format(1h  ,7F10.4)
c      write(lprint, 116) nzzb,sskp, ssv, icri, crki
c116   format(1h  ,'nzzb,sskp,ssv,icri,crki ', I8, 2D14.6, i2, D14.6)      

      do 6898 jj =  1 , nzzb
6898  E9(ijreg , JJ) =  res(jj)
      do  717  jj  =  1  ,  NHPI
      PHj(ijreg, jj)  =  phi(jj)       
717   SPHj(ijreg, jj)  =  stdphi(jj)       
      ssqj(ijreg) =  sskp
	ssvj(ijreg) =  ssv
      nikj(ijreg)  =  NZZB

714    CONTINUE

c      write(lprint, 129) 

      if(crki .lt. criter)  then
      criter  =   crki
      r(k)  = threh1 
      DO  6719  II =  1 ,  k
      nnp(ii)  =  NP
      DO  8  JJ  =  1  ,  NHPI
8     PPA(II,  JJ)  =  PHj(ii, jj)
      DO  13  JJ  =  1  ,  NHPI
13    STDPPA(II,  JJ)  =  SPHj(ii, jj)
      sssq(ii) =  ssqj(ii)
      sssv(ii) =  ssvj(ii)
      nnik(ii)  =  nikj(ii)
6719   continue
      do  5585   ii  = 1 ,  nk
      do 69998 jj =  1 , nzzb
69998  res(jj)  = E9(ii , JJ) 
      CALL ZCOR(RES,NZZB,NAC,RHO,COV,DM,DSD,IEXIT)                     
      DO  5522  I  =1 , NHLAG
      MHHQ  =  LHLAG(I) 
c       write(*,*) qtest(rho,mhhq,nob)
c       pause
      QTQ(ii, I)  =  QTEST(RHO,MHHQ,nzzb) 
5522  CONTINUE
      NDFPI(ii)  = NHPI 
5585  continue
      endif

711    continue

c      do  55555   iiii=1,k
c      write(*,*)  ndfpi(iiii)
c55555 write(*,*) (qtq(iiii,jjjj), jjjj =1,nhlag)
c      pause
c      WRITE(LPRINT , 300) 
c300   FORMAT(1H  ,'EXIT LOOP : PARAMETER ESTIMATES ')
c      write(lprint, 113)  k
c113   format(1h   ,'No. of regimes k = ', I5)

       i2  =  0
      do  909  ii  =  1  ,  k
      nnp1 = nnp(ii)  +  jch
       i1  =  i2   +  1
       i2  =  i2  + nnik(ii)
       ik  =  0
       do  9010  i  =  i1 ,  i2
       j  = kkhn(i)  +  nd
       if(j .le.  nm  .or.  j .gt.  nob)  goto  9010
       ik =  ik  +  1
9010     continue
      varhe = sssq(ii)/float(ik)
      rquad(II) =  1D0 - sssq(ii) / sssv(ii)

c      write(lprint, 110) ii,r(ii),r(ii+1),nnp(ii),varhe,rquad(II),ik
c110   format(1h   ,'ii,r,p,s2,R2,obs. ', I5, 2F7.4, I5, D12.4, F7.4, I8)
c      write(lprint, 111) (ppa(ii, jj),  jj=1 , nnp1)
c      write(lprint, 111) (stdppa(ii, jj),  jj=1 , nnp1)
c111 	format(1h  ,7F10.4)

       i1  =  i2 + 1
909     continue

c       write(lprint, 67188)  R(K)
c67188  format(1h   ,F20.4)

	II  =  0
      DO  407  I  = 1 ,  k
      nkp1  =  nnp(i) + JCH
      DO  408  J =1  , nkp1
      II =  II + 1
      PYY(II)  =  PPA(I , J)
408   CONTINUE
407   CONTINUE

C      IF(ICFLAG  .EQ. 1) THEN
c      write(lprint,  1025)
c1025  format(1h   ,'Model param.s PYY -> zero constant is added')
c      write(lprint, 1024) (pyy(i), i= 1 , ntp)
c1024  format(1h   ,10F7.4)
c      else
c      write(lprint,  1026)
c1026  format(1h   ,'Model param.s PYY -> model constant is omitted')
c      write(lprint, 1027) (pyy(i), i= 1 , ntp)
c1027  format(1h   ,10F7.4)
c      ENDIF

      sskp  =  0D0
      ssv  =  0D0
      ndr  =  0
      do   719  ii  =1  ,  k
      sskp  =  sskp + sssq(ii) 
      ssv =  ssv + sssv(ii) 
      ndr = ndr  +  nnik(ii)  
719   continue

c      WRITE(LPRINT,  328)  ndr
c328   FORMAT(1H  ,'EFFECTIVE N. OBSERVATIONS NDR = ', I10)
c      WRITE(LPRINT,  308)  SSV
c308   FORMAT(1H  ,'OBSERVATIONS SUM OF SQUARES SSV = ', D14.6)
       totvar =  SSV / dble(ndr)
      OBSVAR = SSQL / DBLE(NOB - NM)
c      WRITE(LPRINT,  335) OBSVAR, totvar 
c335   FORMAT(1H  ,'Series variance (zcor,regres) = ', 2D14.6)
c      WRITE(LPRINT,  304)  SSKP
c304   FORMAT(1H  ,'RESIDUAL SUM OF SQUARES SSKP = ', D14.6)
      resvar = SSKP / dble(ndr) 
c      WRITE(LPRINT,  305) resvar 
c305   FORMAT(1H  ,'RESIDUAL variance = ', D14.6)

      if(icri  .eq.  1)  then
      py  =  dble(ntp) * 2D0 
      crh = dble(ndr) * dlog(dabs(resvar)) + dble(ntp) * 2D0 
      else
      py =  dble(ntp) * dlog(dble(ndr))  
      crh = dble(ndr)*dlog(dabs(resvar))+dble(ntp)*dlog(dble(ndr))  
      endif
      xlns = 	dlog(dabs(resvar))
c      write(lprint, 307)  xlns, py, crh
c307   format(1h  ,'Ln(sigma2) = ', D14.6, 5x, 'Penalty = ', D14.6
c     +/1h   ,'Criterion = ', D14.6)
       rr2 =  1.0 -  SSKP / SSV
c      write(lprint,  62711) rr2
c62711 format(1h  ,'R2 = ', F10.6)

C       if(iprint  .eq.  1)  then
C      write(lprint, 40117) 
C40117 format(1h  ,'original data , fitted values')
C      do  49117  i  =  1  ,  nob
C49117 write(lprint, 49118)  y(i), vfit(i)
C49118 format(2F20.10)
C       endif

C      JJ =  0
C      DO  5531 II  = 1 ,  K
C      NZZB  =  nnik(II) 
C      DO  5532  J  = 1, NZZB
C      JJ =  JJ + 1
C5532  RES(JJ)  =  E9(II , J)
C5531  CONTINUE
C      NZZB  = JJ
      
      K1  =  K -  1
C      WRITE(*,*) 'K1 ' , K1
C      DO 99877 IIII =  1 , K
C99877 WRITE(*,*) ( PPA(IIII, JJJJ), JJJJ=1,NKP1)
      CALL  RESID(Y, NOB, PAR, NKP1, RES, YHHY, SHSQ, IEXIT, IMODEL)
C      WRITE(*,*) 'Y,YHHY,RES'
C      DO 99888 IIII =1 , NOB
C      WRITE(*,*) Y(IIII), YHHY(IIII), RES(IIII)
C      PAUSE
C99888 CONTINUE
      NZZB  =  NOB - NM
C      WRITE(*,*) SHSQ/DBLE(NZZB)
C      PAUSE
      CALL ZCOR(RES,NZZB,NAC,RHO,COV,DM,DSD,IEXIT)                     
      DO  5533  I  =1 , NHLAG
      MHHQ  =  LHLAG(I) 
      QTTQ(I)  =  QTEST(RHO, MHHQ, NZZB) 
5533  CONTINUE

c      WRITE(LPRINT, 309)

C   MONTE CARLO STATISTICS

      KITER =  KITER + 1
      do  6177  ii  =  1 , K  
      wsssv(ii) =  wsssv(ii)  + sssq(ii) / dble(nnik(ii))
6177  wnnik(ii)  =  wnnik(ii) + nnik(ii) 
      WSSVH  =  WSSVH + obsVAR
      WSSVH2  =  WSSVH2 + obsVAR * obsVAR
      WSSQH  =  WSSQH  + RESVAR
      WSSQH2  =  WSSQH2 +  RESVAR * RESVAR
      DO  405  I =1 ,  NTP
      WPHI(I) = WPHI(I) + PYY(I)
405   WPHI2(I)  = WPHI2(I) + PYY(I) * PYY(I)
      DO  416  I =1 ,  NK11
      WRK(I) = WRK(I) +  R(I)
416   WRK2(I)  = WRK2(I) + R(I) * R(I)
      DO 44416  II =  1 , K
44416 NTKJ(II)  =  0
      II  =  1
      DO  44417  J  =  NM1 , NOB
      IF(Y(J - ND) .LE. RXA(II + 1)) THEN
      NTKJ(II)  = NTKJ(II) +  1
      ELSE
      NTKJ(II + 1)  = NTKJ(II + 1) +  1      
      ENDIF
44417 CONTINUE
      DO  44418  II =  1 ,  NK
      WNTIK(II) =  WNTIK(II) + DBLE(NTKJ(II))
44418 WMAENK(II) = WMAENK(II) + DABS(DBLE(NTKJ(II) - NNIK(II)))
      DO  412  I =1 ,  NK12
      WMAER(I) = WMAER(I) + DABS(R(I+1)-RXA(I+1))
      WMAER2(I) = WMAER2(I) + (R(I+1)-RXA(I+1)) ** 2
      IF(DABS(R(I+1)-RXA(I+1)) .LT. TOLER) KONTOK(I) = KONTOK(I) + 1
412   CONTINUE
      WNK  =   WNK  +  DBLE(K)
      WNK2  =  WNK2  +  DBLE(K) * DBLE(K)
      WNP =  WNP + DBLE(NP)
      WNP2  =  WNP2 + DBLE(NP) * DBLE(NP)
      WSSQi  =  WSSQi  + TOTVAR 
      WSSQi2  =  WSSQi2  + TOTVAR * TOTVAR
      WSSQ  =  WSSQ  + RESVAR 
      WSSQ2  =  WSSQ2  + RESVAR * RESVAR
      WSSe  =  WSSe  + SSE 
      WSSe2  =  WSSe2  + SSE * SSE
      DO  410  I  =1  , NK
      WR2(I)  =  WR2(I) +  RQUAD(I)
410   WR22(I) =  WR22(I) + RQUAD(I) * RQUAD(I)
      waic =  waic +  crh
      waic2 =  waic2 +  crh * crh
      DO  5523  I  = 1 ,  NHLAG
      MHHQ  =  LHlag(I) 
      DO  5525   II =  1 ,  K
      WQ(II , I) =  WQ(II , I) + QTQ(II, I)
      WQ2(II , I) =  WQ2(II , I) + QTQ(II, I) ** 2
      HHNI =  DBLE(MHHQ - NDFPI(II))
      WDF(II, I) = WDF(II, I) + HHNI
      IF(HHNI .GT. 0.0) THEN
      HHNI2 =  HHNI / 2D0
      GGGG  =  ALOGAM(HHNI2, IFAUL2)
      PPOINT  =  1D0 -  ALPHA
      PVALUE =  PPCHI2(PPOINT, HHNI, GGGG, IFAULT)
      IF(QTQ(II, I) .GT. PVALUE) WCOQ(II, I) = WCOQ(II ,I) + 1
      ENDIF
5525  CONTINUE
5523  CONTINUE
      NHDFPI =  1
      DO  5545  II = 1 ,  K
      IF(NDFPI(II) .GT. NHDFPI) NHDFPI = NDFPI(II)
5545  CONTINUE
      DO  5543  I  = 1 ,  NHLAG
      MHHQ  =  LHlag(I) 
      WWQ(I) =  WWQ(I) + QTTQ(I)
      WWQ2(I) =  WWQ2(I) + QTTQ(I) ** 2
      HHNI =  DBLE(MHHQ - NHDFPI)
      WWDF(I) = WWDF(I) + HHNI
      IF(HHNI .GT. 0.0) THEN
      HHNI2 =  HHNI / 2D0
      GGGG  =  ALOGAM(HHNI2, IFAUL2)
      PPOINT  =  1D0 -  ALPHA
      PVALUE =  PPCHI2(PPOINT, HHNI, GGGG, IFAULT)
      IF(QTTQ(I) .GT. PVALUE) WWCOQ(I) = WWCOQ(I) + 1
      ENDIF
5543  CONTINUE
      difxe = 0d0
      IF(ICFLAG .EQ.  1)  THEN
      do  6171 i =1  ,  NOPXA
6171  difxe = difxe + dabs(pxa(i) - pyy(i))
      IHCI  =  0
      DO 6176  II =  1 ,  NK
      D2  =  0D0
      NKP1  =  NP +  1
      DO  6175 I =1  ,  NKP1
      IHCI  =  IHCI + 1
6175  D2 = D2 + (pxa(IHCI) - pyy(IHCI)) ** 2
      IF(D2 .GT. CD2(II)/DBLE(NTKJ(II))) WCOD2(II) = WCOD2(II) + 1
      WD2(II) =  WD2(II) +  D2
      WD22(II) =  WD22(II) +  D2 * D2
6176  CONTINUE
      ELSE
      IHCI = 0
      IKCI = 0
      DO  6172  II  =1  , NK
      D2  =  0D0
      IKCI  = IKCI +  1
      difxe = difxe + dabs(pxa(IKCI))
      DO 6173  J  =  1 ,  NP
      IHCI  = IHCI +  1
      IKCI  = IKCI +  1
      difxe = difxe + dabs(pxa(IKCI) - pyy(IHCI))
6173  D2 = D2 + (pxa(IKCI) - pyy(IHCI)) ** 2
      IF(D2 .GT. CD2(II)/DBLE(NTKJ(II))) WCOD2(II) = WCOD2(II) + 1
      WD2(II) =  WD2(II) +  D2
      WD22(II) =  WD22(II) +  D2 * D2
6172  CONTINUE
      ENDIF
      if(difxe.lt.difmin ) then
       difmin = difxe
      ixrepl = irepl
      endif

c      WRITE(LPRINT, 22222) IREPL, IX, IY , IZ
c22222 FORMAT(1H  ,'Repl. ', I10, 4X, 'ix,iy,iz',  3I10)

501   continue

      IF(KITER  .GT.  0)  THEN

      WSSVH = WSSVH / DBLE(KITER)
      WSSVH2 =  DSQRT(DABS(WSSVH2/DBLE(KITER) - WSSVH**2))
      WSSQH = WSSQH / DBLE(KITER)
      WSSQH2 =  DSQRT(DABS(WSSQH2/DBLE(KITER) - WSSQH**2))
      DO  425  I =1 ,  NTP
      WPHI(I) = WPHI(I) / DBLE(KITER)
425   WPHI2(I)  = DSQRT(DABS(WPHI2(I)/DBLE(KITER) - WPHI(I)**2))
      DO  426  I =1 ,  NK11
      WRK(I) = WRK(I) / DBLE(KITER)
426   WRK2(I)  = DSQRT(DABS(WRK2(I)/DBLE(KITER) - WRK(I)**2))
      DO  428  I =1 ,  NK12
      WMAER(I) = WMAER(I) / DBLE(KITER)
428   WMAER2(I)  = DSQRT(DABS(WMAER2(I)/DBLE(KITER) - WMAER(I)**2))
      do  6420  i  =1  , NK
      Wd2(i)  =  Wd2(i) / DBLE(KITER) 
      Wd22(i)  =  DSQRT(DABS(Wd22(i)/DBLE(KITER) - Wd2(i)**2))
      WR2(I) = WR2(I) / DBLE(KITER)
      WR22(I)  = DSQRT(DABS(WR22(I)/DBLE(KITER) - WR2(I)**2))
      wsssv(i)  =  wsssv(i) / DBLE(KITER) 
      wnnik(i) =  wnnik(i) / DBLE(KITER) 
      WNTIK(I)  =  WNTIK(I) / DBLE(KITER)
6420  WMAENK(I) =  WMAENK(I) / DBLE(KITER)
      DO  427  I  = 1 , NHLAG
      WWDF(I)  = WWDF(I) / DBLE(KITER)
      WWQ(I) =  WWQ(I) / DBLE(KITER) 
      WWQ2(I) =  DSQRT(DABS(WWQ2(I) / DBLE(KITER) - WWQ(I) ** 2)) 
      DO  424  II  = 1 ,  NK
      WDF(II, I)  = WDF(II, I) / DBLE(KITER)
      WQ(II, I) =  WQ(II, I) / DBLE(KITER) 
424   WQ2(II, I) = DSQRT(DABS(WQ2(II, I) / DBLE(KITER) - WQ(II, I)** 2)) 
427   CONTINUE
      WNK = WNK / DBLE(KITER)
      WNK2 =  DSQRT(DABS(WNK2/DBLE(KITER) - WNK**2))
      WNP = WNP / DBLE(KITER)
      WNP2 =  DSQRT(DABS(WNP2/DBLE(KITER) - WNP**2))
      WSSQi  =  WSSQi / DBLE(KITER)
      WSSQi2  =  DSQRT(DABS(WSSQi2/DBLE(KITER) - WSSQi**2))
      WSSQ  =  WSSQ / DBLE(KITER)
      WSSQ2  =  DSQRT(DABS(WSSQ2/DBLE(KITER) - WSSQ**2))
      WSSe  =  WSSe / DBLE(KITER)
      WSSe2  =  DSQRT(DABS(WSSe2/DBLE(KITER) - WSSe**2))
      Waic  =  Waic / DBLE(KITER) 
      Waic2  =  DSQRT(DABS(Waic2/DBLE(KITER) - Waic**2))

      WRITE(LPRINT, 17127) KITER, K, NP
17127 FORMAT(1H  ,'Valid repl.', I8, 4X, 'k,p = ', 2I8)
      WRITE(LPRINT, 18118) TOLER 
18118 FORMAT(1H   ,'Correct threshold : +-', F10.4, ' from true')
      WRITE(LPRINT, 18119) (KONTOK(I), I =1  , NK12)
18119 FORMAT(1H  ,17I4) 
      WRITE(LPRINT, 40051) 
40051 FORMAT(1H   ,'threshold MAE (mean abs err) mean, se')
      DO  438  I  =1 ,  NK12
438   WRITE(LPRINT, 40052) WMAER(I), WMAER2(I)
40052 FORMAT(1H  ,2F30.6)
      write(lprint, 40041)
40041 format(1H   ,'total variance, residual variance (mean,se)')
      WRITE(LPRINT, 40100) WSSVH, WSSVH2
      WRITE(LPRINT, 40100) WSSQH, WSSQH2
40100 format(1h  , 2F30.6)
      WRITE(LPRINT, 40151) 
40151 FORMAT(1H , 'estimated parameters phi (mean,se)')
      DO  435  I =1 ,  NTP
435   WRITE(LPRINT, 40100) WPHI(I), WPHI2(I)
      WRITE(LPRINT, 40161) 
40161 FORMAT(1H , 'regimes thresholds (mean,se)')
      DO  436  I =1 ,  NK11
436   WRITE(LPRINT, 40100) WRK(I), WRK2(I)
      WRITE(LPRINT, 47040)
47040 FORMAT(1H  ,'number of regimes, AR order (mean,se)') 
      WRITE(LPRINT, 40100) WNK, WNK2
      WRITE(LPRINT, 40100) WNP, WNP2
      write(lprint, 47651)
47651  format(1h  ,'n. obs : MAE, true, estim. per regime ')
      do  66421  i  =1  , K
66421 write(lprint, 66624) i, wmaenk(i), wntik(i), wnnik(i)
66624 format(1h  , I5, 3F12.0) 
      write(lprint, 47051)
47051  format(1h  ,'variance and R2 (m,se) per regime ')
      do  6421  i  =1  , K
6421  write(lprint, 66124) i, wsssv(i), wr2(i), wr22(i)
66124 format(1h  , I5, 3F12.4) 
      DO  65528 II = 1 ,  NK
      WRITE(LPRINT, 66500) II
66500 FORMAT(1H   ,'regime ', I5, 5X, 'Lag, df, Q (m,se), n.reject')
      DO  65527  IIII =  1  ,  NHlag
      MHHQ  =  LHlag(IIII)
      WRITE(LPRINT,61718) MHHQ,WDF(II,IIII),WQ(II,IIII),WQ2(II,IIII)
     +, WCOQ(II,IIII)
61718 FORMAT(1H  ,I5, F10.0, 2F12.4, F10.0)
65527 CONTINUE      
65528 CONTINUE      
      WRITE(LPRINT, 66600) 
66600 FORMAT(1H   ,'ALL residuals: Lag, df, Q (m,se), n.reject')
      DO  66527  IIII =  1  ,  NHlag
      MHHQ  =  LHlag(IIII)
      WRITE(LPRINT,6271)MHHQ,WWDF(IIII),WWQ(IIII),WWQ2(IIII),WWCOQ(IIII)
6271  FORMAT(1H  ,I5, F10.0, 2F12.4, F10.0)
66527 CONTINUE      
      WRITE(LPRINT, 40116)
40116 FORMAT(1H  ,'Squared autoregressive distance ')
      DO  66628 II = 1 ,  NK
      WRITE(LPRINT, 66700)
66700 FORMAT(1H   ,'regime , D2 (m,se), n.reject')
      WRITE(LPRINT,67718)  II,WD2(II),WD22(II),WCOD2(II)
67718 FORMAT(1H  ,I5, 2F12.4, F10.0)
66628 CONTINUE      
      write(lprint, 48041)
48041 format(1H   ,'time series var, residual var, error var (mean,se)')
      WRITE(LPRINT, 40100) WSSQi, WSSQi2
      WRITE(LPRINT, 40100) WSSQ, WSSQ2
      WRITE(LPRINT, 40100) WSSe, WSSe2
      IF(ICFLAG  .EQ.  1)  THEN
      do  40717  i  = 1 , NOPXA
40717 thdiff(i) =  pxa(i) - wphi(i)
      ELSE
      I  =  0
      IHCI = 0
      IKCI = 0
      DO  40172  II  =1  , NK
      I  =  I  + 1
	IKCI  = IKCI +  1
      THDIFF(I)  =  pxa(IKCI)
      DO 40173  J  =  1 ,  NP
      I  =  I +  1
      IHCI  = IHCI +  1
      IKCI  = IKCI +  1
      THDIFF(I)  =   pxa(IKCI) - WPHI(IHCI)
40173 CONTINUE
40172 CONTINUE
      ENDIF
      difeas  =  1D2 * dotprd(NOPXA, thdiff,  thdiff)
      WRITE(LPRINT, 40114)
40114 FORMAT(1H  ,'100 * Sum(true.param-average_estim.param)^2')
      WRITE(LPRINT, 40100) difeas
      WRITE(LPRINT, 40115)  DIFMIN, IXREPL
40115 FORMAT(1H  ,'Param. min. MAE ', F10.4, 5X, 'repl. ', I8)
       ENDIF

      CLOSE(UNIT=LPRINT)
      STOP
      END


      SUBROUTINE GATAR(no, nn, nmx, nl, nob, nchro, lbest, lchro1,lchro2
     +, lchrom, nnhp, fbest, ssq, p2, p1, maxit, nk, mspan, nhd, iter2
     +, iseme, lprint, iexit)
      IMPLICIT REAL*8(A - H , O - Z)
      dimension  NO(nmx, nchro), NN(nmx, nchro), lbest(nchro)
     +,lchrom(nchro), lchro1(nchro), lchro2(nchro), nnhp(nk)
     +, FITCUM(nl), FITN(nl)
      data  zero /0.0D-000/
	data small , big / 8.43D-37, 3.37D+38/
        data  tol  /8.43D-37/ 

C       Initializations

       DO 99399   I   =   1  ,  NL
       DO 99399    J   =    1  ,   NCHRO
       NO(I   ,   J)   =  0
99399     NN(I  ,   J)  =   0
        DO 99398  I  =   1  ,  NCHRO
99398   LBEST(I)   =   0
        DO 99397  I  =   1  ,  NCHRO
        lchro1(I)   =   0
99397     lchro2(I)   =   0
       DO 99396  I  =  1,  NL
        FITCUM(I)= zero
99396    FITN(I)  =   zero

C       Initial population, no more than nk one's are allowed, zeroes
C       must be in genes 1..nq1 and nob-nq1+1..nob

       nq1 = nhd
        do  33441 i=1  ,  nk
       if(nnhp(i). gt. nq1) nq1 =  nnhp(i)
33441     continue
        npd  =  nq1
        nk1  =  nk - 1
        do  33442  i  =1  ,  nl
        call  vsunif(iseme, ris)
      nk2 =  max0(1, min0(nk1, idnint(-5D-1 + ris * (dble(nk1) + 1D0)))) 
33449   continue
        DO 96997  II  =   1  ,  NCHRO
96997    no(i , ii)    =   0
      do  33443  j  =  1  ,  nk2
        call  vsunif(iseme, ris)
      ij = max0(npd + 1, min0(nob - npd
     +, idnint(dble(npd + 1) + ris*(dble(nob - npd) - dble(npd + 1)))))
33443  no(i , ij)  =   1
        DO 99997  II  =   1  ,  NCHRO
99997  lchrom(II)   =   no(i , ii)
c       write(*,*) (lchrom(ii), ii=1, nchro)
       call  gcheck(lchrom, nchro, npd, nk, mspan, ixflag)
c       write(*,*)  ixflag
c       pause
        if(ixflag .lt. 0)  goto  33449
33442  continue

c      cromosoma forzato 
c      do  33552 ii  =  1  ,  nchro
c33552 no(1 , ii)  =   0
c      cromosoma forzato per il file lintar.dat
c      no(1 ,  676)  =  1
c      cromosoma forzato per il file lintar4.dat
c      no(1 ,  100)  =  1
c      no(1 ,  239)  =  1
c      no(1 ,  390)  =  1
c
c      write(lprint, 190)
c190   format(1h  ,'Initial population')
c      do   33444 i  =1  ,  nl
c33444 write(lprint, 191) (no(i , j), j = 1 , nchro)  
c191   format(1h  ,70I1)

      fbest =  zero
      do 97  k  =  1,  nl
      do 98  i  =  1,  nchro
98    lchrom(i)    =   no(k  ,  i)
      fffit = FFB(lchrom, nchro, nk, lprint, ifault)
       IF(IFAULT .NE. 0) fffit  =  zero
       if(fffit.le.fbest)  goto  90
       fbest  =   fffit
	 nbest  =   k
90      continue
97      continue
	 do  91  i  =   1,  nchro
91      lbest(i)   =    no(nbest  ,  i)
	   fbest1  =   fbest

         if(maxit .le. 0)  return

C       Genetic algorithm loop

         iter  =  0
         iter2    =  0
c	 WRITE(*,*)  '     Iterazione ..... '
1234	  continue
         iter  =  iter + 1

c	WRITE(*,*)  ITER

C  calcolo della fitness function per ogni individuo, del tot e del max

	FBEST  =  zero
      fwost  =   big
	DO 2000 K = 1 , NL
	 do  2001  i  =  1,  nchro
2001     lchrom(i)   =   no(k , i)
      fffit = FFB(lchrom, nchro, nk, lprint, ifault)
	if (fffit.le.fbest) goto 2043
	fbest  =   fffit
	nbest  =    k
2043     continue
	if (fffit.ge.fwost) goto 2044
	fwost  =   fffit
	nwost  =    k
2044     continue
	FITN(K) = FFFIT
2000    CONTINUE

	  iter1  =  iter  -   1
      if(fbest-fbest1 .gt. tol) write(LPRINT,225) iter1, fbest1 , fbest
225     format(1h ,4x,i10,' : ',f12.5,' -> ',f12.5)
       if(fbest-fbest1 .gt. tol) iter2 =  iter1

C        Strategia elitista

      if(fbest1 .le. fbest)  then
       do  2002  i =1  ,  nchro
2002  lbest(i)  =  no(nbest , i)
       fbest1  =  fbest
      else
       do  2003  i =1  , nchro
2003  no(nwost , i)  =  lbest(i)
       fitn(nwost) =  fbest1
       nbest =  nwost
      fbest  =  fbest1
      endif

	  IF(ITER.gt.MAXIT) GOTO  2100

C   riproduzione della popolazione: SI USA LA TECNICA DELLA FITNESS
C   cumulata  CON M = N         P(t) ---> P*(t+1)

	FFTOT = zero
	DO 22000 K = 1 , NL
       FFFIT =  FITN(K)
	FFTOT = FFTOT + FFFIT
	 FITCUM(K)  =   FFTOT
22000    CONTINUE

          if(fftot .LT. SMALL)    then
          iexit  =  -1
          return
          endif

	  DO  22007  K =  1 ,  NL
22007  FITCUM(K)  =   FITCUM(K)/FFTOT
	  
c      IF(FBEST.GT.tol) THEN
c      ssq  =  1D0 / FBEST
c      ELSE
c      ssq  =  big
c      ENDIF
c      WRITE(LPRINT,  55593)  
c55593  FORMAT(1H  ,'Strategia elitista: best indiv., fitness, ssq ')
c	 WRITE(LPRINT,55500) NBEST, FBEST, ssq
c55500  format(1h  ,I10,  D14.6, D14.6) 
c       write(LPRINT , 5556)  (LBEST(I), I=1,nchro) 
c      WRITE(LPRINT,  55592)
c55592  format(1h   ,'Population ')
c       do 76011  k  =  1  ,   nl
c76011  write(lprint, 54557) (no(k ,  j),  j=1, nchro)
c54557   format(1h   ,70I1)

	DO 3000 K = 1 , NL
        CALL VSUNIF(ISEME, RIS)
       DO 3001  KS  =  1  ,   NL
       IF(RIS.LE.FITCUM(KS))  GOTO 3003
3001    CONTINUE
	 KS  =  NL
3003    DO 3100 I = 1 , nchro
3100    NN(k , i) = NO(ks , i)
3000    CONTINUE

	 DO 3010   K  =  1  ,  NL
	 DO 3010    I  =  1  ,  nchro
3010     NO(k , i)  =  NN(k , i)

c      WRITE(LPRINT,  55594)  
c55594  FORMAT(1H  ,'Riproduzione ')
c       do 76012  k  =  1  ,   nl
c76012  write(lprint, 54557) (no(k , j),  j=1, nchro)

C    calcolo del crossover su una proporz. pari a p2 degli n individui
C     = n*p2 individui ovvero n*p2/2 coppie     P*(t+1) ---> P**(t+1)
c    due diversi cromosomi sono scelti a caso e ricombinati a partire
c     dal punto di taglio aleatorio ltag+1 e fino a ngeni
C     L'intero LTAG e' il piu' vicino a 
c      (1 - 1/2) + (NGENI - 1/2 - 1 + 1/2) * RND(IX,IY,IZ)
C  Nearest integer (Round to integer)= NINT(x) (Arg REAL, Funct INTEGER)

      ncrott  =  idint(p2 * dble(nl) / 2D0)

      DO     30     J  =   1    ,   ncrott

        CALL VSUNIF(ISEME, RIS)
       k1  =  MAX0(1, MIN0(NL, IDnint(5D-1   +   ris * DBLE(nl)))) 
        CALL VSUNIF(ISEME, RIS)
       k2 = MOD(IDNINT(5D-1 + ris*DBLE(nl-1)) + k1 -1, nl) + 1 
        CALL VSUNIF(ISEME, RIS)
      ltag = MAX0(1, MIN0(nchro-1, IDNINT(5D-1 + ris * DBLE(nchro- 1)))) 
	 ltagp1 = ltag +  1

      do  3004  i =1  , nchro
      lchro1(i)  =  no(k1 , i)
3004   lchro2(i) =  no(k2 , i)

c      write(lprint, 54557) (no(k1 , jjjj),  jjjj=1, nchro)
c      write(lprint, 54557) (no(k2 , jjjj),  jjjj=1, nchro)

       DO 55 I = LTAGP1 , nchro
       JGENE = lchro1(i)
       lchro1(i) = lchro2(i)
       lchro2(i)  =  JGENE
55      CONTINUE

C       check if every regime contains mspan observations at least

       call  gcheck(lchro1, nchro, npd, nk, mspan, ixfla1)
       call  gcheck(lchro2, nchro, npd, nk, mspan, ixfla2)
       if(ixfla1.eq.0  .and.  ixfla2.eq.0) then
      do  3005  i =  1  ,  nchro
      no(k1 , i)  =   lchro1(i)
3005  no(k2 , i)  =  lchro2(i)
       endif

c       write(lprint,  13117) j
c13117  format(1h  , 'coppia ',  i5)
c      write(lprint,  13118) k1 , k2, ltag, ltagp1
c13118 format(1h  ,'k1,k2,ltag,ltagp1 ', 4I6)
c      write(lprint,  13119)  ixfla1, ixfla2
c13119 format(1h  ,'ixfla1,ixfla2 ', 2I6)
c      write(lprint, 54557) (no(k1 , jjjj),  jjjj=1, nchro)
c      write(lprint, 54557) (no(k2 , jjjj),  jjjj=1, nchro)

30        continue
	  
c      WRITE(LPRINT,  55595)  
c55595  FORMAT(1H  ,'Crossover ')
c       do 76022  k  =  1  ,   nl
c76022  write(lprint, 54557) (no(k , j),  j=1, nchro)

C        calcolo delle mutazioni: P**(t+1) ---> P***(t+1)

      nppd1  =  npd  +  1
      nppd2  =   nob - npd

	DO  4000   K  =  1 ,  NL

      do  4004  i =1  , nchro
4004   lchrom(i) =  no(k , i)

C       write(lprint, 54557) (lchrom(i),  i=1, nchro)

	DO   4200   I  =  nppd1  ,  nppd2
        CALL VSUNIF(ISEME, RIS)

C       La mutazione ha luogo se RND <= Pm  (Pm=P1)

	IF(RIS.gt.P1) goto  4200
      lchrom(i) =  1  - lchrom(i) 
4200    CONTINUE

C       write(lprint, 54557) (lchrom(i),  i=1, nchro)

C        check  if all regimes contain at least mspan observations

       call  gcheck(lchrom, nchro, npd, nk, mspan, ixflah)

c       write(lprint,  30301) ixflah
c30301  format(1h  ,  'ixflah = ', I5)

       if(ixflah.eq.0) then
      do  4005  i =  1  ,  nchro
4005  no(k , i)  =  lchrom(i)
       endif

4000    CONTINUE

c      WRITE(LPRINT,  55596)  
c55596  FORMAT(1H  ,'Mutazione ')
c       do 76044  k  =  1  ,   nl
c76044  write(lprint, 54557) (no(k , j),  j=1, nchro)

	GOTO  1234

C         end   iterations

2100    CONTINUE

      fffit = FFB(lbest, nchro, nk, lprint, ifault)
       
	     iter1  =  iter  - 1
	     write(LPRINT ,  55570)  iter1, ITER2
55570   format(1h    ,'End genetic algorithm : iter, iter2 = ', 2i10)
	  WRITE(LPRINT,5557)   NBEST  , FBEST
5557     FORMAT(1X,4X,'Migliore cromosoma ',I4,2X,'Fitn.Funct.',E12.5)
c	WRITE(LPRINT,5556)(lbest(i), I=1,nchro)
5556    format(1h   ,70I1)
C	     write(LPRINT ,  10009)  fffit, ssq
C10009     format(1h  ,'fitness, ssq ', 2D15.6)

       RETURN

        END


      subroutine  gcheck(lchrom, nchro, npd, nk, mspan, ifault)

C       gcheck controlla che per ciascun regime vi siano almeno mspan 
C       osservazioni; gli errori possibili sono:
C       ifault = -1: tra la coda iniziale e finale non ci sono istanti
C       ifault = -2: almeno un regime ha meno di mspan osservazioni
C       ifault = -3: il cromosoma codifica piu' regimi del massimo nk
 
      dimension   lchrom(nchro)
      ifault  =  0
      npd1  =  npd +  1
      npd2  =  nchro - npd
      if(npd2  .lt.  npd1)  then
      ifault  =  -1
      return
      endif
      i1  = 0
      ic  =  0
      do  1   i  =  npd1  , npd2
      if(lchrom(i) .le.  0)  then
      ic =  ic +  1
c      write(*,*) 'i', i, lchrom(i), ic
      else
c      write(*,*) 'i', i , lchrom(i), ic
       if(ic  .le.  mspan) then
       ifault  =  -2
       return
       else
       i1 = i1  + 1
       ik  =  i
       ic  =  1
c      write(*,*) 'i1,ik,ic', i1 , ik, ic
       endif
      endif
1     continue
      if(npd2 - ik + 1  .lt.  mspan)  then
      ifault  =  -2
      return
      endif
      if(i1  .gt.  nk - 1)  then
      ifault  =  -3
      return
      endif
      return
      end
      

        SUBROUTINE  RESID(Z , NDR, PA, NP, R, VFIT, SSQ, IEXIT, imodel)
        IMPLICIT REAL*8(A-H , O-Z)
        DIMENSION Z(NDR), PA(NP), R(NDR), VFIT(NDR)                             
      COMMON/THAR/ icri, nkp, k, k1, nd, rk(10), nnp(10), ppa(10,31)
     +, stdppa(10, 31), sssv(10), sssq(10), nnik(10)                                     
      COMMON /chost/ icflag, nm, xeta
       data   tol / 8.43D-37 /                                          
       data     big  / 3.37D+38 /                                       
        IEXIT = 0
                                                                                
C      REAL ARRAY R IS SET TO ZERO                                      
                                                                        
        DO 1 I=1,NDR                                                    
1       R(I) = 0.0                                                      

C      PREDICTED TIME SERIES ACCORDING TO THE AUTOREGRESSIVE MODEL

         if(imodel .eq. 1)  then
        if(np .lt. 1)  goto 1402
        do  1401 i=1, np
1401    r(i)  =  z(i)
1402    continue
         np1 =  np + 1
        DO  1400  I  =  np1 ,  NDR
        DO  2400  J  =  1  ,  NP
2400    R(I) = R(I) + PA(J) * Z(I - J)
1400     CONTINUE
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE STATE DEPENDENT EAR MODEL
 
         if(imodel .eq. 2)  then
         G  =  PA(NP)
         NQ1 = (NP - 1) / 2
        do  140 i=1, nq1
140     r(i)  =  z(i)
         nq2 =  nq1 + 1
        DO 100   I =  nq2 ,NDR
        DO  110  J  =  1 ,  NQ1
        J1  =  NQ1 + J
        C  =  PA(J) + PA(J1) * DEXP(-G * (Z(I - 1) ** 2))
        R(I) = R(I) +  C * Z(I - J)
       IF(DABS(R(I)) .LT. TOL) R(I) = 0.0
      IF(DABS(R(I)).GT.BIG) THEN
      IEXIT = -1
      RETURN
      ENDIF
110    CONTINUE
100     continue
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE BILINEAR MODEL

         if(imodel .eq. 3)  then
        do  3401 i=1, np
3401    r(i)  =  z(i)
         np1 =  np + 1
        DO  3400  I  =  np1 ,  NDR
        R(I)  =  Z(I)
3400     CONTINUE
          endif

C      PREDICTED TIME SERIES ACCORDING TO THE THRESHOLD AR MODEL

        if(imodel .eq. 4)  then

C the first nq1=max(nd,p1,...,pk) predicted values equal the true values
C   **  overruled by nm

c       nq1 = nd
c        do  441 i=1  ,  k
c       if(nnp(i). gt. nq1) nq1 =  nnp(i)
c441     continue
         nq1  =  nm
        do  440 i=1, nq1
440     r(i)  =  z(i)

C the nq1+1,...,ndr predicted values are computed from the TAR estimates

         nq2 =  nq1 + 1
      DO  400 I  =  nq2  ,  NDR

C       regime choice depends on Z(t - nd)

        jj =  i - nd
       do 411 iiii =  1 ,  k1
       if(z(jj) .lt. rk(iiii+1)) goto  414
411    continue
       iiii  =  k
414     continue

       ntp  =  nnp(iiii)
C       WRITE(*,*) 'IIII,RK(IIII+1),NTP'
C       WRITE(*,*) IIII,RK(IIII+1),NTP
       if(icflag.eq.1) then
       ntp1  =  ntp + 1
       else
       ntp1 =  ntp
       endif
       do  4412  j =1  ,  ntp1
4412    pa(j)  =  ppa(iiii ,  j)
C       WRITE(*,*) (PA(J), J=1, NTP1)

C      the regime is k=iiii, the predicted value is inizialized to pa(0)

       if(icflag.eq.1) then
       j1 =1 
      R(I)  =  pa(j1)
       else
       j1 = 0
      R(I)  =  0.0
       endif
C      WRITE(*,*) R(I)
      DO  5410  J  =  1  ,  NTP
      j1  =  j1 + 1
      R(I) =  R(I) + PA(J1) * Z(I - J)
C      WRITE(*,*) R(I),PA(J1),Z(I-J)
5410   CONTINUE
400   CONTINUE
         endif
C      PAUSE

C      RESIDUALS COMPUTATION: OBSERVED/SIMULATED TIME SERIES DATA Z 

        DO 101  I = 1 , NDR
        VFIT(I)  =   R(I)
101     R(I)  = Z(I) - R(I)

C      SUM OF SQUARES COMPUTATION

        SSQ  =  DOTPRD(NDR , R , R)
        RETURN                                                          
        END                                                             


       subroutine THCTRL(parver, NQ, icontr, imodel, XCOEFF, XROOTS)
        implicit real*8 (a-h, o-z)
      COMPLEX  XCOEFF(NQ+1), XROOTS(NQ)
      LOGICAL polish
        dimension parver(NQ)
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)
     +, stdppa(10, 31), sssv(10), sssq(10), nnik(10)                                     
      data  small/ 8.43D-37/
       lprint  =  6
      ONE =  1D0
c  check AR roots 1-p1B-p2B^2... all outside the unit circle
        if(imodel .eq. 1) then
        icontr  =  -1
      XCOEFF(1) =CMPLX(one)
      DO  1400  J  =  1  ,  NQ
      RCOEFF =  -parver(J)
      JJ  =  J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
1400  continue
c      write(lprint, *) (xcoeff(j), j=1 , nq+1)
      polish=.false.
      call zroots(XCOEFF,NQ,XROOTS,polish)
c      write(lprint, *) (xroots(j), j=1 , nq)
      do  1015 i  =  1  ,  NQ
      xnorm = CABS(xroots(i))
c      write(lprint,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .le. one) goto  1409  
1015  continue
       icontr  =  0
1409   continue
        endif
c  check Haggan-Ozaki conditions (Biometrika, 1981)
        if(imodel .eq. 2) then
        icontr =  -1
       RCOEFF =  parver(NQ)
        if(RCOEFF. le. 0D0) goto  2409         
        nq1 = (nq - 1) / 2
        nq2 =  nq1 + 1
      XCOEFF(nq2) =CMPLX(one)
      DO  2400  J  =  1  ,  NQ1
      RCOEFF =  -parver(J)
      JJ  =  NQ1 - J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
2400  continue
      write(LPRINT, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(LPRINT, *) (xroots(j), j=1 , nq1)
      do  2015 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(LPRINT,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .ge. one) goto  2409  
2015  continue
      XCOEFF(nq2) =CMPLX(one)
      DO  2401  J  =  1  ,  NQ1
      J1 = J + NQ1
      RCOEFF =  -(parver(J) + parver(J1))
      JJ  =  NQ1 - J + 1
      XCOEFF(JJ) =CMPLX(RCOEFF)
2401  continue
      write(LPRINT, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(LPRINT, *) (xroots(j), j=1 , nq1)
      inside  = 0
      do  2025 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(LPRINT,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .lt. one) inside = inside + 1  
2025  continue
c      pause
      if(inside .eq. nq1) goto 2409
      sum = 0D0
      DO  2402  J  =  1  ,  NQ1
2402  sum  =  sum +  parver(J)
      sam =  0D0
      DO  2403  J  =  1  ,  NQ1
      J1 = NQ1 + J
2403  sam  =  sam +  parver(J1)
      IF(DABS(SAM)  .LE. small)  goto  2409
      FF =  (1D0 - sum) / sam
      write(LPRINT, 100) sum, sam, FF
100   format(1h  ,'Sum phi = ', F10.4,2x, 'Sum pi = ', F10.4
     +, 2x, 'FF =', F10.4)
c      pause
      if(FF .ge. 0D0  .and. FF .le. 1D0) goto  2409
       icontr = 0 
2409   continue
         endif
c  check bilinear model patrameters
        if(imodel .eq. 3) then
       icontr = 0 
         endif
c  checks that the AR roots p0-p1B-p2B^2... of the k - regimes of the
c  TAR threshold models all lie outside the unit circle
        if(imodel .eq. 4) then
        icontr  =  -1
       do  4401  iiii  =  1 , k
        nq1 = nnp(iiii) 
        nq2 = nnp(iiii) + 1
      XCOEFF(1) =CMPLX(one)
      if(NQ2 .ge. 2)  then
      DO  4400  J  =  2  ,  NQ2
      RCOEFF =  -ppa(iiii , J)
      XCOEFF(J) =CMPLX(RCOEFF)
4400  continue
       endif
      write(lprint, *) (xcoeff(j), j=1 , nq2)
      polish=.false.
      call zroots(XCOEFF,NQ1,XROOTS,polish)
      write(lprint, *) (xroots(j), j=1 , nq1)
      do  4015 i  =  1  ,  NQ1
      xnorm = CABS(xroots(i))
      write(lprint,'(1x,i4,4x, F10.4)') i, xnorm
      if(xnorm .le. one) goto  4409  
4015  continue
4401  continue
       icontr  =  0
4409   continue
         endif
        return
         end


      SUBROUTINE zroots(a,m,roots,polish)
C     roots of a polynomial by Laguerre's method with deflation 
      INTEGER m,MAXM
      REAL EPS
      COMPLEX a(m+1),roots(m)
      LOGICAL polish
      PARAMETER (EPS=1.e-6,MAXM=101)
CU    USES laguer
      INTEGER i,j,jj,its
      COMPLEX ad(MAXM),x,b,c
      do 11 j=1,m+1
        ad(j)=a(j)
11    continue
      do 13 j=m,1,-1
        x=cmplx(0.,0.)
        call laguer(ad,j,x,its)
        if(abs(aimag(x)).le.2.*EPS**2*abs(real(x))) x=cmplx(real(x),0.)
        roots(j)=x
        b=ad(j+1)
        do 12 jj=j,1,-1
          c=ad(jj)
          ad(jj)=b

          b=x*b+c
12      continue
13    continue
      if (polish) then
        do 14 j=1,m
          call laguer(a,m,roots(j),its)
14      continue
      endif
      do 16 j=2,m
        x=roots(j)
        do 15 i=j-1,1,-1
          if(real(roots(i)).le.real(x))goto 10
          roots(i+1)=roots(i)
15      continue
        i=0
10      roots(i+1)=x
16    continue
      return
      END


      SUBROUTINE laguer(a,m,x,its)
C     roots of a polynomial by Laguerre's method  
      INTEGER m,its,MAXIT,MR,MT
      REAL EPSS
      COMPLEX a(m+1),x
      PARAMETER (EPSS=2.e-7,MR=8,MT=10,MAXIT=MT*MR)
      INTEGER iter,j
      REAL abx,abp,abm,err,frac(MR)
      COMPLEX dx,x1,b,d,f,g,h,sq,gp,gm,g2
      SAVE frac
      DATA frac /.5,.25,.75,.13,.38,.62,.88,1./
      do 12 iter=1,MAXIT
        its=iter
        b=a(m+1)
        err=abs(b)
        d=cmplx(0.,0.)
        f=cmplx(0.,0.)
        abx=abs(x)
        do 11 j=m,1,-1
          f=x*f+d

          d=x*d+b
          b=x*b+a(j)
          err=abs(b)+abx*err
11      continue
        err=EPSS*err
        if(abs(b).le.err) then
          return
        else
          g=d/b
          g2=g*g
          h=g2-2.*f/b
          sq=sqrt((m-1)*(m*h-g2))
          gp=g+sq
          gm=g-sq
          abp=abs(gp)
          abm=abs(gm)
          if(abp.lt.abm) gp=gm
          if (max(abp,abm).gt.0.) then
            dx=m/gp
          else
            dx=exp(cmplx(log(1.+abx),float(iter)))

          endif
        endif
        x1=x-dx
        if(x.eq.x1)return
        if (mod(iter,MT).ne.0) then
          x=x1
        else
          x=x-dx*frac(iter/MT)
        endif
12    continue
      pause 'too many iterations in laguer'
      return
      END


      SUBROUTINE GRADU(X,XX,XORD,N,NG,NUM)
      IMPLICIT REAL*8(A - H , O -Z)
      DIMENSION X(NUM),XX(NUM),XORD(NUM),N(NUM),NG(NUM)
          big  =   3.37D+38
      DO   1   I   =  1  , NUM
1     XX(I)   =    X(I)
       K   =    0
3     K  =   K   +   1
      AMIN   =   big
	 DO  2   I   =   1   ,   NUM
       IF(XX(I).GE.AMIN)    GOTO  2
      AMIN   =    XX(I)
       J   =   I
2     CONTINUE
      XORD(K)   =    XX(J)
      N(J)   =   K
      NG(K)   =   J
      XX(J)    =     big
      IF(K.LT.NUM)     GOTO  3
      RETURN
      END


      REAL*8 FUNCTION FFB(lchrom, nchro, nk, lprint, ifault)
      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION LCHROM(NCHRO)
      COMMON/TSOBS/ NHB, Z(5500), KKHN(5500), ZO(5500), ZH(5500)
     +, NJ(10), XMAT(5500, 31), PHI(31), STDPHI(31), SSKP, SSV
     +, AUX1(31), VC1(31 , 31), BB(31), CC(31), IP(31), IQ(31)                                     
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)
     +, stdppa(10, 31), sssv(10), sssq(10), nnik(10)                                     
      COMMON /chost/ icflag, nm, xeta
      data  tol/ 8.43D-37/
       data     big  / 3.37D+38 /                                       

      IFAULT  =  0
      FFB  =  0D0

      IK  =  0
      DO  1   II  =  1  ,  NCHRO
      IF(LCHROM(II) .GE. 1) THEN
      IK = IK +  1
      NJ(IK) = II - 1
      JJ = KKHN(II)
      R(IK)  =  Z(JJ) 
      ENDIF
1     CONTINUE
      KJ =  IK +  1
      NJ(KJ)  =  NHB
      K1  =  IK
      K  =  IK  +  1

c      WRITE(LPRINT, 102)
c102   FORMAT(1H  ,'vettore lchrom')
c      WRITE(LPRINT, 103) (LCHROM(II), II=1,  NCHRO)
c103   FORMAT(1H   ,  70I1)
c      WRITE(LPRINT, 104)
c104   FORMAT(1H  ,'vettore nj')
c      WRITE(LPRINT, 105) (NJ(IK), IK=1,  KJ)
c105   FORMAT(1H   ,  15I5)
c      WRITE(LPRINT, 100) KJ
c100   FORMAT(1H  ,'regimi ', I5, 5X, 'obs:ini;fin')

      I1  =  1
      DO  2  II  =  1 ,  KJ
      I2 =  NJ(II)

c      WRITE(LPRINT, 101) I1, I2
c101   FORMAT(1H   ,  2I10)

      I1 =  I2 +  1
2     CONTINUE        

      I1  =  1
      DO  3  II  =  1 ,  KJ
      I2 =  NJ(II)

C      set maximum order of the AR model for the ii-th regime

      mnp  =  np      
      criter =  big

C      Searching for nnp(ii) with AIC (icri=1) or BIC (icri=2)

      do  4917  nkp =  1  ,  mnp
      ik  =   0
      DO  4  I  =  I1 , I2
      J  =  KKHN(I) + ND
c      if(j .lt. nkp + 1 .or. j. gt. nhb) goto  4
      if(j .le. nm .or. j. gt. nhb) goto  4

c      WRITE(LPRINT, 106) II, I, Z(J)
c106   FORMAT(1H  ,'regime ', i3, 3x, 'obs ', i5, 3x, 'z ', F10.4)

      ik  =  ik  +  1
      ZO(IK) =  Z(J)
      if(icflag.eq.1) then
      jhj = 1
      xmat(ik , jhj)  =  1D0
      else
      jhj  =  0
      endif
      if(nkp .lt. 1)  goto  6
      do  5  lagh =  1 ,  nkp
      lag1  =  lagh  +  jhj
      jj  =  j - lagh
      if(jj  .ge.  1)  then
      xmat(ik , lag1)  =  z(jj)
      else
      xmat(ik, lag1)  =  0.0D-000 
      endif
5     continue
6     continue
4     continue

      nkp1  =  nkp  +  jhj

c      write(lprint,  108)
c108   format(1h  ,'ZO = matrice XMAT')
c      do  7  j =  1  ,  ik
c7     write(lprint, 107) ZO(j), (xmat(j , jj), jj = 1  ,  nkp1)
c107   format(1h  ,7F10.4) 

      CALL REGRES(ZO, XMAT, 5500, IK, PHI, NkP1, AUX1, VC1, 31, BB, CC
     +, IP, IQ, TOL, MSING)

      IF(MSING  .EQ.  2)  THEN
      IFAULT  =  -1
      RETURN
      ENDIF

      dhm = RMEAN(zo, ik)
      ssv  =  0D0
      sskp =  0D0
      do  9  jj =  1  ,  ik
      ssv  =  ssv + (zo(jj) - dhm) * (zo(jj) - dhm)
      zo1 =  0D0
      do  10  ij  =  1 , nkp1
10    zo1 = zo1 +  phi(ij) * xmat(jj, ij)
9      sskp =  sskp + (zo(jj) -  zo1) * (zo(jj) - zo1)
      hsigma =  dsqrt(dabs(sskp / dble(ik)))
      do  12  ij =  1  , nkp1
12    stdphi(ij) = hsigma * dsqrt(dabs(VC1(ij , ij))) 
      if(icri  .eq.  1)  then
      crki =  dble(ik) *dlog(sskp / dble(ik)) + dble(nkp1) * 2D0 
      else
      crki= dble(ik)*dlog(sskp/dble(ik)) + dble(nkp1) * dlog(dble(ik))
      endif      

C      write(lprint , 119)  ii, np, nkp
C119   format(1h  ,'regime,np,nkp ', 3I6)
C      write(lprint, 117) (phi(jj),  jj=1 , nkp1)
C117 	format(1h  ,7F10.4)
C      write(lprint, 116) sskp, ssv, icri, crki
C116   format(1h  ,'sskp,ssv,icri,crki ', 2D14.6, i2, D14.6)      

      if(crki .lt. criter)  then
      criter  =   crki
      nnp(ii)  =  nkp
      DO  8  JJ  =  1  ,  NkP1
8     PPA(II,  JJ)  =  PHI(JJ)
      DO  13  JJ  =  1  ,  NkP1
13    STDPPA(II,  JJ)  =  STDPHI(JJ)
      sssq(ii) =  sskp
      sssv(ii) =  ssv
      nnik(ii)  =  ik
      endif

4917   continue

      I1 =  I2 +  1
3     CONTINUE        


c      WRITE(LPRINT, 109) k
c109   FORMAT(1H  ,'risultati FFB, k = ',  I5)
c      do  12  ii  =  1  ,  k
c      write(lprint, 110) ii, r(ii), nnp(ii)
c110   format(1h   ,'regime,r,nnp ', I5, F12.4, I10)
c      nnp1 = nnp(ii)  +  1
c12     write(lprint, 111) (ppa(ii, jj),  jj=1 , nnp1)
c111 	format(1h  ,7F10.4)
C
C      IMODEL  =  4
C      np1  =  np + 1
C      CALL  RESID(Z , NHB, PHI, NP1, ZO, ZH, SSQ, IEXIT, imodel)
C
C      write(lprint, 112) iexit
C112   format(1h  ,'exit RESID, iexit = ', I10)
C      write(lprint, 113)  ssq
C113   format(1h   ,'Residual sum of squares SSQ = ', D14.6)
C
C      IF(IEXIT  .LT. 0) THEN
C      IFAULT = -1
C      RETURN
C      ENDIF

       SSKP  =  0D0
      SSV  =  0D0
       p  = 0
      do  11  i  =  1  ,  k
       SSKP  =  SSKP + SSSQ(I)
      SSV  =  SSV +  SSSV(I)
11    p  =  p  +  dble(nnp(i))
      SSQ  =   SSKP
      if(icri  .eq.  1)  then
      crki = dble(nhb-nm)* dlog(ssq / dble(nhb-nm)) + p * 2D0 
      else
      crki =dble(nhb-nm)*dlog(ssq/dble(nhb-nm)) + p * dlog(dble(nhb-nm)) 
      endif      
      FFB  =  dexp(-crki/xeta)
      
c      write(lprint, 115) icri, p, crki 
c115   format(1h  ,'icri,p,crki ',  I2, 2D14.6)
c      write(lprint, 114) ffb
c114   format(1h   ,'Exit FFB = ', D14.6)

      RETURN

      END


      SUBROUTINE  SIMTRU(etilda, mob, nob, nscart, nm, PAR , NQ, imodel
     +, VARE, sse, icontr)
      IMPLICIT REAL*8 (A -H , O - Z)
      DIMENSION  PAR(NQ), etilda(mob)
      COMMON/TSOBS/ NHB, Z(5500), KKHN(5500), ZO(5500), ZH(5500)
     +, NJ(10), XMAT(5500, 31), PHI(31), STDPHI(31), SSKP, SSV
     +, AUX1(31), VC1(31 , 31), BB(31), CC(31), IP(31), IQ(31)                                     
      COMMON/THAR/ icri, np, k, k1, nd, r(10), nnp(10), ppa(10,31)
     +, stdppa(10, 31), sssv(10), sssq(10), nnik(10)                                     
      COMMON /RAND/ IX, IY, IZ
      data  small/ 8.43D-37/
       data     big  / 3.37D+38 /                                       
       icontr = -1
      lprint  =  6

C     generate the random noise time series N(0 , VARE) for pseudo-
C     historical data Z 

      NTOT = NOB + NSCART
      N1 =  NTOT
      NDR1 =  NOB - NM
      DO  401  I  =  1  ,  NTOT
402   PPX0 =  RANDOM(L)
      PPX1 =  PPND16(PPX0 , IZAULT)
      IF(IZAULT .NE. 0)  GOTO  402
401   ETILDA(I) =  PPX1 * DSQRT(VARE)   

       sse = 0D0
       nscar1 =  nscart +  NM  + 1
       do 1401 i = nscar1, ntot
1401   sse  =  sse  +  etilda(i) ** 2
       sse  =  sse/ dble(NDR1)

c       write(lprint, 90) (etilda(i), i=1, ntot)
c90     format(1h   , 10F7.4)
c       write(lprint, 91)  NDR1, sse, vare
c91     format(1h  ,'Error variance ndr, sse, vare = ',I10,2D12.4) 

C   Autoregressive model AR(nq)
C   z(t) = constant + par(1) z(t-1) + ... + par(nq) z(t-nq) + etilda(t)

        if(imodel .eq. 1)  then
      DO  100 I  =  1  ,  N1
      Z(I) =  ETILDA(I) + r(k1)
      DO  200  J  =  1  ,  NQ
      IF(J .GE. I)  GOTO  200
      Z(I) =  Z(I) + PAR(J) * Z(I - J)
200   CONTINUE
100   CONTINUE
        icontr = 0
         endif

C   Exponential autoregressive EXPAR(nq1), nq1 = nq / 2
C   z(t) = constant + (par(1) + par(nq1+1)exp(-gamma z(t-d)^2)) z(t-1) + 
C.. + (par(nq1) + par(nq1+nq1)exp(-gamma z(t-d)^2)) z(t-nq1) + etilda(t)
C      constant = r(1), gamma = r(k1)

        if(imodel .eq. 2)  then
        gg  =  r(k1)
        nq1 = nq / 2
      DO  1400 I  =  1  ,  N1
      if(i.gt.2) then
      if(dabs(z(i-1)).gt.big) then
      write(*,*) 'obs. no. i = ', i
      write(*,*) 'imodel', imodel
      write(*,*) 'parametri par'
      write(*,*) (par(iiii), iiii=1,nq)
      write(*,*) 'z(i-2)', z(i-2)
      write(*,*) 'z(i-1)', z(i-1)
        return
       endif
        endif
      Z(I) =  ETILDA(I) + r(1)
      DO  2400  J  =  1  ,  NQ1
      IF(J .GE. I)  GOTO  2400
      J1 = NQ1 + J
      coef = 	par(J) + par(J1) * dexp(-gg * (Z(i-1)**2))
      Z(I) =  Z(I) + coef * Z(I - J)
2400   CONTINUE
c      write(*,*) 'z(i)', z(i)
c       pause
1400   CONTINUE
        icontr = 0
        endif

C   Bilinear model (not active)

        if(imodel .eq. 3)  then
       do  301  i  =1  ,  n1
301    z(i)  =  etilda(i)
        icontr = 0
         endif

C   k - regimes threshold autoregressive model TAR(nd,nnp(1)..nnp(k))
C   z(t)=ppa(1,1)+ppa(1,2)z(t-1)+...ppa(1,nnp(1)+1)z(t-nnp(1))+etilda(t)
C      z(t-nd) < r(1)
C   z(t)=ppa(2,1)+ppa(2,2)z(t-1)+...ppa(2,nnp(2)+1)z(t-nnp(2))+etilda(t)
C    r(1)<=z(t-nd)<r(2)
C      .............
C   z(t)=ppa(k,1)+ppa(k,2)z(t-1)+...ppa(k,nnp(k)+1)z(t-nnp(k))+etilda(t)
C      z(t-nd) >= r(k-1)    (k1 is set to k - 1)

        if(imodel .eq. 4)  then
       
C   The first nd time series values are taken to follow the first regime
c     ****  overruled  by  nm
      do  4171  i  =1  ,  nm
4171  z(i)  =  etilda(i)
c       nkp1  =  nnp(1)
c       nkp  =  nnp(1) + 1
c       do  417  j =1  ,  nkp
c417    par(j)  =  ppa(1 ,  j)
c       do  416 i  =  1 ,  nd
c      Z(I) =  ETILDA(I) + par(1)
c
cc      write(lprint, 1105) I, etilda(i), Z(i)
c
c      DO  403  J  =  1  ,  nkp1
c      IF(J .GE. I)  GOTO  403
c       j1  =  j + 1
c
cc      write(lprint, 1106) J, par(j1), Z(i-j)
c
c      Z(I) =  Z(I) + PAR(J1) * Z(I - J)
c403   continue
c416    continue

C   The k-regimes TAR generates the z values time series after t = nd+1 
c    ********  overruled  by  nm
c      nd1  =  nd + 1
c      DO  400 I  =  nd1  ,  N1
      nm1  =  nm + 1
      DO  400 I  =  nm1  ,  N1

C       regime choice depends on x(t - nd)

        jj =  i - nd
       do 411 iiii =  1 ,  k1
       if(z(jj) .le. r(iiii)) goto  414
411    continue
       iiii  =  k
414     continue

c      write(lprint,  11007)  iiii, r(iiii), jj, z(jj)
c11007 format(1h  ,'regime ', i2,2x, 'soglia sup.', f10.4, 2x
c     +, 't-d ', i5, 2x, 'x(t-d) ', f10.4)

       nkp1  =  nnp(iiii)
       nkp  =  nnp(iiii) + 1
       do  412  j =1  ,  nkp
412    par(j)  =  ppa(iiii ,  j)

      Z(I) =  ETILDA(I) +  par(1)

c      write(lprint, 1105) I, etilda(i) , Z(i), Z(i-1)
c1105  format(1h   ,'obs n. ', I5, 3F10.4)

      DO  410  J  =  1  ,  nkp1
      IF(J .GE. I)  GOTO  410
      j1  =  j + 1

c      write(lprint, 1106) J, par(j1), Z(i-j)
c1106  format(1h  ,'j,par(j),z(i-j) ', I5, 2F10.4)

      Z(I) =  Z(I) + PAR(J1) * Z(I - J)
410   CONTINUE

c      write(lprint, 1009) i, Z(i)
c1009  format(1h  , 'oss. i = ', I5, F10.4)

400   CONTINUE
        icontr = 0
         endif

C   k - regimes threshold autoregressive model TAR(nd,nnp(1)..nnp(k))
C   with coefficients linear functions of z(t - nd)
C   z(t) = ppa(1,1) + ppa(1,nnp(1)+1+1) z(t-nd) +
C            + (ppa(1,2)+ ppa(1,nnp(1)+1+2) z(t-nd)) z(t-1) + ...
C  ... + (ppa(1,nnp(1)+1)+ ppa(1,nnp(1)+1+nnp(1)+1) z(t-nd)) z(t-nnp(1))
C         + etilda(t)
C      z(t-nd) <= r(1)
C   z(t) = ppa(2,1) + ppa(2,nnp(2)+1+1) z(t-nd) + 
C            + (ppa(2,2)+ ppa(2,nnp(2)+1+2) z(t-nd)) z(t-1) + ...
C  ... + (ppa(2,nnp(2)+1)+ ppa(2,nnp(2)+1+nnp(2)+1) z(t-nd)) z(t-nnp(2))
C     + etilda(t)
C    r(1)<z(t-nd)<=r(2)
C      .............
C   z(t) = ppa(k,1) + ppa(k,nnp(1)+1+1) z(t-nd)
C             +  (ppa(k,2)+ ppa(k,nnp(k)+1+2) z(t-nd)) z(t-1) + ...
C  ... + (ppa(k,nnp(k)+1)+ ppa(k,nnp(1)+1+nnp(1)+1) z(t-nd)) z(t-nnp(k))
C     + etilda(t)
C      z(t-nd) > r(k-1)    (k1 is set to k - 1)

        if(imodel .eq. 5)  then
       
C   The first nd time series values are taken to be white noise

       do  516 i  =  1 ,  nd
      Z(I) =  ETILDA(I) 

c      write(lprint, 11105) I, etilda(i), Z(i)
c11105  FORMAT(1H  , 'n.obs.,Etilda,Z ', I5,  2F10.4)

516    continue

C   The k-regimes TAR generates the z values time series after t = nd+1 

      nd1  =  nd + 1

      DO  500 I  =  nd1  ,  N1

      Z(I) =  ETILDA(I)

C       regime choice depends on x(t - nd)

        jj =  i - nd

       do 511 iiii =  1 ,  k1
       if(z(jj) .le. r(iiii)) goto  514
511    continue
       iiii  =  k
514     continue

C  set autoregressive order and model parameters

       nkp  =  nnp(iiii)
       j1  =  1
       j2 =  nkp + 1  +1
       par(j1)  =  ppa(iiii , j1)
       par(j2)  =  ppa(iiii ,  j2)
       do  512  j =1  ,  nkp
       j1  =  j +  1
512    par(j1)  =  ppa(iiii ,  j1)
       do  508  j =1  ,  nkp
       j2  =  nkp + 1 + j +  1
508    par(j2)  =  ppa(iiii ,  j2)

c      write(lprint,  51007)  iiii, r(iiii), NKP, jj, z(jj)
c51007 format(1h  ,'regime i, soglia sup.,  p(i),  t-d,  z(t-d)'
c     +/ 1h  ,I5, F10.4, 2I5, E12.4)
c      write(lprint, 52008) 
c52008 format(1h  ,'autoregressive parameters: a(0)..a(p) b(0)..b(p)')
c      write(lprint, 53008) (par(jjjj), jjjj = 1 , j2)
c53008 format(1h  ,7F10.4)

C        autoregressive "constant" term

       j1  =  1
       j2 =  nkp + 1  +1
      Z(I) =  Z(I) + PAR(J1) + PAR(J2) * Z(I - ND)

c      write(lprint, 1105) I, etilda(i), PAR(J1), PAR(J2), Z(i) 
c1105  format(1h  , 'constant: n.obs.t, Etilda, par(0), par(1), Z(t)'
c     +/1h  ,I5, 3F10.4, E12.4)

C        "lagged" autoregressive terms 1, ..., p

      DO  510  J  =  1  ,  nkp

      IF(J .GE. I)  GOTO  510

       j1  =  j + 1
       j2  =  nkp + 1 + j + 1
      Z(I) =  Z(I) + (PAR(J1) + PAR(J2) * Z(I - ND)) * Z(I - J)

c      write(lprint, 1106) J, par(j1), par(j2), Z(i-j), z(i)
c1106  format(1h  ,'lag, par(0), par(1), z(t-lag), z(t)'
c     +/1h   , I5, 2F10.4, 2E12.4)
      
510   continue

c      write(lprint, 51009) i, Z(i)
c51009  format(1h  , 'oss. i = ', I5, E12.4)

500   CONTINUE

        icontr = 0

         endif

C   Exponential autoregressive EXPAR(k), each j-th exponential term is 
C   multiplied by a polynomial in z(t-nd) of order nnp(j)-1, j = 1,...,k
C   The model's constant is constant = r(k1), where k1 is set to k + 1
C    z(t) = constant + 
C                        + [ppa(1, nnp(1)+1) +
C   + (ppa(1,1)+ppa(1,2) z(t-nd)+ ...ppa(1,nnp(1)) z(t-nd)^(nnp(1)-1)) *
C                        * exp(-r(1) z(t-nd)^2] z(t - 1)  +
C                        + [ppa(2, nnp(2)+1) +
C   + (ppa(2,1)+ppa(2,2) z(t-nd)+ ...ppa(2,nnp(2)) z(t-nd)^(nnp(2)-1)) *
C                        * exp(-r(2) z(t-nd)^2] z(t - 2)  +
C                          ..............................
C                        + [ppa(k, nnp(k)+1) +
C   + (ppa(k,1)+ppa(k,2) z(t-nd)+ ...ppa(k,nnp(k)) z(t-nd)^(nnp(k)-1)) *
C                        * exp(-r(k) z(t-nd)^2] z(t - k)  +
C                                                            + etilda(t)

      if(imodel .eq. 6)  then
      do  600  i  = 1   , n1
      z(i)  =  etilda(i) + r(k1)

c      write(lprint, 1010) i, etilda(i), r(k1)
c1010  format(1h   ,'obs,etilda,r(k1) ', I5, 2F10.4)

      if(k  .le.  0)  goto   609
      do   604   j  =1  ,  k
      if(max0(j, nd)  .ge.  i)  goto  604
      nkp  =  nnp(j)
      nkp1  =   nkp  + 1      
      sxm  =  ppa(j , nkp1)

c      write(lprint, 1011) j, sxm
c1011  format(1h  ,'lag, regular AR param. ', I5, F10.4)

      if(nkp  .le.  0)  then

c      write(lprint, 1016) sxm, z(i-j)
c1016  format(1h   ,'coef,z(i-j) ', 2F20.5) 

      z(i) = z(i) + sxm * z(i - j)
      else
      shm =  0.0
      do  603  jj  =  1  ,  nkp
      ii  =   jj  -  1

c      write(lprint, 1012) jj, ii
c1012  format(1h  ,'polynomial term no. ', I5, 5x, 'order ', i5)
c      c1=	z(i-nd)**ii
c      c2 = ppa(j,jj)*(z(i-nd)**ii) 
c      write(lprint,1013) ppa(j,jj), c1, c2
c1013  format(1h   ,'ppa(j,jj),z(i-nd)**ii,ppa(j,jj)*(z(i-nd)**ii)'
c     +/1h   , 3F20.5)

603   shm  =  shm  +  ppa(j , jj) * (z(i-nd) ** ii)

c      c3  =  z(i-nd)**2
c      c4  =  dexp(-r(j) * (z(i-nd)**2))
c      write(lprint, 1014) shm, r(j), c3, c4
c1014  format(1h  ,'shm,r(j),z(i-nd)**2,dexp(-r(j) * (z(i-nd)**2))'
c     +/1h   ,4D16.6)

      z(i) = z(i) + (sxm + shm * dexp(-r(j) * (z(i-nd)**2))) * z(i - j)

c      cccc  =  sxm + shm * dexp(-r(j) * (z(i-nd)**2))
c      write(lprint, 1015) cccc, z(i-j)
c1015  format(1h   ,'coef,z(i-j) ', 2F20.5) 

      endif
604   continue
609   continue      

c      write(lprint, 1017) z(i)
c1017  format(1h   ,'observation generated z = ', F20.5)

600   continue
        endif

C       The first nscart observations generated are discarded,
C       nob observations are left for recording

      DO  101  I  =  1 ,  NOB
101   Z(I)  =  Z(I + NSCART)

c      write(lprint,  '(1h  , 18hserie generata z    )')
c      write(lprint , 11166) (z(i) , i=1, nob)
c11166 format(1h  , 7F10.4)

        return
        end


      SUBROUTINE REGRES(Y, XMAT, MOB, NOB, P, NP, A, D, MP, B, C, IP, IQ
     +, EPS, MSING)

C   Linear regression ordinary least squares : p = (X'X)^(-1) X'y
C   msing = 1, normal exit; msing = 2, the matrix X'X is singular

      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION  Y(NOB), XMAT(MOB, NP), P(NP), A(NP) 
     +, D(MP, NP), B(NP), C(NP), IP(NP), IQ(NP)

C   X'X -> D (here X == XMAT)

      DO  1  I  =1  ,  NP
      DO 1  J  =1  ,  NP
      SUM  =  0.0
      DO  2  K  =1  ,  NOB
2     SUM  =  SUM  +  XMAT(K , I) * XMAT(K , J)
1     D(I , J)  =  SUM

C   (X'X)^(-1) -> D

      CALL  DGJR(D, NP, MP, EPS, MSING, B, C, IP, IQ)
      IF(MSING .EQ. 2)  RETURN

C   X'y -> a

      DO  3  I  =1  ,  NP
      SUM  =  0.0
      DO  4  K  =1  ,  NOB
4     SUM =  SUM + XMAT(K , I) * Y(K)
3     A(I)  =  SUM

C   (X'X)^(-1) X'y == Da -> p

      DO  5  I =1  ,  NP
      SUM  =  0.0
      DO  6  J  =1  ,  NP
6     SUM  =  SUM +  D(I , J) * A(J)
5     P(I) =  SUM
C                                                             End REGRES
      RETURN
      END


      SUBROUTINE DGJR(A,N,MM,EPS,MSING,B,C,P,Q)
C----     GAUSS-JORDAN-RUTISHAUSER MATRIX INVERSION WITH DOUBLE PIVOTING
      IMPLICIT REAL*8 (A - H , O - Z)
      INTEGER P,Q
      DIMENSION A(MM,N),B(N),C(N),P(N),Q(N)
      MSING=1
      DO 10 K=1,N
C----     DETERMINATION OF THE PIVOT ELEMENT
      PIVOT=0.0
      DO 20 I=K,N
      DO 20 J=K,N
      IF(DABS(A(I,J))-DABS(PIVOT)) 20,20,30
30    PIVOT=A(I,J)
      P(K)=I
      Q(K)=J
20    CONTINUE
      IF(DABS(PIVOT)-EPS) 40,40,50
C----     EXCHANGE OF THE PIVOTAL ROW WITH THE K-TH ROW
50    IF(P(K)-K) 60,80,60
60    DO 70 J=1,N
      L=P(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
70    A(K,J)=Z
C----     EXCHANGE OF THE PIVOTAL COLUMN WITH THE K-TH COLUMN
80    IF(Q(K)-K) 85,90,85
85    DO 100 I=1,N
      L=Q(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
100   A(I,K)=Z
90    CONTINUE
C----     JORDAN STEP
      DO 110 J=1,N
      IF(J-K) 130,120,130
120   B(J)=1.0/PIVOT
      C(J)=1.0
      GOTO 140
130   B(J)=-A(K,J)/PIVOT
      C(J)=A(J,K)
140   A(K,J)=0.0
110   A(J,K)=0.0
      DO 10 I=1,N
      DO 10 J=1,N
10    A(I,J)=A(I,J)+C(I)*B(J)
C----     REORDERING THE MATRIX
      DO 155 M=1,N
      K=N-M+1
      IF(P(K)-K) 160,170,160
160   DO 180 I=1,N
      L=P(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
180   A(I,K)=Z
170   IF(Q(K)-K) 190,155,190
190   DO 150 J=1,N
      L=Q(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
150   A(K,J)=Z
155   CONTINUE
151   RETURN
40    CONTINUE
      MSING=2
      GOTO 151
      END
                                                                       

      REAL*8 FUNCTION DOTPRD(P, X, Y)                                   ARI03050
C                                                                       ARI03060
C  ***  RETURN THE INNER PRODUCT OF THE P-VECTORS X AND Y.  ***         ARI03070
C                                                                       ARI03080
C                                                                       ARI03090
C     THIS PROGRAM IS TAKEN FROM :                                      ARI03100
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI03110
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI03120
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI03130
C     SEPTEMBER 1981                                                    ARI03140
C                                                                       ARI03150
      INTEGER P                                                         ARI03160
      REAL*8 X(P), Y(P)                                                 ARI03170
C                                                                       ARI03180
      INTEGER I                                                         ARI03190
      REAL ONE, SQTETA, T, ZERO                                         ARI03200
C/+                                                                     ARI03210
      REAL*8 DMAX1, DABS                                                ARI03220
      REAL  ABS
C/                                                                      ARI03230
      EXTERNAL RMDCON                                                   ARI03240
      REAL RMDCON                                                       ARI03250
C                                                                       ARI03260
C  ***  RMDCON(2) RETURNS A MACHINE-DEPENDENT CONSTANT, SQTETA, WHICH   ARI03270
C  ***  IS SLIGHTLY LARGER THAN THE SMALLEST POSITIVE NUMBER THAT       ARI03280
C  ***  CAN BE SQUARED WITHOUT UNDERFLOWING.                            ARI03290
C                                                                       ARI03300
C/6                                                                     ARI03310
      DATA ONE/1.E+0/, SQTETA/0.E+0/, ZERO/0.E+0/                       ARI03320
C/7                                                                     ARI03330
C     PARAMETER (ONE=1.D+0, ZERO=0.D+0)                                 ARI03340
C     DATA SQTETA/0.D+0/                                                ARI03350
C/                                                                      ARI03360
C                                                                       ARI03370
      DOTPRD = ZERO                                                     ARI03380
      IF (P .LE. 0) GO TO 999                                           ARI03390
      IF (SQTETA .EQ. ZERO) SQTETA = RMDCON(2)                          ARI03400
      DO 20 I = 1, P                                                    ARI03410
         T = DMAX1(DABS(X(I)), DABS(Y(I)))                              ARI03420
         IF (T .GT. ONE) GO TO 10                                       ARI03430
         IF (T .LT. SQTETA) GO TO 20                                    ARI03440
         T = (X(I)/SQTETA)*Y(I)                                         ARI03450
         IF (ABS(T) .LT. SQTETA) GO TO 20                               ARI03460
 10      DOTPRD = DOTPRD + X(I)*Y(I)                                    ARI03470
 20   CONTINUE                                                          ARI03480
C                                                                       ARI03490
 999  RETURN                                                            ARI03500
C  ***  LAST CARD OF DOTPRD FOLLOWS  ***                                ARI03510
      END                                                               ARI03520


      REAL FUNCTION RMDCON(K)                                           ARI14080
                                                                        ARI14090
C  ***  RETURN MACHINE DEPENDENT CONSTANTS                 ***          ARI14100
C                                                                       ARI14110
C     THIS PROGRAM IS TAKEN FROM :                                      ARI14120
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI14130
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI14140
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI14150
C     SEPTEMBER 1981                                                    ARI14160
C                                                                       ARI14170
C +++  COMMENTS BELOW CONTAIN DATA STATEMENTS FOR VARIOUS MACHINES.  +++ARI14180
C +++  TO CONVERT TO ANOTHER MACHINE, PLACE A C IN COLUMN 1 OF THE   +++ARI14190
C +++  DATA STATEMENT LINE(S) THAT CORRESPOND TO THE CURRENT MACHINE +++ARI14200
C +++  AND REMOVE THE C FROM COLUMN 1 OF THE DATA STATEMENT LINE(S)  +++ARI14210
C +++  THAT CORRESPOND TO THE NEW MACHINE.                           +++ARI14220
C                                                                       ARI14230
      INTEGER K                                                         ARI14240
C                                                                       ARI14250
C  ***  THE CONSTANT RETURNED DEPENDS ON K...                           ARI14260
C                                                                       ARI14270
C  ***        K = 1... SMALLEST POS. ETA SUCH THAT -ETA EXISTS.         ARI14280
C  ***        K = 2... SQUARE ROOT OF 1.001*ETA.                        ARI14290
C  ***        K = 3... UNIT ROUNDOFF = SMALLEST POS. NO. MACHEP SUCH    ARI14300
C  ***                 THAT 1 + MACHEP .GT. 1 .AND. 1 - MACHEP .LT. 1.  ARI14310
C  ***        K = 4... SQUARE ROOT OF 0.999*MACHEP.                     ARI14320
C  ***        K = 5... SQUARE ROOT OF 0.999*BIG (SEE K = 6).            ARI14330
C  ***        K = 6... LARGEST MACHINE NO. BIG SUCH THAT -BIG EXISTS.   ARI14340
C                                                                       ARI14350
      REAL BIG, ETA, MACHEP                                             ARI14360
                                                                        ARI14370
      REAL SQRT                                                         ARI14380
                                                                        ARI14390
      REAL ONE001, PT999                                                ARI14400
                                                                        ARI14410
      DATA ONE001/1.001/, PT999/0.999/                                  ARI14420
                                                                        ARI14430
C  +++  IBM 360, IBM 370, OR XEROX  +++                                 ARI14440
C                                                                       ARI14450
C      DATA BIG/Z7FFFFFFF/, ETA/Z00100000/, MACHEP/Z3C100000/           ARI14460
C                                                                       ARI14470
C  +++  DATA GENERAL  +++                                               ARI14480
C                                                                       ARI14490
C     DATA BIG/0.7237E+76/, ETA/0.5398E-78/, MACHEP/0.9537E-06/         ARI14500
C                                                                       ARI14510
C  +++  DEC 11  +++                                                     ARI14520
C                                                                       ARI14530
C     DATA BIG/1.7E+38/, ETA/2.9388E-39/, MACHEP/1.1921E-07/            ARI14540
C                                                                       ARI14550
C  +++  HP3000  +++                                                     ARI14560
C                                                                       ARI14570
C     DATA BIG/1.1579E+77/, ETA/8.6362E-78/, MACHEP/2.3842E-07/         ARI14580
C                                                                       ARI14590
C  +++  HONEYWELL  +++                                                  ARI14600
C                                                                       ARI14610
C     DATA BIG/O376777000000/, ETA/O404400400000/,                      ARI14620
C    1     MACHEP/O716400000000/                                        ARI14630
C                                                                       ARI14640
C  +++  DEC10  +++                                                      ARI14650
C                                                                       ARI14660
C     DATA BIG/"377777777777/, ETA/"000400000021/,                      ARI14670
C    1     MACHEP/"147400000000/                                        ARI14680
C                                                                       ARI14690
C  +++  BURROUGHS  +++                                                  ARI14700
C                                                                       ARI14710
C     DATA BIG/O0777777777777777/, ETA/O1771000000000000/,              ARI14720
C    1     MACHEP/O1301000000000000/                                    ARI14730
C                                                                       ARI14740
C  +++  CONTROL DATA  +++                                               ARI14750
C                                                                       ARI14760
C     DATA BIG/37754000000000000000B/, ETA/00024000000000000000B/,      ARI14770
C    1     MACHEP/16414000000000000000B/                                ARI14780
C                                                                       ARI14790
C  +++  PRIME  +++                                                      ARI14800
C                                                                       ARI14810
C     DATA BIG/1.7E+38/, ETA/1.47E-39/, MACHEP/2.38419E-7/              ARI14820
C                                                                       ARI14830
C  +++  UNIVAC  +++                                                     ARI14840
C                                                                       ARI14850
C     DATA BIG/1.69E+38/, ETA/5.9E-39/, MACHEP/1.4901162E-8/            ARI14860
C                                                                       ARI14870
C  +++  VAX  +++                                                        ARI14880
C                                                                       ARI14890
C     DATA BIG/1.7E+38/, ETA/2.939E-39/, MACHEP/5.9604645E-08/          ARI14900
C
c  approximations of real numbers in floating-point form (1 to 7 digits)        
c  from 8.43E-37 to 3.37E+38 (assumed zero if less/equal than 0.000015)
        big  =  3.37E+38
        eta  =   8.43E-37 
        machep  = 0.000015 
C                                                                       ARI14910
C-------------------------------  BODY  --------------------------------ARI14920
                                                                        ARI14930
      GO TO (10, 20, 30, 40, 50, 60), K                                 ARI14940
                                                                        ARI14950
 10   RMDCON = ETA                                                      ARI14960
      GO TO 999                                                         ARI14970
                                                                        ARI14980
 20   RMDCON = SQRT(ONE001*ETA)                                         ARI14990
      GO TO 999                                                         ARI15000
                                                                        ARI15010
 30   RMDCON = MACHEP                                                   ARI15020
      GO TO 999                                                         ARI15030
                                                                        ARI15040
 40   RMDCON = SQRT(PT999*MACHEP)                                       ARI15050
      GO TO 999                                                         ARI15060
                                                                        ARI15070
 50   RMDCON = SQRT(PT999*BIG)                                          ARI15080
      GO TO 999                                                         ARI15090
                                                                        ARI15100
 60   RMDCON = BIG                                                      ARI15110
                                                                        ARI15120
 999  RETURN                                                            ARI15130
C  ***  LAST CARD OF RMDCON FOLLOWS  ***                                ARI15140
      END                                                               ARI15150
                                                                        ARI15160

      REAL*8 FUNCTION SUMF(X,N)
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(N)                                                    
      SUMF=0.0                                                          
      DO 10 I=1,N                                                       
   10 SUMF=SUMF+X(I)                                                    
      RETURN                                                            
      END                                                               


      REAL*8 FUNCTION RMEAN(X,NOB)                                      ARI01510
C                                                                       ARI01520
C----      DOUBLE PRECISION FUNCTION RMEAN                              ARI01530
C                                                                       ARI01540
C      CALCULATES THE SAMPLE MEAN OF A SERIES OF NOB OBSERVATIONS       ARI01550
C                                                                       ARI01560
C----                                                                   ARI01570
C                                                                       ARI01580
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01590
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01600
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01610
C                                                                       ARI01620
C----                                                                   ARI01630
C                                                                       ARI01640
C      X:  OBSERVED TIME SERIES OF NOB VALUES                           ARI01650
C                                                                       ARI01660
C----                                                                   ARI01670
C                                                                       ARI01680
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB)                                                  ARI01690
      SUM=0                                                             ARI01700
      DO 10 J=1,NOB                                                     ARI01710
  10  SUM=SUM+X(J)                                                      ARI01720
      RMEAN=SUM/FLOAT(NOB)                                              ARI01730
      RETURN                                                            ARI01740
      END                                                               ARI01750


      REAL*8 FUNCTION CPROXY(X,XBAR,Y,YBAR,NOB)                         ARI01760
C                                                                       ARI01770
C----     DOUBLE PRECISION FUNCTION CPROXY                              ARI01780
C                                                                       ARI01790
C      CALCULATES SUM OF PRODUCTS OF DEVIATIONS OF TWO VARIABLES        ARI01800
C      FROM SPECIFIED CENTRAL VALUES                                    ARI01810
C                                                                       ARI01820
C----                                                                   ARI01830
C                                                                       ARI01840
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01850
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01860
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01870
C                                                                       ARI01880
C----                                                                   ARI01890
C                                                                       ARI01900
C      X,Y:      REAL ARRAYS OF LENGTH NOB.                             ARI01910
C                ON ENTRY CONTAIN VALUES OF THE TWO VARIABLES           ARI01920
C      XBAR,YBAR:X'S AND Y'S MEAN RESPECTIVELY                          ARI01930
C                                                                       ARI01940
C----                                                                   ARI01950
C                                                                       ARI01960
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB),Y(NOB)                                           ARI01970
      S=0                                                               ARI01980
      DO 10 I=1,NOB                                                     ARI01990
  10  S=S+(X(I)-XBAR)*(Y(I)-YBAR)                                       ARI02000
      CPROXY=S                                                          ARI02010
      RETURN                                                            ARI02020
      END                                                               ARI02030


      SUBROUTINE ZCOR(C,NOB,NAC,R,SER,DM,DSD,IEXIT)                     ARI02040
C                                                                       ARI02050
C-----     SUBROUTINE ZCOR                                              ARI02060
C                                                                       ARI02070
C     CALCULATES AUTOCORRELATIONS AND THEIR STANDARD ERRORS             ARI02080
C                                                                       ARI02090
C-----                                                                  ARI02100
C                                                                       ARI02110
C     C     SERIES INPUT OF NOB OBS.                                    ARI02120
C     NAC   MAXIMUM LAG                                                 ARI02130
C     R     AUTOCORRELATION FUNCTION OF NAC VALUES                      ARI02140
C     SER  AUTOCOVARIANCE FUNCTION OF NAC VALUES                        ARI02150
C     DM    MEAN OF THE SERIES                                          ARI02160
C     DSD   STANDARD ERROR OF THE SERIES                                ARI02170
C     IEXIT IF NAC>= NOB IEXIT IS SET TO -1                             ARI02180
C           UNLESS THIS ONE ERROR IS DETECTED IEXIT                     ARI02190
C           CONTAINS ZERO ON EXIT                                       ARI02200
C                                                                       ARI02210
C-----                                                                  ARI02220
C                                                                       ARI02230
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION C(NOB),R(NAC),SER(NAC)                                  ARI02240
      IEXIT=0                                                           ARI02250
      IF(NOB-NAC) 100,100,20                                            ARI02260
   20 DIV=NOB                                                           ARI02270
      DM=RMEAN(C,NOB)                                                   ARI02280
      DENOM=CPROXY(C,DM,C,DM,NOB)                                       ARI02290
      DSD=DSQRT(DENOM/DIV)                                              ARI02300
      DO 30 K=1,NAC                                                     ARI02310
      M=NOB-K                                                           ARI02320
      HNUM=CPROXY(C(1),DM,C(K+1),DM,M)                                  ARI02330
      SER(K)=HNUM/DIV                                                   ARI02340
      R(K)=HNUM/DENOM                                                   ARI02350
   30 CONTINUE                                                          ARI02360
      NAC1=NAC+1                                                        ARI02370
      DO 40 K=1,NAC                                                     ARI02380
      M=NAC1-K+1                                                        ARI02390
      R(M)=R(M-1)                                                       ARI02400
      SER(M)=SER(M-1)                                                   ARI02410
   40 CONTINUE                                                          ARI02420
      R(1)=1.0                                                          ARI02430
      SER(1)=DSD*DSD                                                    ARI02440
      RETURN                                                            ARI02450
  100 IEXIT=-1                                                          ARI02460
      RETURN                                                            ARI02470
      END                                                               ARI02480


      SUBROUTINE SMEADL(X,N,XMEAN)                                      INE13820
C     MEAN DELETION                                                     INE13850
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(N)                                                    INE13870
      AN=N                                                              INE13880
      XMEAN=SUMF(X,N)/AN                                                INE13890
      DO 10 I=1,N                                                       INE13900
   10 X(I)=X(I)-XMEAN                                                   INE13910
      RETURN                                                            INE13920
      END                                                               INE14030


      REAL*8  FUNCTION QTEST(R, NAC, NOB)
      IMPLICIT  REAL*8 (A - H , O - Z)
      DIMENSION  R(NAC)
      NAC1  =  NAC + 1
      SUM  =  0D0
      DO  1  K  = 2 ,  NAC1
1     SUM  =  SUM  +  R(K) * R(K) / DBLE(NOB - K + 1)  
      QTEST = DBLE(NOB) * DBLE(NOB + 1) * SUM
      RETURN
      END
   

	 real*8 function  gammad(x  ,  p  ,  ifault)

c    algorithm AS 239 Applied Statistics (1988) Vol. 37, no. 3

c    computation of the Incomplete Gamma Integral
c    G(x , p)  =  (1 / Gamma(p))  Int{0 , x} t^(p - 1) exp(-t) dt

	  integer  ifault
	  real*8   pn1, pn2, pn3, pn4, pn5, pn6, x, tol, oflo, xbig,
     *             arg, c, rn, p, a , b, one, zero, alogam,
     *             an, two,  elimit, plimit, alnorm, three, nine
	  intrinsic  dabs, dlog, dexp, dsqrt, dmin1
	  external    alogam,   alnorm
	  data zero, one, two, oflo, three, nine, tol, plimit, xbig,
     *  elimit/0.0,1.0,2.0,1.0E30,3.0,9.0,1.0E-7,1000.0,1.0E6,-88.0E0/

	    gammad   =   zero

c      Check that we have valid values for X and P

	 if(p.le.zero.or.x.lt.zero)   then
	      ifault  =   1
	      return
	 endif
	 ifault  =   0
	 if(x  .eq.  zero)   then
	      gammad  =  zero
	      return
	 endif

c      Use  a Normal  approximation if P  .gt.  PLIMIT

	  if(p  .gt.  plimit)   then
      pn1= three* dsqrt(p) * ((x/p)**(one/three) + one/(nine * p) - one)
	  gammad =   alnorm(pn1  ,  .false.)
	     return
	  endif

c     If  X is extremely large compared to  P then set GAMMAD   to  ONE

	  if(x  .gt. xbig)  then
	       gammad  =   one
	       return
	  endif

	 if(x.le.one  .or.  x.lt.p) then

c     Use Pearson's series expansion
c     (Note that P is not large enough to force overflow in ALOGAM)
c     No need to test IFAULT on exit since P .gt. zero

	 arg  =  p * dlog(x) - x - alogam(p + one , ifault)
	 c    =   one
	 gammad =    one
	 a   =   p
40       a   =    a   +   one
	 c  =   c * x / a
	 gammad   =   gammad  +   c
	 if(c  .gt.   tol)    goto    40
	 arg  =   arg  +  dlog(gammad)
	 gammad    =    zero
	 if(arg  .ge.   elimit)   gammad  =   dexp(arg)

       else

c      Use  a  continued  fraction  expansion

	 arg  =  p * dlog(x) - x - alogam(p  ,   ifault)
	 a =   one  -  p
	 b  =   a  +  x  +  one
	 c   =   zero
	 pn1  =   one
	 pn2   =   x
	 pn3  = x  +  one
	 pn4  =   x * b
	 gammad  =   pn3 / pn4
60       a  =  a  +  one
	 b  =   b   +   two
	 c   =  c  +  one
	 an  =    a * c
	 pn5  =   b * pn3  -  an * pn1
	 pn6 =   b * pn4  -  an * pn2
	 if(dabs(pn6)  .gt.  zero)    then
	     rn  =  pn5 / pn6
	    if(dabs(gammad - rn) .le. dmin1(tol  ,  tol * rn))  goto  80
	     gammad  =   rn
	 endif

	 pn1  =   pn3
	 pn2  =  pn4
	 pn3   =   pn5
	 pn4   =   pn6
	 if(dabs(pn5)  .ge.  oflo)    then

c          Re-scale terms in continued fraction if terms are large

	     pn1  =  pn1 / oflo
	     pn2 =   pn2 / oflo
	     pn3  =   pn3 / oflo
	     pn4 =  pn4 / oflo
	 endif
	 goto   60
80      arg  =   arg  +  dlog(gammad)
	gammad   =   one
	if(arg  .ge.  elimit)  gammad  =  one  -  dexp(arg)
      endif

	 end


	      real*8  function  alnorm(x  ,   upper)

c             algorithm AS 66 Applied Statistics (1973) Vol. 22, p. 424

c             evaluates the tail area of the standardized normal curve
c             from x to infinity if upper is .true. or
c             from minus infinity to x if upper is .false.

	  real*8 ltone , utzero , zero , half , one , con , a1 , a2 , a3 ,
     $   a4 , a5 , a6 , a7 , b1 , b2 , b3 , b4 , b5 , b6 , b7 , b8 , b9,
     $   b10 , b11 , b12 , x , y , z , zexp
	  logical   upper  ,   up

c           ltone and utzero must be set to suit the particular computer
c           (see introductory text)

	    data  ltone  ,   utzero / 7.0  ,  18.66 /
	    data  zero , half , one , con / 0.0 , 0.5 , 1.0 , 1.28 /
	    data              a1,              a2,                a3,
     $                        a4,              a5,                a6,
     $                        a7
     $        /   0.398942280444,  0.399903438504,     5.75885480458,
     $             29.8213557808,   2.62433121679,     48.6959930692,
     $             5.92885724438  /
	    data              b1,              b2,                  b3,
     $                        b4,              b5,                  b6,
     $                        b7,              b8,                  b9,
     $                       b10,             b11,                 b12
     $         /  0.398942280385,       3.8052E-8,       1.00000615302,
     $             3.98064794E-4,   1.98615381364,      0.151679116635,
     $             5.29330324926,    4.8385912808,       15.1508972451,
     $            0.742380924027,    30.789933034,       3.99019417011 /

	       zexp(z)    =     exp(z)

	       up   =    upper
	       z    =  x
	       if(z  .ge.  zero)     goto   10
	       up   =   .not.  up
	       z      =    -z
10      if(z .le. ltone .or. up . and. z .le. utzero)   goto   20
	       alnorm   =   zero
	       goto     40
20             y  =   half  *  z   *  z
	   if(z  .  gt.    con)    goto    30

      alnorm = half - z*(a1 - a2*y/(y + a3 - a4/(y + a5 + a6/(y + a7))))
		  goto    40

30    alnorm = b1 * zexp( -y) / (z - b2 + b3 / (z + b4 + b5 / (z -
     $   b6 + b7 / (z + b8 - b9 / (z + b10 + b11 / (z + b12 ))))))

40           if(.not.   up)    alnorm   =   one  -   alnorm
		 return
		   end


	real*8 function ppchi2(p  ,  v  ,   g,  ifault)

c     algorithm AS 91 Applied Statistics (1975) vol. 24, p. 385

c     to evaluate the percentage points of the chi-squared 
c     probability distribution function.
c     p  must lie in the range 0.000002 to  0.999998,
c     v  must be positive,
c     g  must be supplied and should be equal to  ln(gamma(v/2.0))

c       real p, v, g, gammds, ppnd,  aa, e , zero, half, one , two,
       real*8 p, v, g, gammad, ppnd16,  aa, e , zero, half, one , two,
     $   three,  six , pmin, pmax, c1, c2, c3, c4, c5, c6, c7, c8,
     $  c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20,
     $   c21, c22, c23, c24, c25, c26, c27, c28, c29, c30, c31,
     $   c32, c33, c34, c35, c36, c37, c38,  a , b,  c, ch , p1, p2,
     $   q, s1, s2 , s3,  s4,  s5,  s6, t, x  ,   xx,
     $   zabs,  zexp  ,  zlog  ,   zsqrt

c         aa  =   ln(2)     ;     c2   =   2/9
c    e = 1.5E-5 is replacing e = 0.5E-6 to keep the routine away from
c    looping indefinitely due to lack of precision  

       data             aa  ,         e  ,     pmin,        pmax
     $       /0.6931471806 ,     1.5e-5 ,  0.000002 ,    0.999998/
c     $       /0.6931471806 ,     0.5e-6 ,  0.000002 ,    0.999998/
       data  zero,  half, one, two,   three,   six
     $      /0.0  ,  0.5  ,  1.0  ,   2.0  ,  3.0  ,   6.0/
       data       c1,      c2,      c3,      c4,      c5,       c6,
     $            c7,      c8,      c9,     c10,     c11,      c12,
     $           c13,     c14,     c15,     c16,     c17,      c18,
     $           c19,     c20,     c21,     c22,     c23,      c24,
     $           c25,     c26,     c27,     c28,     c29,      c30,
     $           c31,     c32,     c33,     c34,     c35,      c36,
     $           c37,     c38/
     $          0.01, 0.222222,   0.32,     0.4,    1.24,      2.2,
     $          4.67,     6.66,   6.73,   13.32,    60.0,      70.0,
     $         84.0,     105.0,  120.0,   127.0,   140.0,     175.0,
     $        210.0,     252.0,  264.0,   294.0,   346.0,     420.0,
     $        462.0,     606.0,  672.0,   707.0,   735.0,     889.0,
     $        932.0,     966.0, 1141.0,  1182.0,  1278.0,    1740.0,
     $       2520.0,    5040.0/

	   zabs(x)   =    dabs(x)
	   zexp(x)   =   dexp(x)
	   zlog(x)   =   dlog(x)
	   zsqrt(x)   =   dsqrt(x)

c           test arguments and initialize

	   ppchi2  =   -one
	   ifault   =  1
	   if(p.lt.pmin.or.p.gt.pmax)   return
	   ifault   =   2
	   if  (v.le.zero)   return
	   ifault   =     0
	   xx   =   half  *   v
	   c  =   xx  -   one

c           starting approximation for small chi-squared

	   if(v  .ge.   -c5 * zlog(p))    goto  1
	   ch = (p * xx *zexp(g + xx * aa)) ** (one / xx)
	   if(ch .lt. e)   goto  6
	   goto     4

c          starting approximation for v less than or equal to 0.32 

1         if(v  .gt.   c3)    goto   3
	  ch  =    c4
	  a  =   zlog(one  -  p)
2          q   =    ch
	  p1  =  one  +  ch * (c7 +  ch)
	  p2  =  ch *  (c9 + ch * (c8  +  ch))
	  t  =  -half + (c7 + two * ch)/ p1 - (c9 + ch * (c10  +
     $       three * ch)) / p2
	  ch = ch - (one - zexp(a + g + half * ch + c * aa) *
     $       p2 / p1) /  t
	 if(zabs(q / ch - one) .gt. c1)    goto   2
	   goto  4

c      call to algorithm AS 111 - note that p has been tested above

3          x  =    ppnd16(p  ,    if1)

c       starting approximation using Wilson and Hilferty estimate

	     p1  =   c2  /   v
	     ch =  v * (x * zsqrt(p1) + one - p1) ** 3

c       starting approximation for p tending to 1

	    if(ch .gt.  c6 * v + six)
     $  ch = -two * (zlog(one - p) - c * zlog(half * ch) + g)

c  call to algorithm AS 147 and calculation of seven term Taylor series
c   the real function gammds(y,p,ifault) computes the incomplete gamma 
c  integral G(y,p)= (1/Gamma(p)) Int{0,y} u^(p-1) exp(-u) du (Lau,1980)
c  gammds is replaced here by the algorithm AS 239 (Shea, 1988)
c  real function gammad(x,p,ifault) x : the value of the upper integral
c  limit x, p : the value of the parameter p, ifault :a fault indicator

4       q   =     ch
       p1   =   half * ch
c       p2  =   p   -   gammds(p1  ,    xx,    if1)
	p2  =   p    -   gammad(p1  ,    xx,    if1)
       if(  if1  .eq.   0)    goto   5
       ifault   =     3
       return
5       t = p2 * zexp(xx * aa + g + p1 - c * zlog(ch))
	b  =   t / ch
	a    =  half * t -  b * c
       s1 = (c19 + a * (c17 + a* (c14 + a *(c13 +  a* (c12  +
     $    c11 * a)))))  /  c24
       s2 =  (c24 + a * (c29 + a * (c32 + a * (c33 + c35 *
     $     a))))  /  c37
       s3  =  (c19 + a * (c25 + a * (c28 + c31 * a))) / c37
       s4 = (c20 + a * (c27 + c34 * a) + c * (c22 + a * (c30 +
     $  c36 * a))) /  c38
       s5 = (c13 + c21 * a + c * (c18 + c26 * a)) / c37
       s6  =  (c15 + c * (c23 + c16 * c)) / c38
       ch = ch + t * (one + half * t * s1 - b * c * (s1 - b *
     $   (s2 - b * (s3 - b * (s4 - b * (s5 - b * s6))))))
	if(zabs(q / ch - one) .gt.  e)    goto   4

6        ppchi2    =    ch
	 return
	 end


      REAL*8 FUNCTION ALOGAM(X,IFAULT)                                                 
      implicit real*8(a - h , o - z)
C                                                                               
C      ALGORITHM ACM 291, COMM. ACM. (1966) VOL.9, P.684                        
C                                                                               
C      EVALUATES NATURAL LOGARITHM OF GAMMA(X)                                  
C      FOR X GREATER THAN ZERO                                                  
C                                                                               
C                                                                               
C      THE FOLLOWING CONSTANTS ARE ALOG(2PI)/2,                                 
C      1/1680, 1/1260, 1/360  AND 1/12                                          
C                                                                               
      DATA A1,A2,A3,A4,A5                                                       
     +  /0.918938533204673, 0.000595238095238,                        
     +   0.000793650793651, 0.002777777777778,                        
     +   0.083333333333333/                                                     
      DATA HALF,ZERO,ONE,SEVEN/0.5,0.0,1.0,7.0/             
C                                                                               
      ZLOG(F)=DLOG(F)                                                           
C                                                                               
      ALOGAM=ZERO                                                               
      IFAULT=1                                                                  
      IF(X.LE.ZERO)RETURN                                                       
      IFAULT=0                                                                  
      Y=X                                                                       
      F=ZERO                                                                    
      IF(Y.GE.SEVEN) GOTO 30                                                    
      F=Y                                                                       
10    Y=Y+ONE                                                                   
      IF(Y.GE.SEVEN) GOTO 20                                                    
      F=F*Y                                                                     
      GOTO 10                                                                   
20    F=-ZLOG(F)                                                                
30    Z=ONE/(Y*Y)                                                               
      ALOGAM=F+(Y-HALF)*ZLOG(Y)-Y+A1+(((-A2*Z+A3)*Z-A4)*Z+A5)/Y                 
      RETURN                                                                    
      END                                                                       


        DOUBLE PRECISION FUNCTION PPND16 (P, IFAULT)
C
C       ALGORITHM AS241  APPL. STATIST. (1988) VOL. 37, NO. 3
C
C       Produces the normal deviate Z corresponding to a given lower
C       tail area of P; Z is accurate to about 1 part in 10**16.
C
C       The hash sums below are the sums of the mantissas of the
C       coefficients.   They are included for use in checking
C       transcription.
C
        DOUBLE PRECISION ZERO, ONE, HALF, SPLIT1, SPLIT2, CONST1,
     *          CONST2, A0, A1, A2, A3, A4, A5, A6, A7, B1, B2, B3,
     *          B4, B5, B6, B7,
     *          C0, C1, C2, C3, C4, C5, C6, C7, D1, D2, D3, D4, D5,
     *          D6, D7, E0, E1, E2, E3, E4, E5, E6, E7, F1, F2, F3,
     *          F4, F5, F6, F7, P, Q, R
        PARAMETER (ZERO = 0.D0, ONE = 1.D0, HALF = 0.5D0,
     *          SPLIT1 = 0.425D0, SPLIT2 = 5.D0,
     *          CONST1 = 0.180625D0, CONST2 = 1.6D0)
C
C       Coefficients for P close to 0.5
C
        PARAMETER (A0 = 3.38713 28727 96366 6080D0,
     *             A1 = 1.33141 66789 17843 7745D+2,
     *             A2 = 1.97159 09503 06551 4427D+3,
     *             A3 = 1.37316 93765 50946 1125D+4,
     *             A4 = 4.59219 53931 54987 1457D+4,
     *             A5 = 6.72657 70927 00870 0853D+4,
     *             A6 = 3.34305 75583 58812 8105D+4,
     *             A7 = 2.50908 09287 30122 6727D+3,
     *             B1 = 4.23133 30701 60091 1252D+1,
     *             B2 = 6.87187 00749 20579 0830D+2,
     *             B3 = 5.39419 60214 24751 1077D+3,
     *             B4 = 2.12137 94301 58659 5867D+4,
     *             B5 = 3.93078 95800 09271 0610D+4,
     *             B6 = 2.87290 85735 72194 2674D+4,
     *             B7 = 5.22649 52788 52854 5610D+3)
C       HASH SUM AB    55.88319 28806 14901 4439
C
C       Coefficients for P not close to 0, 0.5 or 1.
C
        PARAMETER (C0 = 1.42343 71107 49683 57734D0,
     *             C1 = 4.63033 78461 56545 29590D0,
     *             C2 = 5.76949 72214 60691 40550D0,
     *             C3 = 3.64784 83247 63204 60504D0,
     *             C4 = 1.27045 82524 52368 38258D0,
     *             C5 = 2.41780 72517 74506 11770D-1,
     *             C6 = 2.27238 44989 26918 45833D-2,
     *             C7 = 7.74545 01427 83414 07640D-4,
     *             D1 = 2.05319 16266 37758 82187D0,
     *             D2 = 1.67638 48301 83803 84940D0,
     *             D3 = 6.89767 33498 51000 04550D-1,
     *             D4 = 1.48103 97642 74800 74590D-1,
     *             D5 = 1.51986 66563 61645 71966D-2,
     *             D6 = 5.47593 80849 95344 94600D-4,
     *             D7 = 1.05075 00716 44416 84324D-9)
C       HASH SUM CD    49.33206 50330 16102 89036
C
C       Coefficients for P near 0 or 1.
C
        PARAMETER (E0 = 6.65790 46435 01103 77720D0,
     *             E1 = 5.46378 49111 64114 36990D0,
     *             E2 = 1.78482 65399 17291 33580D0,
     *             E3 = 2.96560 57182 85048 91230D-1,
     *             E4 = 2.65321 89526 57612 30930D-2,
     *             E5 = 1.24266 09473 88078 43860D-3,
     *             E6 = 2.71155 55687 43487 57815D-5,
     *             E7 = 2.01033 43992 92288 13265D-7,
     *             F1 = 5.99832 20655 58879 37690D-1,
     *             F2 = 1.36929 88092 27358 05310D-1,
     *             F3 = 1.48753 61290 85061 48525D-2,
     *             F4 = 7.86869 13114 56132 59100D-4,
     *             F5 = 1.84631 83175 10054 68180D-5,
     *             F6 = 1.42151 17583 16445 88870D-7,
     *             F7 = 2.04426 31033 89939 78564D-15)
C       HASH SUM EF    47.52583 31754 92896 71629
C
        IFAULT = 0
        Q = P - HALF
        IF (ABS(Q) .LE. SPLIT1) THEN
          R = CONST1 - Q * Q
          PPND16 = Q * (((((((A7 * R + A6) * R + A5) * R + A4) * R + A3)
     *                  * R + A2) * R + A1) * R + A0) /
     *                (((((((B7 * R + B6) * R + B5) * R + B4) * R + B3)
     *                  * R + B2) * R + B1) * R + ONE)
          RETURN
        ELSE
          IF (Q .LT. ZERO) THEN
            R = P
          ELSE
            R = ONE - P
          END IF
          IF (R .LE. ZERO) THEN
            IFAULT = 1
            PPND16 = ZERO
            RETURN
          END IF
          R = SQRT(-LOG(R))
          IF (R .LE. SPLIT2) THEN
            R = R - CONST2
            PPND16 = (((((((C7 * R + C6) * R + C5) * R + C4) * R + C3)
     *                  * R + C2) * R + C1) * R + C0) /
     *               (((((((D7 * R + D6) * R + D5) * R + D4) * R + D3)
     *                  * R + D2) * R + D1) * R + ONE)
          ELSE
            R = R - SPLIT2
            PPND16 = (((((((E7 * R + E6) * R + E5) * R + E4) * R + E3)
     *                  * R + E2) * R + E1) * R + E0) /
     *               (((((((F7 * R + F6) * R + F5) * R + F4) * R + F3)
     *                  * R + F2) * R + F1) * R + ONE)
          END IF
          IF (Q .LT. ZERO) PPND16 = - PPND16
          RETURN
        END IF
        END


      SUBROUTINE VSUNIF(ISEME,P2)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 CC0,CC1,CC2,CC3,CC4,P2
      DATA CC2/16807.D0/,CC3/2147483647.D0/
      SAVE
      CC1=ISEME
      CC1=CC1*CC2
      CC4=DMOD(CC1,CC3)
      ISEME=CC4
      CC0=CC4
      P2=CC0/CC3
      RETURN
      END


      REAL*8 function  random(l)

c        algorithm as 183 Appl. Statist. (1982) Vol. 31, no. 2
c
c        returns a pseudo-random number rectangularly distributed 
c        between  0  and 1.
c
c        ix, iy and iz should be set to integer values between 
c        1 and 30000 before first entry
c
c        integer arithmetic up to 30323  is required

      IMPLICIT REAL*8 (A -H , O - Z)
	common /rand/  ix, iy,  iz
	ix = 171 * mod(ix, 177) - 2 * (ix / 177)
	iy = 172 * mod(iy, 176) - 35 * (iy / 176)
	iz = 170 * mod(iz, 178) - 63 * (iz / 178)

	if (ix .lt. 0) ix = ix + 30269
	if (iy .lt. 0) iy = iy + 30307
	if (iz .lt. 0) iz = iz + 30323

c        if integer arithmetic up to 5212632 is available, 
c        the preceding 6 statements may be replaced by
c
c        ix = mod(171 * ix, 30269)
c        iy = mod(172 * iy, 30307) 
c        iz = mod(170 * iz, 30323)
c
c        on some machines, this may slightly increase
c        the speed. the results will be identical.

	random  = DMOD(DBLE(ix) / 30269D0 + DBLE(iy) / 30307D0 +
     *                 DBLE(iz) / 30323D0, 1D0)

	return
	end


	real*8 function uniform()
c
c	Generate uniformly distributed random numbers using the 32-bit
c	generator from figure 3 of:
c	L'Ecuyer, P. Efficient and portable combined random number
c	generators, C.A.C.M., vol. 31, 742-749 & 774-?, June 1988.
c
c	The cycle length is claimed to be 2.30584E+18
c
c	Seeds can be set by calling the routine set_uniform
c
c	It is assumed that the Fortran compiler supports long variable
c	names, and integer*4.
c
	integer*4 z, k, s1, s2
	common /unif_seeds/ s1, s2
	save /unif_seeds/
c
	k = s1 / 53668
	s1 = 40014 * (s1 - k * 53668) - k * 12211
	if (s1 .lt. 0) s1 = s1 + 2147483563
c
	k = s2 / 52774
	s2 = 40692 * (s2 - k * 52774) - k * 3791
	if (s2 .lt. 0) s2 = s2 + 2147483399
c
	z = s1 - s2
	if (z .lt. 1) z = z + 2147483562
c
	uniform = z / 2147483563.
	return
	end


	subroutine set_uniform(seed1, seed2)
c
c	Set seeds for the uniform random number generator.
c
	integer*4 s1, s2, seed1, seed2
	common /unif_seeds/ s1, s2
	save /unif_seeds/

	s1 = seed1
	s2 = seed2
	return
	end


