C      PROGRAM XD2TEST.FOR
C      DRIVER FOR THE ROUTINE D2TEST:
C      TEST FOR SQUARED DISTANCE BETWEEN ESTIMATED ARMA MODEL PARAMETERS
C      AND THEORETICAL ARMA MODEL PARAMETERS

      PARAMETER(MPIGRE=10, MP=3, MQ=3, MV=MP+MQ)
      IMPLICIT REAL*8 (A - H, O-Z)
      CHARACTER*70 PNAME
      DIMENSION PHI(MPIGRE), THETA(MPIGRE), VPHI(MPIGRE), YNVPHI(MPIGRE)
     +, VTHE(MPIGRE), YNVTHE(MPIGRE), PWEIO(MPIGRE),TEMPY(MPIGRE,MPIGRE)
     +, XMATDE(MPIGRE, MPIGRE), XMCOV(MV,MV), OMEGA(MV,MV)
     +, BMAT(MPIGRE,MPIGRE)
     +, XLN(MPIGRE, MPIGRE),XILN(MPIGRE, MPIGRE),DELTAN(MPIGRE, MPIGRE)
     +, BHHB(MPIGRE),CHHC(MPIGRE),IIHP(MPIGRE),IIHQ(MPIGRE)

      OPEN(UNIT=5, FILE='xd2test.txt')
      read(5, *) np, nq, npi, nob
      if(np.gt.0) read(5, *) (phi(i), i=1,  np)
      if(nq.gt.0) read(5 , *) (theta(i),  i=1 ,  nq)
      read(5, *) a1, xco, alpha
      READ(5 ,100)  pname
100	format(A70)
      CLOSE(UNIT=5)

      open(unit  =  6, file = pname)

      NV = NP  + NQ

C     Corduas, M. (2000) La metrica Autoregressiva tra modelli ARIMA:
C      una procedura in linguaggio GAUSS. Quaderni di Statistica, Vol. 2

      CALL D2TEST(PHI, THETA, NPI, NP, NQ, VPHI, YNVPHI, MPIGRE, XMATDE
     +,VTHE,YNVTHE,XLN,XILN,XMCOV,MV,NV,NOB,PWEIO,BMAT,DELTAN,TEMPY
     +,OMEGA,T1,T2,T3,AHAT,BHAT,XNU,ALPHA,PX,BHHB,CHHC,IIHP,IIHQ,A1,XCO)

      close(unit =  6)

      STOP
       END


      SUBROUTINE D2TEST(PHI,THETA,NPI,NP,NQ,VPHI,YNVPHI,MX,XMATDE
     +,VTHE,YNVTHE,XLN,XILN,XMCOV,MV,NV,NOB,PWEIO,BMAT,DELTAN,TEMPY
     +,OMEGA,T1,T2,T3,AHAT,BHAT,XNU,ALPHA,PX,BHHB,CHHC,IIHP,IIHQ,A1,XCO)

C@:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://////////
C
CNota: La circolazione e diffusione dei seguenti programmi e' libera e 
Cgratuita purche' si citi correttamente ed integralmente la fonte.  
CCorduas M. (2000), La metrica Autoregressiva tra modelli ARIMA: 
Cuna procedura in linguaggio GAUSS, Quaderni di Statistica, 2, 1-37
CResta dell'utente ogni responsabilita' per i danni derivanti dall'
Cutilizzo dei programmi qui descritti.
C
C Corduas, M. (2000)
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::://///////// @

      IMPLICIT REAL*8 (A - H, O-Z)
      DIMENSION PHI(NPI), THETA(NPI), VPHI(NPI), YNVPHI(NPI)
     +, XMATDE(MX,NPI),VTHE(NPI),YNVTHE(NPI),XLN(MX,NPI),XILN(MX,NPI)
     +, PWEIO(MX), BMAT(MX, NPI), DELTAN(MX, NPI), TEMPY(MX, NPI)
     +, XMCOV(MV,NV), OMEGA(MV,NV)
     +, BHHB(NPI),CHHC(NPI),IIHP(NPI),IIHQ(NPI)
      DATA  EPS/8.43D-37/

C     Parameters variance-covariance matrix V->XMCOV computation
C     DELTAN and inverse L->XLENNE matrix computation
C     Pi-weights derivatives matrix BMAT computation
C     Vector v->VPHI computation

      LPRINT =  6
      WRITE(LPRINT,  101)
101   FORMAT(1H  ,'Enter D2TEST ...')
      WRITE(LPRINT, 102)
102   FORMAT(1H   ,'PHI ')
      WRITE(LPRINT, 1000) (PHI(I) , I = 1 , NP)
      WRITE(LPRINT, 103)
103   FORMAT(1H   ,'THETA ')
      WRITE(LPRINT, 1000) (THETA(I) , I = 1 , NQ)
      WRITE(LPRINT, 1001)      

      I =  1
      VPHI(I)  =  -1.0
      IF(NP  .GT.  0)  THEN
      DO  10  II =1  ,  NP
      I  =  I +  1
      VPHI(I)  =  PHI(II)
10    CONTINUE
      ENDIF
      IF(I  .LT. NPI)  THEN
      I1  =  I +  1
      DO  11  II  =  I1,  NPI
11    VPHI(II)  =   0.0
      ENDIF

      CALL  POLINV(PHI, NP, YNVPHI, NPI, XCO, A1)

C     XMATDE matrix for XMCOV computation: autoregressive part

      DO  12  I  =1  ,  NPI
      DO  12  J =  1  ,  NPI
12    XMATDE(I , J) =  0.0
      IF(NP .GT.  0)  THEN
      DO  13  J =  1 ,  NP
      I1  =  J +  1
      II  =  0
      DO  14  I  =  I1  , NPI
      II  =  II  + 1
14    XMATDE(I , J) =   YNVPHI(II)
13    CONTINUE
C      ELSE
C      XMATDE(2,1) =  1.0
      ENDIF

      WRITE(LPRINT, 104)
104   FORMAT(1H   , 'VPHI ')
      WRITE(LPRINT, 1000)  (VPHI(I), I=1  ,  NPI)
      WRITE(LPRINT, 105)
105   FORMAT(1H   , 'YNVPHI ')
      WRITE(LPRINT, 1000)  (YNVPHI(I), I=1  ,  NPI)
      WRITE(LPRINT, 106)
106   FORMAT(1H   , 'XMATDE ')
      DO  901  I  =1  ,  NPI
901   WRITE(LPRINT, 1000)  (XMATDE(I , J), J=1  ,  NPI)
      WRITE(LPRINT, 1001)

      I =  1
      VTHE(I)  =  1.0
      IF(NQ  .GT.  0)  THEN
      DO  20  II =1  ,  NQ
      I  =  I +  1
      VTHE(I)  =  -THETA(II)
20    CONTINUE
      ENDIF
      IF(I  .LT. NPI)  THEN
      I1  =  I +  1
      DO  21  II  =  I1,  NPI
21    VTHE(II)  =   0.0
      ENDIF

      CALL  POLINV(THETA, NQ, YNVTHE, NPI, XCO, A1)

C     XMATDE matrix for XMCOV computation: moving average part

C      NP1 = MAX0(2, NP + 1)
      NP1  =  NP  + 1
      NP2  =  NP1 + NQ  - 1
      IF(NQ .GT.  0)  THEN
      I1  =  1
      DO  23  J =  NP1 ,  NP2
      I1  =  I1 +  1
      II  =  0
      DO  24  I  =  I1  , NPI
      II  =  II  + 1
24    XMATDE(I , J) =   -YNVTHE(II)
23    CONTINUE
C      ELSE
C      XMATDE(2,NP1) =  -1.0
      ENDIF

      WRITE(LPRINT, 204)
204   FORMAT(1H   , 'VTHE ')
      WRITE(LPRINT, 1000)  (VTHE(I), I=1  ,  NPI)
      WRITE(LPRINT, 205)
205   FORMAT(1H   , 'YNVTHE ')
      WRITE(LPRINT, 1000)  (YNVTHE(I), I=1  ,  NPI)
      WRITE(LPRINT, 206)
206   FORMAT(1H   , 'XMATDE ')
      DO  902  I  =1  ,  NPI
902   WRITE(LPRINT, 1000)  (XMATDE(I , J), J=1  ,  NPI)
      WRITE(LPRINT, 1001)

C     Parameters variance covariance matrix V = inv(U'U / n)
C     ->XMCOV = (XMATDE'XMADTE / N)^-1

      DO 25  I  = 1 ,  NV
      DO  25  J  =  1  ,  NV
      ELEH =  0.0
      DO  26  IJ  =  1  ,  NPI
26    ELEH =  ELEH + XMATDE(IJ, I) * XMATDE(IJ, J)
      XMCOV(I, J)  =  ELEH 
25    CONTINUE

      WRITE(LPRINT, 210)
210   FORMAT(1H  ,'XMCOV ')
      DO  905  I  =1  ,  NV
905   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)

      CALL DGJR(XMCOV,NV,MV,EPS,MSING,BHHB,CHHC,IIHP,IIHQ)

      WRITE(LPRINT, 209)
209   FORMAT(1H  ,'inv(XMCOV) ')
      DO  910  I  =1  ,  NV
910   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)

      DO 211 I = 1 ,  NV
      DO  211  J  =1  ,  NV
211   XMCOV(I , J)  =  XMCOV(I , J) / DBLE(NOB)

      WRITE(LPRINT, 208) NOB
208   FORMAT(1H  ,'NOB ', I6)
      WRITE(LPRINT, 250)
250   FORMAT(1H  ,'inv(XMCOV)/NOB ')
      DO  950  I  =1  ,  NV
950   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)
      WRITE(LPRINT, 1001)

C     Build matrix Lenne = lowmat(toeplitz(vthe))
C     and its inverse ILenne

      DO  32  I  =1  ,  NPI
      DO  32  J =  1  ,  NPI
32    XLN(I , J) =  0.0
      DO 33  J  =1  ,  NPI
      J1  =  J
      II  =  0
      DO  34  I  =  J1 , NPI
      II  =  II +  1
34    XLN(I , J)  =  VTHE(II)
33    CONTINUE
      DO  35  I  =1  ,  NPI
      DO  35  J =  1  ,  NPI
35    XILN(I , J) =  XLN(I , J)
      CALL DGJR(XILN,NPI,MX,EPS,MSING,BHHB,CHHC,IIHP,IIHQ)

      WRITE(LPRINT, 306)
306   FORMAT(1H   , 'Lenne->XLN ')
      DO  903  I  =1  ,  NPI
903   WRITE(LPRINT, 1000)  (XLN(I , J), J=1  ,  NPI)
      WRITE(LPRINT, 307)
307   FORMAT(1H   , 'ILenne->XILN ')
      DO  904  I  =1  ,  NPI
904   WRITE(LPRINT, 1000)  (XILN(I , J), J=1  ,  NPI)
      WRITE(LPRINT, 1001)
      		
C     Matrix B->Bmat computation

      DO  41  I = 1  ,  NPI
      ELEH  =  0.0
      DO  42  J  = 1   ,  NPI
42    ELEH  =  ELEH  + XILN(I, J) * VPHI(J)
      PWEIO(I)  =  ELEH
41    CONTINUE

      WRITE(LPRINT, 401)
401   FORMAT(1H   ,'Pweio ')
      WRITE(LPRINT, 1000) (PWEIO(I) , I = 1  ,  NPI)

      DO  44  I  =1  ,  NPI
      DO  44  J =  1  ,  NPI
44    BMAT(I , J) =  0.0

      IF(NP  .GT.  0)  THEN
      JJ =  1
      DO  43  J  =  1  ,  NP
      JJ =  JJ +  1
      DO  45   I  =  1  ,  NPI
45    BMAT(I , J) =  XILN(I , JJ)
43    CONTINUE
      ENDIF  

      WRITE(LPRINT, 402)
402   FORMAT(1H   , 'BMAT after autoregression ')
      DO  906  I  =1  ,  NPI
906   WRITE(LPRINT, 1000)  (BMAT(I , J), J=1  ,  NPI)

      WRITE(LPRINT, 403)
403   FORMAT(1H  ,'Building BMAT : MA part ')

      IF(NQ  .GT.  0)  THEN

      DO   46  J  = 1 ,  NQ

      DO   47  II  =  1  ,  NPI
      DO  47    IJ  =  1,  NPI
      IF(II  .EQ.  J + IJ) THEN
      DELTAN(II ,  IJ) =  -1.0
      ELSE
      DELTAN(II ,  IJ) =  0.0
      ENDIF
47    CONTINUE

      WRITE(LPRINT, 404) J
404   FORMAT(1H   , 'MA param n. ', I5)
      WRITE(LPRINT, 405) 
405   FORMAT(1H   , 'DELTAN ' )
      DO  907  I  =1  ,  NPI
907   WRITE(LPRINT, 1000)  (DELTAN(I , JI), JI =1  ,  NPI)
      
      DO  48  II  =  1 , NPI
      DO  48  JJ  =  1 ,  NPI
      ELEH  =  0.0
      DO   49  IJ =  1  ,  NPI
49    ELEH  = ELEH + XILN(II , IJ) * DELTAN(IJ , JJ)
      TEMPY(II ,  JJ) =  -ELEH
48    CONTINUE

      IJ  =  NP  + J
      DO  50  II  =  1 ,  NPI
      ELEH  =  0.0
      DO  51   JJ  =  1  ,  NPI
51    ELEH =  ELEH + TEMPY(II , JJ) * PWEIO(JJ)
      BMAT(II , IJ)  =  ELEH
50    CONTINUE

      WRITE(LPRINT, 406) 
406   FORMAT(1H   , 'BMAT in progress ... ' )
      DO  908  I  =1  ,  NPI
908   WRITE(LPRINT, 1000)  (BMAT(I , JI), JI =1  ,  NPI)

46    CONTINUE

      ENDIF

      WRITE(LPRINT, 407) 
407   FORMAT(1H   , 'BMAT ' )
      DO  909  I  =1  ,  NPI
909   WRITE(LPRINT, 1000)  (BMAT(I , JI), JI =1  ,  NPI)
      WRITE(LPRINT, 1001)

C     CALCTRACM0:--->CALCOLA LE TRACCE t1, t2, t3
C     INPUT: matrici B->BMAT e V->XMCOV ottenute per il modello M0
C     OUTPUT: tracce t1, t2, t3
C     H0: (pix-pi0) asympt N(0, Sigma)  Sigma = A B V0 B' A'
C     Qui A=I (identity matrix), B e V0 si riferiscono al modello M0
C     tr(Sigma^k)=tr[(B'B V)^k], k=1,2,3

      DO 55  I  = 1 ,  NV
      DO  55  J  =  1  ,  NV
      ELEH =  0.0
      DO  56  IJ  =  1  ,  NPI
56    ELEH =  ELEH + BMAT(IJ, I) * BMAT(IJ, J)
      TEMPY(I, J)  =  ELEH 
55    CONTINUE

      WRITE(LPRINT, 507) 
507   FORMAT(1H   , 'transpose(BMAT) BMAT ' )
      DO  917  I  =1  ,  NV
917   WRITE(LPRINT, 1000)  (TEMPY(I , J), J =1  , NV)

      DO  57  I =  1 ,  NV
      DO  57  J  =1  ,  NV
      ELEH  = 0.0
      DO  58  IJ  =  1  ,  NV
58    ELEH  =  ELEH +  TEMPY(I , IJ) * XMCOV(IJ , J)
      OMEGA(I , J)  =  ELEH
57    CONTINUE
      T1  =  0.0
      DO  59  I  = 1 , NV
59    T1  = T1  +  OMEGA(I , I)

      WRITE(LPRINT, 508) 
508   FORMAT(1H   , 'OMEGA = transpose(BMAT) BMAT XMCOV' )
      DO  918  I  =1  ,  NV
918   WRITE(LPRINT, 1000)  (OMEGA(I , J), J =1  , NV)
      WRITE(LPRINT, 518)  T1 
518   FORMAT(1H   , 'tr(OMEGA) ' , F12.6)

      DO  60  I =  1 ,  NV
      DO  60  J  =1  ,  NV
      ELEH  = 0.0
      DO  61  IJ  =  1  ,  NV
61    ELEH  =  ELEH +  OMEGA(I , IJ) * OMEGA(IJ , J)
      TEMPY(I , J)  =  ELEH
60    CONTINUE
      T2  =  0.0
      DO  62  I  = 1 , NV
62    T2  = T2  +  TEMPY(I , I)

      WRITE(LPRINT, 509) 
509   FORMAT(1H   , 'OMEGA^2' )
      DO  919  I  =1  ,  NV
919   WRITE(LPRINT, 1000)  (TEMPY(I , J), J =1  , NV)
      WRITE(LPRINT, 519)  T2 
519   FORMAT(1H   , 'tr(OMEGA^2) ' , F12.6)

      DO  63  I =  1 ,  NV
      DO  63  J  =1  ,  NV
      ELEH  = 0.0
      DO  64  IJ  =  1  ,  NV
64    ELEH  =  ELEH +  TEMPY(I , IJ) * OMEGA(IJ , J)
      DELTAN(I , J)  =  ELEH
63    CONTINUE
      T3  =  0.0
      DO  65  I  = 1 , NV
65    T3  = T3  +  DELTAN(I , I)

      WRITE(LPRINT, 510) 
510   FORMAT(1H   , 'OMEGA^3' )
      DO  920  I  =1  ,  NV
920   WRITE(LPRINT, 1000)  (DELTAN(I , J), J =1  , NV)
      WRITE(LPRINT, 520)  T3 
520   FORMAT(1H   , 'tr(OMEGA^3) ' , F12.6)
      WRITE(LPRINT, 1001)

      AHAT = T3 / T2
      BHAT =  T1 - (T2 * T2 / T3)
      XNU = (T2 * T2 * T2) / (T3 * T3)
      HHNI2  =  XNU / 2D0
      GGGG  =  ALOGAM(HHNI2 , IFAUL2)
      PPOINT  =  1D0  -  ALPHA
	PX = PPCHI2(PPOINT, XNU, GGGG, IFAULT) * AHAT + BHAT

      WRITE(LPRINT, 511) 
511   FORMAT(1H  ,'AHAT,BHAT,XNU,HHNI2,GGGG,ALPHA,PPOINT ')
      WRITE(LPRINT, 1000) AHAT, BHAT, XNU, HHNI2, GGGG, ALPHA, PPOINT
      WRITE(LPRINT, 512)  PX
512   FORMAT(1H  ,'Percentile ', F12.6)
      WRITE(LPRINT, 1001)

      WRITE(LPRINT, 107)
107   FORMAT(1H   ,'Exit D2TEST ...')

      RETURN
1000  FORMAT(1H  , 7F10.4)
1001  FORMAT(1H   ,'//'  )
      END


      SUBROUTINE  POLINV(PHI, NP, YNVPHI, NPI, XCO, A1)

C     Polynomial inversion:
C     (A1 + XCO * PHI(1) * B + ... + XCO * PHI(NP) * B^NP)^-1 =
C     A1 + YNVPHI(1) * B + ... + YNVPHI(NPI) * B^NPI

      IMPLICIT REAL*8 (A - H, O-Z)
      DIMENSION PHI(NP), YNVPHI(NPI)

      YNVPHI(1) =  A1
      YNVPHI(2)  =  -XCO * PHI(1)

      IF(NPI .GT.  2)  THEN
      DO   10  I  = 3 ,  NPI
      IJ  =  I  -  1
      YNVPHI(I)  =  -XCO * PHI(IJ)
      II  =  I  -  2
      DO  20  J  =1  ,  II
      JJ  =  II - J  + 2
20    YNVPHI(I) =  YNVPHI(I) - XCO * PHI(J) * YNVPHI(JJ)
10    CONTINUE
      ENDIF

      RETURN
      END


      SUBROUTINE DGJR(A,N,MM,EPS,MSING,B,C,P,Q)
C----     GAUSS-JORDAN-RUTISHAUSER MATRIX INVERSION WITH DOUBLE PIVOTING
      IMPLICIT REAL*8 (A - H , O - Z)
      INTEGER P,Q
      DIMENSION A(MM,N),B(N),C(N),P(N),Q(N)
      MSING=1
      DO 10 K=1,N
C----     DETERMINATION OF THE PIVOT ELEMENT
      PIVOT=0.0
      DO 20 I=K,N
      DO 20 J=K,N
      IF(DABS(A(I,J))-DABS(PIVOT)) 20,20,30
30    PIVOT=A(I,J)
      P(K)=I
      Q(K)=J
20    CONTINUE
      IF(DABS(PIVOT)-EPS) 40,40,50
C----     EXCHANGE OF THE PIVOTAL ROW WITH THE K-TH ROW
50    IF(P(K)-K) 60,80,60
60    DO 70 J=1,N
      L=P(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
70    A(K,J)=Z
C----     EXCHANGE OF THE PIVOTAL COLUMN WITH THE K-TH COLUMN
80    IF(Q(K)-K) 85,90,85
85    DO 100 I=1,N
      L=Q(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
100   A(I,K)=Z
90    CONTINUE
C----     JORDAN STEP
      DO 110 J=1,N
      IF(J-K) 130,120,130
120   B(J)=1.0/PIVOT
      C(J)=1.0
      GOTO 140
130   B(J)=-A(K,J)/PIVOT
      C(J)=A(J,K)
140   A(K,J)=0.0
110   A(J,K)=0.0
      DO 10 I=1,N
      DO 10 J=1,N
10    A(I,J)=A(I,J)+C(I)*B(J)
C----     REORDERING THE MATRIX
      DO 155 M=1,N
      K=N-M+1
      IF(P(K)-K) 160,170,160
160   DO 180 I=1,N
      L=P(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
180   A(I,K)=Z
170   IF(Q(K)-K) 190,155,190
190   DO 150 J=1,N
      L=Q(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
150   A(K,J)=Z
155   CONTINUE
151   RETURN
40    CONTINUE
      MSING=2
      GOTO 151
      END


	real*8 function ppchi2(p  ,  v  ,   g,  ifault)

c     algorithm AS 91 Applied Statistics (1975) vol. 24, p. 385

c     to evaluate the percentage points of the chi-squared 
c     probability distribution function.
c     p  must lie in the range 0.000002 to  0.999998,
c     v  must be positive,
c     g  must be supplied and should be equal to  ln(gamma(v/2.0))

c       real p, v, g, gammds, ppnd,  aa, e , zero, half, one , two,
       real*8 p, v, g, gammad, ppnd16,  aa, e , zero, half, one , two,
     $   three,  six , pmin, pmax, c1, c2, c3, c4, c5, c6, c7, c8,
     $  c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20,
     $   c21, c22, c23, c24, c25, c26, c27, c28, c29, c30, c31,
     $   c32, c33, c34, c35, c36, c37, c38,  a , b,  c, ch , p1, p2,
     $   q, s1, s2 , s3,  s4,  s5,  s6, t, x  ,   xx,
     $   zabs,  zexp  ,  zlog  ,   zsqrt

c         aa  =   ln(2)     ;     c2   =   2/9
c    e = 1.5E-5 is replacing e = 0.5E-6 to keep the routine away from
c    looping indefinitely due to lack of precision  

       data             aa  ,         e  ,     pmin,        pmax
     $       /0.6931471806 ,     1.5e-5 ,  0.000002 ,    0.999998/
c     $       /0.6931471806 ,     0.5e-6 ,  0.000002 ,    0.999998/
       data  zero,  half, one, two,   three,   six
     $      /0.0  ,  0.5  ,  1.0  ,   2.0  ,  3.0  ,   6.0/
       data       c1,      c2,      c3,      c4,      c5,       c6,
     $            c7,      c8,      c9,     c10,     c11,      c12,
     $           c13,     c14,     c15,     c16,     c17,      c18,
     $           c19,     c20,     c21,     c22,     c23,      c24,
     $           c25,     c26,     c27,     c28,     c29,      c30,
     $           c31,     c32,     c33,     c34,     c35,      c36,
     $           c37,     c38/
     $          0.01, 0.222222,   0.32,     0.4,    1.24,      2.2,
     $          4.67,     6.66,   6.73,   13.32,    60.0,      70.0,
     $         84.0,     105.0,  120.0,   127.0,   140.0,     175.0,
     $        210.0,     252.0,  264.0,   294.0,   346.0,     420.0,
     $        462.0,     606.0,  672.0,   707.0,   735.0,     889.0,
     $        932.0,     966.0, 1141.0,  1182.0,  1278.0,    1740.0,
     $       2520.0,    5040.0/

	   zabs(x)   =    dabs(x)
	   zexp(x)   =   dexp(x)
	   zlog(x)   =   dlog(x)
	   zsqrt(x)   =   dsqrt(x)

c           test arguments and initialize

	   ppchi2  =   -one
	   ifault   =  1
	   if(p.lt.pmin.or.p.gt.pmax)   return
	   ifault   =   2
	   if  (v.le.zero)   return
	   ifault   =     0
	   xx   =   half  *   v
	   c  =   xx  -   one

c           starting approximation for small chi-squared

	   if(v  .ge.   -c5 * zlog(p))    goto  1
	   ch = (p * xx *zexp(g + xx * aa)) ** (one / xx)
	   if(ch .lt. e)   goto  6
	   goto     4

c          starting approximation for v less than or equal to 0.32 

1         if(v  .gt.   c3)    goto   3
	  ch  =    c4
	  a  =   zlog(one  -  p)
2          q   =    ch
	  p1  =  one  +  ch * (c7 +  ch)
	  p2  =  ch *  (c9 + ch * (c8  +  ch))
	  t  =  -half + (c7 + two * ch)/ p1 - (c9 + ch * (c10  +
     $       three * ch)) / p2
	  ch = ch - (one - zexp(a + g + half * ch + c * aa) *
     $       p2 / p1) /  t
	 if(zabs(q / ch - one) .gt. c1)    goto   2
	   goto  4

c      call to algorithm AS 111 - note that p has been tested above

3          x  =    ppnd16(p  ,    if1)

c       starting approximation using Wilson and Hilferty estimate

	     p1  =   c2  /   v
	     ch =  v * (x * zsqrt(p1) + one - p1) ** 3

c       starting approximation for p tending to 1

	    if(ch .gt.  c6 * v + six)
     $  ch = -two * (zlog(one - p) - c * zlog(half * ch) + g)

c  call to algorithm AS 147 and calculation of seven term Taylor series
c   the real function gammds(y,p,ifault) computes the incomplete gamma 
c  integral G(y,p)= (1/Gamma(p)) Int{0,y} u^(p-1) exp(-u) du (Lau,1980)
c  gammds is replaced here by the algorithm AS 239 (Shea, 1988)
c  real function gammad(x,p,ifault) x : the value of the upper integral
c  limit x, p : the value of the parameter p, ifault :a fault indicator

4       q   =     ch
       p1   =   half * ch
c       p2  =   p   -   gammds(p1  ,    xx,    if1)
	p2  =   p    -   gammad(p1  ,    xx,    if1)
       if(  if1  .eq.   0)    goto   5
       ifault   =     3
       return
5       t = p2 * zexp(xx * aa + g + p1 - c * zlog(ch))
	b  =   t / ch
	a    =  half * t -  b * c
       s1 = (c19 + a * (c17 + a* (c14 + a *(c13 +  a* (c12  +
     $    c11 * a)))))  /  c24
       s2 =  (c24 + a * (c29 + a * (c32 + a * (c33 + c35 *
     $     a))))  /  c37
       s3  =  (c19 + a * (c25 + a * (c28 + c31 * a))) / c37
       s4 = (c20 + a * (c27 + c34 * a) + c * (c22 + a * (c30 +
     $  c36 * a))) /  c38
       s5 = (c13 + c21 * a + c * (c18 + c26 * a)) / c37
       s6  =  (c15 + c * (c23 + c16 * c)) / c38
       ch = ch + t * (one + half * t * s1 - b * c * (s1 - b *
     $   (s2 - b * (s3 - b * (s4 - b * (s5 - b * s6))))))
	if(zabs(q / ch - one) .gt.  e)    goto   4

6        ppchi2    =    ch
	 return
	 end


      REAL*8 FUNCTION ALOGAM(X,IFAULT)                                                 
      implicit real*8(a - h , o - z)
C                                                                               
C      ALGORITHM ACM 291, COMM. ACM. (1966) VOL.9, P.684                        
C                                                                               
C      EVALUATES NATURAL LOGARITHM OF GAMMA(X)                                  
C      FOR X GREATER THAN ZERO                                                  
C                                                                               
C                                                                               
C      THE FOLLOWING CONSTANTS ARE ALOG(2PI)/2,                                 
C      1/1680, 1/1260, 1/360  AND 1/12                                          
C                                                                               
      DATA A1,A2,A3,A4,A5                                                       
     +  /0.918938533204673, 0.000595238095238,                        
     +   0.000793650793651, 0.002777777777778,                        
     +   0.083333333333333/                                                     
      DATA HALF,ZERO,ONE,SEVEN/0.5,0.0,1.0,7.0/             
C                                                                               
      ZLOG(F)=DLOG(F)                                                           
C                                                                               
      ALOGAM=ZERO                                                               
      IFAULT=1                                                                  
      IF(X.LE.ZERO)RETURN                                                       
      IFAULT=0                                                                  
      Y=X                                                                       
      F=ZERO                                                                    
      IF(Y.GE.SEVEN) GOTO 30                                                    
      F=Y                                                                       
10    Y=Y+ONE                                                                   
      IF(Y.GE.SEVEN) GOTO 20                                                    
      F=F*Y                                                                     
      GOTO 10                                                                   
20    F=-ZLOG(F)                                                                
30    Z=ONE/(Y*Y)                                                               
      ALOGAM=F+(Y-HALF)*ZLOG(Y)-Y+A1+(((-A2*Z+A3)*Z-A4)*Z+A5)/Y                 
      RETURN                                                                    
      END                                                                       


	 real*8 function  gammad(x  ,  p  ,  ifault)

c    algorithm AS 239 Applied Statistics (1988) Vol. 37, no. 3

c    computation of the Incomplete Gamma Integral
c    G(x , p)  =  (1 / Gamma(p))  Int{0 , x} t^(p - 1) exp(-t) dt

	  integer  ifault
	  real*8   pn1, pn2, pn3, pn4, pn5, pn6, x, tol, oflo, xbig,
     *             arg, c, rn, p, a , b, one, zero, alogam,
     *             an, two,  elimit, plimit, alnorm, three, nine
	  intrinsic  dabs, dlog, dexp, dsqrt, dmin1
	  external    alogam,   alnorm
	  data zero, one, two, oflo, three, nine, tol, plimit, xbig,
     *  elimit/0.0,1.0,2.0,1.0E30,3.0,9.0,1.0E-7,1000.0,1.0E6,-88.0E0/

	    gammad   =   zero

c      Check that we have valid values for X and P

	 if(p.le.zero.or.x.lt.zero)   then
	      ifault  =   1
	      return
	 endif
	 ifault  =   0
	 if(x  .eq.  zero)   then
	      gammad  =  zero
	      return
	 endif

c      Use  a Normal  approximation if P  .gt.  PLIMIT

	  if(p  .gt.  plimit)   then
      pn1= three* dsqrt(p) * ((x/p)**(one/three) + one/(nine * p) - one)
	  gammad =   alnorm(pn1  ,  .false.)
	     return
	  endif

c     If  X is extremely large compared to  P then set GAMMAD   to  ONE

	  if(x  .gt. xbig)  then
	       gammad  =   one
	       return
	  endif

	 if(x.le.one  .or.  x.lt.p) then

c     Use Pearson's series expansion
c     (Note that P is not large enough to force overflow in ALOGAM)
c     No need to test IFAULT on exit since P .gt. zero

	 arg  =  p * dlog(x) - x - alogam(p + one , ifault)
	 c    =   one
	 gammad =    one
	 a   =   p
40       a   =    a   +   one
	 c  =   c * x / a
	 gammad   =   gammad  +   c
	 if(c  .gt.   tol)    goto    40
	 arg  =   arg  +  dlog(gammad)
	 gammad    =    zero
	 if(arg  .ge.   elimit)   gammad  =   dexp(arg)

       else

c      Use  a  continued  fraction  expansion

	 arg  =  p * dlog(x) - x - alogam(p  ,   ifault)
	 a =   one  -  p
	 b  =   a  +  x  +  one
	 c   =   zero
	 pn1  =   one
	 pn2   =   x
	 pn3  = x  +  one
	 pn4  =   x * b
	 gammad  =   pn3 / pn4
60       a  =  a  +  one
	 b  =   b   +   two
	 c   =  c  +  one
	 an  =    a * c
	 pn5  =   b * pn3  -  an * pn1
	 pn6 =   b * pn4  -  an * pn2
	 if(dabs(pn6)  .gt.  zero)    then
	     rn  =  pn5 / pn6
	    if(dabs(gammad - rn) .le. dmin1(tol  ,  tol * rn))  goto  80
	     gammad  =   rn
	 endif

	 pn1  =   pn3
	 pn2  =  pn4
	 pn3   =   pn5
	 pn4   =   pn6
	 if(dabs(pn5)  .ge.  oflo)    then

c          Re-scale terms in continued fraction if terms are large

	     pn1  =  pn1 / oflo
	     pn2 =   pn2 / oflo
	     pn3  =   pn3 / oflo
	     pn4 =  pn4 / oflo
	 endif
	 goto   60
80      arg  =   arg  +  dlog(gammad)
	gammad   =   one
	if(arg  .ge.  elimit)  gammad  =  one  -  dexp(arg)
      endif

	 end


	      real*8  function  alnorm(x  ,   upper)

c             algorithm AS 66 Applied Statistics (1973) Vol. 22, p. 424

c             evaluates the tail area of the standardized normal curve
c             from x to infinity if upper is .true. or
c             from minus infinity to x if upper is .false.

	  real*8 ltone , utzero , zero , half , one , con , a1 , a2 , a3 ,
     $   a4 , a5 , a6 , a7 , b1 , b2 , b3 , b4 , b5 , b6 , b7 , b8 , b9,
     $   b10 , b11 , b12 , x , y , z , zexp
	  logical   upper  ,   up

c           ltone and utzero must be set to suit the particular computer
c           (see introductory text)

	    data  ltone  ,   utzero / 7.0  ,  18.66 /
	    data  zero , half , one , con / 0.0 , 0.5 , 1.0 , 1.28 /
	    data              a1,              a2,                a3,
     $                        a4,              a5,                a6,
     $                        a7
     $        /   0.398942280444,  0.399903438504,     5.75885480458,
     $             29.8213557808,   2.62433121679,     48.6959930692,
     $             5.92885724438  /
	    data              b1,              b2,                  b3,
     $                        b4,              b5,                  b6,
     $                        b7,              b8,                  b9,
     $                       b10,             b11,                 b12
     $         /  0.398942280385,       3.8052E-8,       1.00000615302,
     $             3.98064794E-4,   1.98615381364,      0.151679116635,
     $             5.29330324926,    4.8385912808,       15.1508972451,
     $            0.742380924027,    30.789933034,       3.99019417011 /

	       zexp(z)    =     exp(z)

	       up   =    upper
	       z    =  x
	       if(z  .ge.  zero)     goto   10
	       up   =   .not.  up
	       z      =    -z
10      if(z .le. ltone .or. up . and. z .le. utzero)   goto   20
	       alnorm   =   zero
	       goto     40
20             y  =   half  *  z   *  z
	   if(z  .  gt.    con)    goto    30

      alnorm = half - z*(a1 - a2*y/(y + a3 - a4/(y + a5 + a6/(y + a7))))
		  goto    40

30    alnorm = b1 * zexp( -y) / (z - b2 + b3 / (z + b4 + b5 / (z -
     $   b6 + b7 / (z + b8 - b9 / (z + b10 + b11 / (z + b12 ))))))

40           if(.not.   up)    alnorm   =   one  -   alnorm
		 return
		   end


        DOUBLE PRECISION FUNCTION PPND16 (P, IFAULT)
C
C       ALGORITHM AS241  APPL. STATIST. (1988) VOL. 37, NO. 3
C
C       Produces the normal deviate Z corresponding to a given lower
C       tail area of P; Z is accurate to about 1 part in 10**16.
C
C       The hash sums below are the sums of the mantissas of the
C       coefficients.   They are included for use in checking
C       transcription.
C
        DOUBLE PRECISION ZERO, ONE, HALF, SPLIT1, SPLIT2, CONST1,
     *          CONST2, A0, A1, A2, A3, A4, A5, A6, A7, B1, B2, B3,
     *          B4, B5, B6, B7,
     *          C0, C1, C2, C3, C4, C5, C6, C7, D1, D2, D3, D4, D5,
     *          D6, D7, E0, E1, E2, E3, E4, E5, E6, E7, F1, F2, F3,
     *          F4, F5, F6, F7, P, Q, R
        PARAMETER (ZERO = 0.D0, ONE = 1.D0, HALF = 0.5D0,
     *          SPLIT1 = 0.425D0, SPLIT2 = 5.D0,
     *          CONST1 = 0.180625D0, CONST2 = 1.6D0)
C
C       Coefficients for P close to 0.5
C
        PARAMETER (A0 = 3.38713 28727 96366 6080D0,
     *             A1 = 1.33141 66789 17843 7745D+2,
     *             A2 = 1.97159 09503 06551 4427D+3,
     *             A3 = 1.37316 93765 50946 1125D+4,
     *             A4 = 4.59219 53931 54987 1457D+4,
     *             A5 = 6.72657 70927 00870 0853D+4,
     *             A6 = 3.34305 75583 58812 8105D+4,
     *             A7 = 2.50908 09287 30122 6727D+3,
     *             B1 = 4.23133 30701 60091 1252D+1,
     *             B2 = 6.87187 00749 20579 0830D+2,
     *             B3 = 5.39419 60214 24751 1077D+3,
     *             B4 = 2.12137 94301 58659 5867D+4,
     *             B5 = 3.93078 95800 09271 0610D+4,
     *             B6 = 2.87290 85735 72194 2674D+4,
     *             B7 = 5.22649 52788 52854 5610D+3)
C       HASH SUM AB    55.88319 28806 14901 4439
C
C       Coefficients for P not close to 0, 0.5 or 1.
C
        PARAMETER (C0 = 1.42343 71107 49683 57734D0,
     *             C1 = 4.63033 78461 56545 29590D0,
     *             C2 = 5.76949 72214 60691 40550D0,
     *             C3 = 3.64784 83247 63204 60504D0,
     *             C4 = 1.27045 82524 52368 38258D0,
     *             C5 = 2.41780 72517 74506 11770D-1,
     *             C6 = 2.27238 44989 26918 45833D-2,
     *             C7 = 7.74545 01427 83414 07640D-4,
     *             D1 = 2.05319 16266 37758 82187D0,
     *             D2 = 1.67638 48301 83803 84940D0,
     *             D3 = 6.89767 33498 51000 04550D-1,
     *             D4 = 1.48103 97642 74800 74590D-1,
     *             D5 = 1.51986 66563 61645 71966D-2,
     *             D6 = 5.47593 80849 95344 94600D-4,
     *             D7 = 1.05075 00716 44416 84324D-9)
C       HASH SUM CD    49.33206 50330 16102 89036
C
C       Coefficients for P near 0 or 1.
C
        PARAMETER (E0 = 6.65790 46435 01103 77720D0,
     *             E1 = 5.46378 49111 64114 36990D0,
     *             E2 = 1.78482 65399 17291 33580D0,
     *             E3 = 2.96560 57182 85048 91230D-1,
     *             E4 = 2.65321 89526 57612 30930D-2,
     *             E5 = 1.24266 09473 88078 43860D-3,
     *             E6 = 2.71155 55687 43487 57815D-5,
     *             E7 = 2.01033 43992 92288 13265D-7,
     *             F1 = 5.99832 20655 58879 37690D-1,
     *             F2 = 1.36929 88092 27358 05310D-1,
     *             F3 = 1.48753 61290 85061 48525D-2,
     *             F4 = 7.86869 13114 56132 59100D-4,
     *             F5 = 1.84631 83175 10054 68180D-5,
     *             F6 = 1.42151 17583 16445 88870D-7,
     *             F7 = 2.04426 31033 89939 78564D-15)
C       HASH SUM EF    47.52583 31754 92896 71629
C
        IFAULT = 0
        Q = P - HALF
        IF (ABS(Q) .LE. SPLIT1) THEN
          R = CONST1 - Q * Q
          PPND16 = Q * (((((((A7 * R + A6) * R + A5) * R + A4) * R + A3)
     *                  * R + A2) * R + A1) * R + A0) /
     *                (((((((B7 * R + B6) * R + B5) * R + B4) * R + B3)
     *                  * R + B2) * R + B1) * R + ONE)
          RETURN
        ELSE
          IF (Q .LT. ZERO) THEN
            R = P
          ELSE
            R = ONE - P
          END IF
          IF (R .LE. ZERO) THEN
            IFAULT = 1
            PPND16 = ZERO
            RETURN
          END IF
          R = SQRT(-LOG(R))
          IF (R .LE. SPLIT2) THEN
            R = R - CONST2
            PPND16 = (((((((C7 * R + C6) * R + C5) * R + C4) * R + C3)
     *                  * R + C2) * R + C1) * R + C0) /
     *               (((((((D7 * R + D6) * R + D5) * R + D4) * R + D3)
     *                  * R + D2) * R + D1) * R + ONE)
          ELSE
            R = R - SPLIT2
            PPND16 = (((((((E7 * R + E6) * R + E5) * R + E4) * R + E3)
     *                  * R + E2) * R + E1) * R + E0) /
     *               (((((((F7 * R + F6) * R + F5) * R + F4) * R + F3)
     *                  * R + F2) * R + F1) * R + ONE)
          END IF
          IF (Q .LT. ZERO) PPND16 = - PPND16
          RETURN
        END IF
        END


                                                                       



      




