c    xresid.for
c    programma per calcolare i residui di una serie storica
c    dato un modello threshold arma con 2 regimi
c    parametri in input: convenzione Box - Jenkins

      parameter(mob = 5500, mp=30, mq=30, mk =10, mlagh=37)
      implicit real*8 (a-h , o-z)
      character*70  pname, fname
      dimension z(mob), vfit(mob), res(mob), phi(mk,mp), theta(mk,mq)
     +, chc(mk), nzp(mk), nzq(mk), r(mk), rho(mlagh), cov(mlagh)
     +,  nj(mk),  s2(mk)

      open(unit=5, file='xresid.txt')
      read(5,*) nob, nac, nm, nd, nk, np, nq
      do  11  i  =1  ,  nk
      read(5, *)  nzp(i), nzq(i), chc(i)
      read(5,*) (phi(i, j), j=1,  np)
11    read(5,*) (theta(i, j), j=1,  nq)
      nk1 = nk - 1
      read(5, *) (r(i), i=1 , nk1)
      read(5, 12) pname        
      read(5, 12) fname        
12    format(A70)
      close(unit = 5)
      open(unit=5, file= fname)
      do  13  j  =1  ,  nob
13    read(5,*) z(j)
      close(unit = 5)

      lprint =  6

      open(unit = lprint, file = pname)
      write(lprint, 100)
100   format(1h  ,'Program xresid.for December 2003')
      write(lprint, 101) nob, nac, fname
101   format(1h  ,'nob,nac ', 2I8, 5X, 'series: '/ 1h  ,A70)
      write(lprint, 102) nm,nd,nk,np,nq
102   format(1h   ,'nm,nd,nk,np,nq  ', 5I8)
      write(lprint, 103) (r(i), i=1 , nk1) 
103   format(1h   ,'threshold model parameter ' , 10F7.4
     +/1h    ,'l.1 regime, n.par ar, n. par ma, constant'
     +/1h   'l.2 ar coefficients l.3 ma coefficients')
      do  14  i  =1  ,  nk
      write(lprint, 104)  i, nzp(i), nzq(i), chc(i)
104   format(1h   ,3I8, F12.4)
      write(lprint,105) (phi(i, j), j=1,  np)
14    write(lprint, 105) (theta(i, j), j=1,  nq)
105   format(1h  ,  10F7.4)      
       write(LPRINT , 274)  
274    format(1h , 'data printout file')
       write(LPRINT , 275)      pname
275    format(1h  ,  A70)
      WRITE(LPRINT, 309)
309   FORMAT(1H  ,'//')

      CALL ZCOR(z,NOB,NAC,RHO,COV,DM,DSD,IEXIT)                     

      WRITE(LPRINT,  187) IEXIT
187   FORMAT(1H ,'Time series z statistics ZCOR : IEXIT ', I5)
      write(LPRINT, 207) dm, cov(1), dsd 
207   format(1h  ,'Input data mean, var, sqm =', 3D12.4)
      write(LPRINT, 208) 
208   format(1h ,'Autocorrelation function')
       nac1  =  nac +  1
      write(LPRINT, 203) (rho(j), j=1, nac1)
203    format(1h  , 7f10.4)
      WRITE(LPRINT, 309)

        NM = MAX0(ND, MAX0(NP,NQ), NM)
        DO  2 I =1 , NM
        vfit(I)   =  z(I)
2       res(I)   =  z(I) -  vfit(i)

C       SSETARMA MODEL FROM NM+1 TO NOB

      ness  =  0
      do  21  i  =1  ,  nk
      nj(i)  =  0
21    s2(i)  =  0.0
      NM1 =  NM+ 1
      DO  3  I = NM1 , NOB

C       FIND THE REGIME FOR OBSERVATION I
c        write(*,*) i,z(i-nd)
c        pause
      IF(Z(I-ND) .LE.  R(1)) THEN 
      II =  1
      ENDIF
      IF(nK1 .GE. 2) THEN
      DO  4  IJ = 2 , nK1
      IF(Z(I-ND) .GT. R(IJ-1) .AND. Z(I-ND) .LE. R(IJ)) GOTO  5
4     CONTINUE
5     II=  IJ
      ENDIF
      IF(Z(I-ND) .GT. R(nK1)) THEN
      II  =  nK
      ENDIF
      nj(ii)  =  nj(ii)  + 1
      ness  =  ness  + 1
c        write(*,*) 'regime ' , ii
c        pause

C       SET ARMA MODEL IN REGIME II FOR OBSERVATION I 

      vfit(I) = Chc(II)
      IF(NP .GT. 0)  THEN
      DO  6   J =  1  , NP
      vfit(I) = vfit(I) + phi(II, J) * Z(I - J)
c      write(*,*) 'j,phi(j),z(i-j),zhat ',j,phi(ii,j),z(i-j),vfit(i)
6     CONTINUE
      ENDIF
      IF(NQ .GT. 0)  THEN
      DO  8   J =  1  , NQ
      vfit(I) = vfit(I) - theta(II, J) * res(I - J)
c      write(*,*)'j,theta(j),e(i-j),zhat ',j,theta(ii,j),res(i-j),vfit(i)
8     CONTINUE
      ENDIF
       res(I)   =  z(I) -  vfit(i)
       s2(ii)  =  s2(ii)  +  res(i) * res(i)
c      write(*,*) i, Z(I), vfit(i), res(i)
c      pause
3     CONTINUE

c      write(*,*) 'fine previsione one-step-ahead modello SETARMA'
c      pause

C       RECORD THE NOB OBSERVATIONS , estimates and residuals	       

      DO 7 I = 1, nob
7     WRITE(lprint, 300)  Z(I), vfit(i), res(i)
300   format(3F20.10)
      WRITE(LPRINT, 309)

      CALL ZCOR(res,NOB,NAC,RHO,COV,DM,DSD,IEXIT)                     

      WRITE(LPRINT,  487) IEXIT
487   FORMAT(1H ,'Residual series res statistics ZCOR : IEXIT ', I5)
      write(LPRINT, 407) dm, cov(1), dsd 
407   format(1h  ,'Resid. data mean, var, sqm =', 3D12.4)
      write(LPRINT, 408) 
408   format(1h ,'Autocorrelation function')
       nac1  =  nac +  1
      write(LPRINT, 403) (rho(j), j=1, nac1)
403    format(1h  , 7f10.4)
      write(lprint,  490) ness
490   format(1h   ,'effective sample size ' , I10
     +/1h   ,'n.obs. per regime')
      write(lprint, 491) (nj(i), i =1 ,  nk)
491   format(1h   ,8I8)
      write(lprint, 492) 
492   format(1h  ,'residual sum of squares per regime')
      write(lprint, 493) (s2(i), i=1 ,  nk)
493   format(1h  ,5F12.6)

      xnaic  =  0.0
      do  22  i  =  1 ,  nk
22    xnaic =  xnaic + nj(i) * dlog(s2(i) / dble(nj(i)))
     +   +  2D0  *  (1D0  +  nzp(i) +  nzq(i))
      xnaic  =  xnaic / dble(ness)

      write(lprint, 494) xnaic
494   format(1h  ,'NAIC ', F12.6)
      write(lprint,495) s2(1)/dble(nj(1)),s2(2)/dble(nj(2))
     +,(s2(1)+s2(2))/dble(ness)      
495   format(1h   ,'variance regime 1, 2 and pooled variance'
     +/1h   , 3F12.6)

      do  20  i = 1 , nac
      nhhi  =  i
      write(lprint, 410) i, qtest(rho,nhhi,nob)
410   format(1h   ,I5, F10.4)
20    continue
 
      CLOSE(UNIT = lprint)
      stop
      end


      REAL*8  FUNCTION QTEST(R, NAC, NOB)
      IMPLICIT  REAL*8 (A - H , O - Z)
      DIMENSION  R(NAC)
      NAC1  =  NAC + 1
      SUM  =  0D0
      DO  1  K  = 2 ,  NAC1
1     SUM  =  SUM  +  R(K) * R(K) / DBLE(NOB - K + 1)  
      QTEST = DBLE(NOB) * DBLE(NOB + 1) * SUM
      RETURN
      END
   

      SUBROUTINE ZCOR(C,NOB,NAC,R,SER,DM,DSD,IEXIT)                     ARI02040
C                                                                       ARI02050
C-----     SUBROUTINE ZCOR                                              ARI02060
C                                                                       ARI02070
C     CALCULATES AUTOCORRELATIONS AND THEIR STANDARD ERRORS             ARI02080
C                                                                       ARI02090
C-----                                                                  ARI02100
C                                                                       ARI02110
C     C     SERIES INPUT OF NOB OBS.                                    ARI02120
C     NAC   MAXIMUM LAG                                                 ARI02130
C     R     AUTOCORRELATION FUNCTION OF NAC VALUES                      ARI02140
C     SER  AUTOCOVARIANCE FUNCTION OF NAC VALUES                        ARI02150
C     DM    MEAN OF THE SERIES                                          ARI02160
C     DSD   STANDARD ERROR OF THE SERIES                                ARI02170
C     IEXIT IF NAC>= NOB IEXIT IS SET TO -1                             ARI02180
C           UNLESS THIS ONE ERROR IS DETECTED IEXIT                     ARI02190
C           CONTAINS ZERO ON EXIT                                       ARI02200
C                                                                       ARI02210
C-----                                                                  ARI02220
C                                                                       ARI02230
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION C(NOB),R(NAC),SER(NAC)                                  ARI02240
      IEXIT=0                                                           ARI02250
      IF(NOB-NAC) 100,100,20                                            ARI02260
   20 DIV=NOB                                                           ARI02270
      DM=RMEAN(C,NOB)                                                   ARI02280
      DENOM=CPROXY(C,DM,C,DM,NOB)                                       ARI02290
      DSD=DSQRT(DENOM/DIV)                                              ARI02300
      DO 30 K=1,NAC                                                     ARI02310
      M=NOB-K                                                           ARI02320
      HNUM=CPROXY(C(1),DM,C(K+1),DM,M)                                  ARI02330
      SER(K)=HNUM/DIV                                                   ARI02340
      R(K)=HNUM/DENOM                                                   ARI02350
   30 CONTINUE                                                          ARI02360
      NAC1=NAC+1                                                        ARI02370
      DO 40 K=1,NAC                                                     ARI02380
      M=NAC1-K+1                                                        ARI02390
      R(M)=R(M-1)                                                       ARI02400
      SER(M)=SER(M-1)                                                   ARI02410
   40 CONTINUE                                                          ARI02420
      R(1)=1.0                                                          ARI02430
      SER(1)=DSD*DSD                                                    ARI02440
      RETURN                                                            ARI02450
  100 IEXIT=-1                                                          ARI02460
      RETURN                                                            ARI02470
      END                                                               ARI02480


      REAL*8 FUNCTION RMEAN(X,NOB)                                      ARI01510
C                                                                       ARI01520
C----      DOUBLE PRECISION FUNCTION RMEAN                              ARI01530
C                                                                       ARI01540
C      CALCULATES THE SAMPLE MEAN OF A SERIES OF NOB OBSERVATIONS       ARI01550
C                                                                       ARI01560
C----                                                                   ARI01570
C                                                                       ARI01580
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01590
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01600
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01610
C                                                                       ARI01620
C----                                                                   ARI01630
C                                                                       ARI01640
C      X:  OBSERVED TIME SERIES OF NOB VALUES                           ARI01650
C                                                                       ARI01660
C----                                                                   ARI01670
C                                                                       ARI01680
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB)                                                  ARI01690
      SUM=0                                                             ARI01700
      DO 10 J=1,NOB                                                     ARI01710
  10  SUM=SUM+X(J)                                                      ARI01720
      RMEAN=SUM/FLOAT(NOB)                                              ARI01730
      RETURN                                                            ARI01740
      END                                                               ARI01750


      REAL*8 FUNCTION CPROXY(X,XBAR,Y,YBAR,NOB)                         ARI01760
C                                                                       ARI01770
C----     DOUBLE PRECISION FUNCTION CPROXY                              ARI01780
C                                                                       ARI01790
C      CALCULATES SUM OF PRODUCTS OF DEVIATIONS OF TWO VARIABLES        ARI01800
C      FROM SPECIFIED CENTRAL VALUES                                    ARI01810
C                                                                       ARI01820
C----                                                                   ARI01830
C                                                                       ARI01840
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01850
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01860
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01870
C                                                                       ARI01880
C----                                                                   ARI01890
C                                                                       ARI01900
C      X,Y:      REAL ARRAYS OF LENGTH NOB.                             ARI01910
C                ON ENTRY CONTAIN VALUES OF THE TWO VARIABLES           ARI01920
C      XBAR,YBAR:X'S AND Y'S MEAN RESPECTIVELY                          ARI01930
C                                                                       ARI01940
C----                                                                   ARI01950
C                                                                       ARI01960
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB),Y(NOB)                                           ARI01970
      S=0                                                               ARI01980
      DO 10 I=1,NOB                                                     ARI01990
  10  S=S+(X(I)-XBAR)*(Y(I)-YBAR)                                       ARI02000
      CPROXY=S                                                          ARI02010
      RETURN                                                            ARI02020
      END                                                               ARI02030



      