C     program xxssetar
C     exhaustive subset threshold model search 
C     ssetar models only, 2 regimes, nd is assumed known
C     ncasi (input) models are given:
C     the subset autoregressive structure is pre-identified for each of
C     the 2 regimes
C    !!! the following feature is not active !!!!
C     threshold parameter is estimated by the Tong's (1990,p.385) method
C    !!! 
C        NCASI models are given completely identified, the parameters
C        (with standard errors) and residual variance are computed 
C        along with the NAIC index (Tong, 1990)
C        the model with least NAIC is chosen
C        Estimation routine is FFB                                  !!!
C     Sample observations start at nm>=max(np,nd)

      PARAMETER(MOB=5500,MLAGH=36,MDYP=05,MK=05,MK1=MK+1,MP=05,MP1=MP+1
     +, MPLAG = MP, MREGI = 02, MMODEL = 7, MCASI = MMODEL ** mregi) 
      implicit real*8(a - h, o- z)
      CHARACTER*72  PNAME, FNAM1, FNAM2

C     TIME SERIES DIMENSION

      DIMENSION  Z(MOB), X(MOB), RES(MOB), VFIT(MOB), ETILDA(MOB)
     +, RHO(MLAGH), COV(MLAGH), XMAT(MOB, MP1), PHI(MP1), STDPHI(MP1)
     +, AUX1(MP1), VC1(MP1, MP1), BB(MP1), CC(MP1), IP(MP1), IQ(MP1)
     +, KKKN(MOB), NXP(MK), LAHP(MK, MP), PPP(MK,MP1), STDPPP(MK,MP1)
     +, FZ(MOB), FITX(MOB), FITY(MOB), KKN(MOB), KNG(MOB)

C     THRESHOLD PARAMETERS DIMENSION

      DIMENSION R(MK1), NJ(MK), S2(MK)

C     TRUE MODEL

      DIMENSION  R90(MK1), XPHI(MK, MP1), NP90(MK), LAGP90(MK, MP) 

C     BEST ESTIMATED MODEL

      DIMENSION  R99(MK1), NP99(MK), S299(MK), NJ99(MK), LAGP99(MK, MP)
     +, XPHI99(MK, MP1), XSTD99(MK, MP1), RES99(MOB) 

C     INPUT MODELS: 15 MODELLI AR CORRISPONDONO AL LAG MASSIMO 4 CON
C      1, 2, 3 O 4 COEFFICIENTI, PER 3 REGIMI SI HA MCASI = 45

      DIMENSION  NREGI(MCASI), ND10(MCASI), R10(MCASI, MK1)
     +, NP10(MCASI, MK), LAGP10(MCASI, MK, MP) 

C      RESIDUAL STATISTICS

      DIMENSION  LHHQ(MLAGH), QHHQ(MLAGH), IJHQ(MLAGH)
     +, R2R(MOB),R2HO(MLAGH),C2OV(MLAGH)

C       MONTE CARLO STATISTICS DIMENSION

      DIMENSION WNP(MDYP,MK,MK,MP),WNPLAG(MDYP,MK,MP,MK,MPLAG)
     +,WNPP(MDYP,MK,MP,MK,MPLAG),WNPP2(MDYP,MK,MP,MK,MPLAG)
     +,WCONST(MDYP,MK,MK),WCONS2(MDYP,MK,MK)
     +,WOBS(MDYP,MK,MK),WOBS2(MDYP,MK,MK)
     +,WS2(MDYP,MK,MK),WS22(MDYP,MK,MK)
     +,WRHE(MDYP,MK,MK1),WRHE2(MDYP,MK,MK1)
     +,WCONTA(MDYP,MK)
     +,WVARE(MDYP,MK),WVARE2(MDYP,MK),WVAOB(MDYP,MK),WVAOB2(MDYP,MK)
     +,WAIC(MDYP,MK),WAIC2(MDYP,MK)
     +,WQ(MDYP,MK,MLAGH),WQ2(MDYP,MK,MLAGH),WCQ(MDYP,MK,MLAGH)
     +,WQQ(MDYP,MK),WQQ2(MDYP,MK),WCQQ(MDYP,MK)

      DATA  TOL, BIG/ 8.43D-37 ,  3.37D+38 /

C     NK = no. of regimes, NK1 = NK+1 = no. of threshold constants r(.)
C
C             1                2               ...             k     
C     _________________|_________________|____ ...  ____|_______________
C                     r(1)              r(2)           r(k-1)
C      z(t-d) < r(2)    r(2)<=z(t-d)<r(3)               z(t-d) >= r(NK)
C        r(1) = -big and r(nk+1) = big are the trivial threshold

      iseed1 =  531919
      iseed2 =  531977
c  iseed1 = prevprime(531971); iseed2 = nextprime(531971);       
	call set_uniform(iseed1, iseed2)

      LDUM1 = 10
      LDUM2 = 11
      LPRINT  =  6

C      BOX-JENKINS CONVENTION FOR AR PARAMETERS

      OPEN(UNIT=5, FILE='xxssetar.txt')
      READ(5,*)   NOB, NSCART, NAC, MSPAN, NM, NDYP, NHK, NHP
      READ(5 ,*)   NHHQ
      READ(5, *)  (LHHQ(I) , I=1 , NHHQ)
      READ(5, *)  IX, IY, IZ
      read(5,*)   NREPL
      read(5,*)     ALPHA
      read(5,*)     IPRINT
      read(5 , 470)      PNAME
      read(5 , 470)      FNAM1
      read(5 , 470)      FNAM2
470    format(A72) 
      READ(5,*) ND90, NREG90
      NREG91 =  NREG90 +  1
      READ(5 , *) (R90(I), I = 1,  NREG91)
      DO 471  I =1 , NREG90
      READ(5, *) NPI
      NP90(I) =  NPI
      READ(5 , *) (LAGP90(I,J), J=1, NPI)
      READ(5 , *) (XPHI(I , J), J =1 , NPI)
471   CONTINUE
      READ(5, *) NCASI
      DO  478  IJ  =  1 , NCASI
      READ(5, *) ND10(IJ) ,  NREGI(IJ)
      NREG11 =  NREGI(IJ) + 1
      READ(5 , *) (R10(IJ, I), I = 1,  NREG11)
      NREG10 =  NREGI(IJ)
      DO 475  I =1 , NREG10
      READ(5, *) NPI
      NP10(IJ ,I) =  NPI
      READ(5 , *) (LAGP10(IJ, I,J), J=1, NPI)
475   CONTINUE
478    CONTINUE
       close(unit  =  5)
          
       open(unit= LPRINT, file=pname)
       write(LPRINT  ,  200)  
200    format(1h  ,  'xxssetar.for (mainpgm) February 2004'
     +/1h ,'estimate the input list of k-regimes subset Setar')
       write(lprint,  201) nrepl
201    format(1h   ,'number of replications nrepl = ', I10)
      WRITE(LPRINT, 204) NOB,NSCART,NAC,MSPAN,NM,NDYP,NHK,NHP
204   FORMAT(1H ,'NOB,NSCART,NAC,MSPAN,NM,NDYP,NHK,NHP= '
     +/1H    , I10, 7I5)
      write(lprint, 281) nhhq
281   format(1h  ,'Lag for Q computation NHHQ ',  I5)
      write(lprint, 282) (lhhq(i) , i = 1 , nhhq)
282   format(1h   ,10I5)
      write(lprint , 288) alpha
288   format(1h  ,'livello di significat. dei test alpha = ', F10.4)
       write(LPRINT , 274)  
274    format(1h , 'data printout file')
       write(LPRINT , 275)      pname
       write(LPRINT , 285)  
285    format(1h , 'data file for storing Ljung-Box test Q values')
       write(LPRINT , 275)      fnam1
       write(LPRINT , 286)  
286    format(1h , 'data file for storing Li-McLeod test QQ values')
       write(LPRINT , 275)      fnam2
275    format(1h  ,  A72)
      WRITE(LPRINT, 276)  ND90, NREG90
276   FORMAT(1H  ,'TRUE MODEL : ND90,NREG90 ',2I5)
      WRITE(LPRINT, 289) 
289   FORMAT(1H   ,'THRESHOLD PARAMETERS ')
      WRITE(LPRINT, 278) (R90(I), I = 1,  NREG91)
      DO  33475  II =1  ,  NREG90
      NPI  =  NP90(II)
      WRITE(LPRINT, 277) II , NPI
277   FORMAT(1H   ,'REGIME ',I5,5X,'AR LAGS AND COEFFICIENTS ', I5)
      WRITE(LPRINT, 291) (LAGP90(II , J) , J = 1 , NPI)
291   FORMAT(1H  , 14I5)
      WRITE(LPRINT, 278)  (XPHI(II , J), J =1 ,  NPI)
278   FORMAT(1H   ,  7F10.4)
33475   CONTINUE
      WRITE(LPRINT, 309)
309   FORMAT(1H  ,'//')

C     MONTE CARLO EXPERIMENT RESULTS ARE SET TO ZERO AT THE START

      NHK1  =  NHK +  1
      NHP1  =  NHP + 1
      DO  310  II = 1 , NDYP
      DO  310  I = 1 , NHK
      DO  310  JJ = 1 , NHK
      DO 310   J  =  1, NHP
310   WNP(II,I,JJ,J)  =  0.0
      DO  311  II  =1  ,  NDYP
      DO  311  I  =1  ,  NHK
      DO 311   III =  1 ,  NHP
      DO  311  JJ  =1  ,  NHK
      DO  311  J =  1,  NHP
      WNPP(II,I,III,JJ,J)  =  0.0
      WNPP2(II,I,III,JJ,J)  =  0.0
311   WNPLAG(II,I,III,JJ,J)  =  0.0
      DO  30311  II  =1  ,  NDYP
      DO  30311  I  =1  ,  NHK
      DO  30311  JJ  =1  ,  NHK
      WCONST(II,I,JJ)  =  0.0
30311 WCONS2(II,I,JJ)  =  0.0
      DO 314  II  =1  ,  NDYP
      DO 314  I  =1  ,  NHK
      DO 314  JJ  =1  ,  NHK
      WOBS(II,I,JJ)  =  0.0
      WOBS2(II,I,JJ) =  0.0
      WS2(II , I, JJ)  =  0.0 
314   WS22(II , I, JJ)  =  0.0 
      NHK1 =  NHK + 1
      DO 312  II  =1  ,  NDYP
      DO 312  I  =1  ,  NHK
      DO 312  III  =1  ,  NHK1
      WRHE(II,I,III) = 0.0
312   WRHE2(II,I,III) = 0.0
      DO  317   II  =  1 ,  NDYP
      DO  317   I  =  1 ,  NHK
317   WCONTA(II,I)   =  0.0
      DO  318  II = 1,  NDYP
      DO  318  I =  1  , NHK
      WVARE(II , I)  =  0.0
      WVARE2(II , I)  =  0.0
      WVAOB(II , I)  =  0.0
      WVAOB2(II , I)  =  0.0
      WAIC(II , I)  =  0.0
      WAIC2(II , I)  =  0.0
      WQQ(II , I)  =  0.0
      WQQ2(II , I)  =  0.0
      WCQQ(II , I)  =  0.0
318   CONTINUE
      DO  316  II = 1,  NDYP
      DO  316  I =  1  , NHK
      DO  316  J =  1  , NHHQ
      WQ(II , I, J)  =  0.0
      WQ2(II , I, J)  =  0.0
316   WCQ(II , I, J)  =  0.0

c        Monte Carlo loop   (RECORD Q, QQ statistics)

       open(unit= LDUM1, file=fnam1)
       open(unit= LDUM2, file=fnam2)

      do   50010  irepl = 1  , nrepl

       write(*,*) irepl
   
c        Generates time series normal unit white noise .

      VARE  = 1D0
      NTOT = NOB + NSCART
      NDR1 =  NOB - NM
      DO  401  I  =  1  ,  NTOT
402        PPX0=  uniform()
      PPX1 =  PPND16(PPX0 , IZAULT)
      IF(IZAULT .NE. 0)  GOTO  402
401   ETILDA(I) =  PPX1 * DSQRT(VARE)   

c        Parameters as specified in input ...

       do  403  i =  1,  nm
403    z(i)  =  etilda(i)
        nm1  =  nm + 1
       do  404  i  = nm1 , ntot
      JJ  =  1
      DO  33313  II  = 1 ,  NREG90
      RLOW =  R90(II)
      RHIGH =  R90(II+1)
       if(z(i - nd90) .GT. RLOW. AND. Z(I - ND90).le. RHIGH) then
      JJ =  II
      ENDIF
33313    CONTINUE
       z(i) =  etilda(i)
        NPI =  NP90(JJ)
        do  406  ij  = 1  ,  npi
         LAG1 =  LAGP90(jj, IJ)
406     z(i) = z(i) + xphi(jj ,ij) * z(i - LAG1) 
404    continue
       do  405  i =  1 ,  nob
405    z(i) = z(i +  nscart) 

c       open(unit=15,file='test90')
c       write(15,40510) (z(i), i=1,  nob)
c40510  format(F20.8)
c        close(unit=15)

c       Preliminary statistics computation

       sse = 0D0
       nscar1 =  nscart +  NM  + 1
       do 1401 i = nscar1, ntot
1401   sse  =  sse  +  etilda(i) ** 2
       sse  =  sse/ dble(NDR1)
       dhm = 0D0
      ssql  =  0D0
      nm1 = nm + 1
      do  110  i = nm1 , nob
      dhm = dhm + z(i)
110   ssql = ssql + z(i) * z(i)
      dhm  =  dhm / dble(nob - nm)
	vhv  = ssql / dble(nob - nm) - dhm * dhm
      SSQL  =  vhv * dble(nob - nm)

      CALL ZCOR(Z,NOB,NAC,RHO,COV,DM,DSD,IEXIT)                     
       DO  33881 I  = 1  ,  NOB
33881  FZ(I)  =  Z(I)
        CALL GRADU(FZ,FITX,FITY,KKN,KNG,NOB)

      IF(IPRINT. GT. 0) THEN
      WRITE(LPRINT,  187) IEXIT
187   FORMAT(1H ,'Time series Z statistics ZCOR : IEXIT ', I5)
      write(LPRINT, 207) dm, dsd, cov(1) 
207   format(1h  ,'Input data mean,sqm,var =', 3D12.4)
      write(6, 206) dhm ,ssql, vhv 
206   format(1h  ,'Data (nm+1,nob) dhm,ssql,var =', 3D12.4)
      write(6, 210) sse 
210   format(1h  ,'Error variance (nm+1,nob) sse =', D12.4)
      write(LPRINT, 208) 
208   format(1h ,'Autocorrelation function')
      nac1  =  nac +  1
      write(LPRINT, 203) (rho(j), j=1, nac1)
203    format(1h  , 7f10.4)
      nmedn =  nob / 2
      write(lprint, 220) 
220   format(1h  ,'time series minimum, median, maximum')
      write(lprint,  221)  fity(1), fity(nmedn), fity(nob) 
221    format(1h   ,3F16.4)
      write(lprint, 129) 
129    format(1h    ,'//'  )
      ENDIF

C    k-REGIMES THRESHOLD ARMA d, r1..rk, (p, l1..lp)-k times

      NP  =  NHP
      NP1  =  NHP +  1
      FMIN =  BIG

      DO  33888  IJ  =  1 ,  NCASI

      ND =  ND10(IJ)
      NK =  NREGI(IJ)
      NK1 =  NK +  1
      DO  33898  II =  1 ,  NK1
33898 R(II) =  R10(IJ, II)
      R(1) = fity(1) - tol
      R(NK1) = fity(nob)
      DO  33897  II  = 1 ,  NK
      NPI =    NP10(IJ, II)
      NXP(II)  =  NPI
      DO  33896  JJ  =  1 , NPI
33896 LAHP(II , JJ) =  LAGP10(IJ , II, JJ)
33897 CONTINUE

      FNAIC =  FFB(Z, MOB, NOB, NM, ND, R, MK, NK, NK1, NJ
     +, S2, MP1, NP, NP1, MSPAN, NXP, LAHP, X, RES, VFIT, PPP, STDPPP
     +, XMAT, PHI, STDPHI, AUX1, VC1, BB, CC, IP, IQ, KKKN
     +, iprint, lprint, ifault)

C      write(lprint, 1147)  ifault
C1147  format(1h   ,'Exit FFB, ifault = ', I5)

      IF(FNAIC .LT. FMIN)  THEN
      FMIN =  FNAIC
      NBEST =  IJ
      ND99  = ND
      NK99  =  NK
      NK991 =  NK +  1
      DO 313  II = 1 , NK991
313   R99(II)  =  R(II)
      RESVAR  = 0.0
      NOB99 = 0
      DO  287  II = 1 ,  NK99
      NPI =  NXP(II)
      NP99(II) =  NPI
      S299(II) = S2(II)
      NJ99(II)  = NJ(II)
      DO  293  JJ  =  1 , NPI
293   LAGP99(II , JJ) =  LAHP(II , JJ)
      NPI1 =  NPI + 1
      DO  284  JJ =  1 , NPI1
      XPHI99(II , JJ) = PPP(II , JJ)         
284   XSTD99(II , JJ) =  STDPPP(II , JJ)
      RESVAR =  RESVAR + S299(II)
      NOB99 =  NOB99 +  NJ99(II)
287   CONTINUE
      DO  33201  J = 1 ,  NOB
33201 RES99(J) =  RES(J)
      RESVAR =  RESVAR / DBLE(NOB99)

c      WRITE(LPRINT, 211) NBEST, FMIN, ND99, NK99
c211   FORMAT(1H  ,'Caso,Naic,d,k ', I5, D12.4, 2I5)
c      write(lprint, 218)  
c218   format(1h  ,'Modello: threshold parameters ')
c      write(lprint, 203) (r99(ii), ii = 1, nk991)
c      do  33895  ii =  1 , nk99
c      write(lprint, 33200) ii, nj99(ii), s299(ii)/dble(nj99(ii))
c33200 format(1h  ,'regime, n. obs, variance = ', 2I5, D12.4
c     +/1H    ,'CONSTANT+COEFFICIENTS AND STANDARD ERRORS ')
c      npi1 =  np99(ii) + 1
c      write(lprint, 203) (xphi99(ii, jj), jj =1 , npi1)
c      write(lprint, 203) (xstd99(ii, jj), jj =1 , npi1)
c33895 continue

      ENDIF

33888 CONTINUE

c  Test residuals for the (best) estimated SSETAR model 
C  Ljung-Box, 1978 (residuals), and McLeod-Li, 1983 (squared residuals)
  
      NHPARA =  0
      DO  33202  I = 1 ,  NK99
      IF(NP99(I) .GT. NHPARA)  THEN
      NHPARA =  NP99(I)
      ENDIF
33202 CONTINUE
      CALL ZCOR(RES99,NOB,NAC,RHO,COV,DM,DSD,IEXIT)                     
      DO  5522  I  =1 ,  NHHQ
      MHHQ  =  LHHQ(I) 
      QHHQ(I)  =  QTEST(RHO, MHHQ,NOB) 
5522  CONTINUE
      DO  5523  I  = 1 ,  NHHQ
      MHHQ  =  LHHQ(I) 
      HHNI =  DBLE(MHHQ - NHPARA - 1)
      IJHQ(I)  =  0
      IF(HHNI .GT. 0.0) THEN
      HHNI2 =  HHNI / 2D0
      GGGG  =  ALOGAM(HHNI2, IFAUL2)
      PPOINT  =  1D0 -  ALPHA
      PVALUE =  PPCHI2(PPOINT, HHNI, GGGG, IFAULT)
      IF(QHHQ(I) .GT. PVALUE) IJHQ(I) =  1
      ENDIF
5523  CONTINUE
      do  5521 i =  1 ,  nob
5521  R2R(i) = RES99(i) * RES99(i)
      CALL ZCOR(R2R,NOB,NAC,R2HO,C2OV,D2M,D2SD,IEXIT)                     
      QQ =  QTEST(R2HO, NAC, NOB)
	hhni  =    dble(NAC)
      IJHQQ  =  0
      IF(HHNI .GT. 0.0)  THEN
	hhni2   =     HHNI / 2D0
	gggg   =   alogam(hhni2  ,  ifaul2)
      ppoint  =  1D0  -  alpha
	pvalue   =   ppchi2(ppoint  ,  hhni  ,  gggg ,   ifault)
      IF(QQ .GT. pvalue)  IJhQQ =  1
      ENDIF

      IF(IPRINT .GT. 0)  THEN
      write(LPRINT, 307) dm, dsd 
307   format(1h  ,'Residuals mean, sqm =', 2F12.4)
      write(LPRINT, 308) 
308   format(1h ,'Residual autocorrelation function')
       nac1  =  nac +  1
      write(LPRINT, 203) (rho(j), j=1, nac1)
      write(lprint, 368) alpha, ppoint 
368   format(1h ,'Test Q : alpha,ppoint ', 2F5.2)
      DO  35523  I  = 1 ,  NHHQ
      MHHQ  =  LHHQ(I) 
      HHNI =  DBLE(MHHQ - NHPARA - 1)
      IF(HHNI .GT. 0.0) THEN
      HHNI2 =  HHNI / 2D0
      GGGG  =  ALOGAM(HHNI2, IFAUL2)
      PPOINT  =  1D0 -  ALPHA
      PVALUE =  PPCHI2(PPOINT, HHNI, GGGG, IFAULT)
      ENDIF
      write(lprint, 33468) mhhq,hhni, Qhhq(i), IJhQ(i) 
33468   format(1h ,'Lag,df,Q,IJhQ ', I5, F5.0, F10.4, i5)
35523  CONTINUE
      write(LPRINT, 467) d2m, d2sd 
467   format(1h  ,'Squared residuals mean, sqm =', 2F12.4)
      write(LPRINT, 408) 
408   format(1h ,'Squared residuals autocorrelation function')
       nac1  =  nac +  1
      write(LPRINT, 203) (r2ho(j), j=1, nac1)
      write(lprint, 468) alpha, ppoint, pvalue, QQ, IJhQQ 
468   format(1h ,'alpha,ppoint,pvalue,QQ,IJQQ ', 2F5.2, 2f10.4, i5)
      ENDIF

C     STORING MONTE CARLO EXPERIMENT RESULTS 

      JNND  = ND99
      JNNK  = NK99
      WCONTA(JNND,JNNK) =  WCONTA(JNND,JNNK) +  1
      DO  30611  I  = 1 , JNNK
      WCONST(JNND,JNNK,I)=WCONST(JNND,JNNK,I)+XPHI99(I,1)  
      WCONS2(JNND,JNNK,I)=WCONS2(JNND,JNNK,I)+XPHI99(I,1)**2
30611 CONTINUE      
      DO  610  I = 1 , JNNK
      JHHP =  NP99(I)
      IF(JHHP.GT.0)  WNP(JNND,JNNK,I,JHHP)  =  WNP(JNND,JNNK,I,JHHP) + 1  
610   CONTINUE
      DO  611  I  =1  ,  JNNK
      JHHP =  NP99(I)
      IF(JHHP .GT.  0)  THEN
      IPAHR =  0
      IPAHR  =  IPAHR  + 1
      DO  612  J =  1,  JHHP
      IJ =  LAGP99(I,J)
      IF(IJ .GT. 0) THEN
      WNPLAG(JNND,JNNK,JHHP,I,IJ) = WNPLAG(JNND,JNNK,JHHP,I,IJ) + 1  
      IPAHR  =  IPAHR  + 1
      WNPP(JNND,JNNK,JHHP,I,IJ)=WNPP(JNND,JNNK,JHHP,I,IJ)
     ++XPHI99(I,IPAHR)  
      WNPP2(JNND,JNNK,JHHP,I,IJ)=WNPP2(JNND,JNNK,JHHP,I,IJ)
     ++XPHI99(I,IPAHR)**2
       ENDIF
612   CONTINUE
      ENDIF     
611   CONTINUE
      JNNK1 =  JNNK +  1
      DO 614  I  =1  ,  JNNK
      WOBS(JNND,JNNK,I)  =  WOBS(JNND,JNNK,I) + DBLE(NJ99(I))
      WOBS2(JNND,JNNK,I)  =  WOBS2(JNND,JNNK,I) + DBLE(NJ99(I)) ** 2 
      WS2(JNND,JNNK,I)  =  WS2(JNND,JNNK,I) + S299(I)
      WS22(JNND,JNNK,I)  =  WS22(JNND,JNNK,I) + S299(I) ** 2 
614   CONTINUE
      DO 616  IJ  =1  ,  JNNK1
      WRHE(JNND,JNNK,IJ)  =  WRHE(JNND,JNNK,IJ) + R99(IJ)
      WRHE2(JNND,JNNK,IJ)  =  WRHE2(JNND,JNNK,IJ) + R99(IJ) ** 2
616   CONTINUE
      WVAOB(JNND,JNNK)  =  WVAOB(JNND,JNNK) +  VHV
      WVAOB2(JNND,JNNK)  =  WVAOB2(JNND,JNNK) +  VHV ** 2
      WVARE(JNND,JNNK)  =  WVARE(JNND,JNNK) +  RESVAR
      WVARE2(JNND,JNNK)  =  WVARE2(JNND,JNNK) +	RESVAR ** 2
      WAIC(JNND,JNNK)  =  WAIC(JNND,JNNK) +	 FMIN 
      WAIC2(JNND,JNNK)  =   WAIC2(JNND,JNNK) +  FMIN ** 2 
      DO  5525  IIII  =  1 ,  NHHQ
      WCQ(JNND,JNNK,IIII) =  WCQ(JNND,JNNK,IIII) + IJHQ(IIII)
      WQ(JNND,JNNK,IIII) =  WQ(JNND,JNNK,IIII) + QHHQ(IIII)
5525  WQ2(JNND,JNNK,IIII) =  WQ2(JNND,JNNK,IIII) + QHHQ(IIII) ** 2
      WCQQ(JNND,JNNK) =  WCQQ(JNND,JNNK) + IJHQQ
      WQQ(JNND,JNNK) =  WQQ(JNND,JNNK) + QQ
      WQQ2(JNND,JNNK) =  WQQ2(JNND,JNNK) + QQ ** 2

       IF(JNND.EQ.ND90.AND.JNNK.EQ.NREG90) THEN
       WRITE(LDUM1, 1716) (QHHQ(IIII) , IIII = 1 ,  NHHQ)
       WRITE(LDUM2, 1716) QQ
1716   FORMAT(6F12.6)
        ENDIF

50010   continue

C     MONTE CARLO RESULTS

      DO  701  II  =  1 ,  NDYP
      DO  701   JJ =  1  ,  NK
      JNND  =  II
      JNNK =  JJ
      WCO = WCONTA(JNND,JNNK)
      WRITE(LPRINT, 1701) JNND , JNNK, WCO
1701  FORMAT(1H   / 1H   ,'D  ', I5,  5X, 'K ', I5, 5X, 'occurs ',5F5.0)
      IF(WCO .GT. 0D0) THEN
      NKI1 = JNNK + 1
      DO 476  IJ = 1 ,  NKI1
      WTH  =  WRHE(JNND,JNNK, IJ) / WCO
      WTH2 = DSQRT(DABS(WRHE2(JNND,JNNK,IJ) / WCO - WTH ** 2)) 
      WRITE(LPRINT,477)  WTH, WTH2 
477   FORMAT(1H  , 'threshold(mean,se)', 5X, 2F12.4)
476   CONTINUE
      DO  704  I  = 1 ,  JNNK
      WO  =  WOBS(JNND,JNNK,I) / WCO
      WO2 = DSQRT(DABS(WOBS2(JNND,JNNK,I) / WCO - WO ** 2)) 
      WHS2  =  WS2(JNND,JNNK,I) / WCO
      WHS22 = DSQRT(DABS(WS22(JNND,JNNK,I) / WCO - WHS2 ** 2)) 
      WRITE(LPRINT,1706) I, WO, WO2, WHS2, WHS22 
1706  FORMAT(1H  ,'regime,n(mean,se)', I5, 5X, 2F10.0 
     +/1H  , 'res. sum of squares (m,se)', 5X, 2F12.4)
      WCON = WCONST(JNND,JNNK,I)/WCO
      WCON2 = DSQRT(DABS(WCONS2(JNND,JNNK,I)/WCO - WCON ** 2)) 
      WRITE(LPRINT, 41704)  WCON , WCON2  
41704  FORMAT(1H ,'CONSTANT : mean,se ', 2F12.4)
      DO  702  J  =  1 , NP
      JHHP  =    J
      IF(WNP(JNND,JNNK,I,JHHP) .GT. 0D0) THEN
      WRITE(LPRINT, 1702) JHHP ,  WNP(JNND,JNNK,I,JHHP)  
1702  FORMAT(1H   ,'p = ', I5, 5X, 'times for regime ', 5F5.0)
      DO  703  ILAG =1 , NP
      WN = WNPLAG(JNND,JNNK,JHHP,I,ILAG)
      IF(WN .GT. 0D0)  THEN
      WNPPN = WNPP(JNND,JNNK,JHHP,I,ILAG)/WN
      WNPPN2=DSQRT(DABS(WNPP2(JNND,JNNK,JHHP,I,ILAG)/WN - WNPPN ** 2)) 
      WRITE(LPRINT, 1704)  ILAG , WN , WNPPN , WNPPN2  
1704  FORMAT(1H ,'lag ', I5, 'occurs ', F5.0, 'mean,se ', 2F12.4)
       ENDIF
703   CONTINUE
       ENDIF
702   CONTINUE
704   CONTINUE
      WVAOB(JNND,JNNK)  =  WVAOB(JNND,JNNK) / WCO
      WVAOB2(JNND,JNNK)  =  DSQRT(DABS(WVAOB2(JNND,JNNK) / WCO
     + - WVAOB(JNND,JNNK) ** 2))
      WRITE(LPRINT, 1714) WVAOB(JNND,JNNK), WVAOB2(JNND,JNNK)
1714  FORMAT(1H ,'observation variance (mean,se)', 2F14.4)      
      WVARE(JNND,JNNK)  =  WVARE(JNND,JNNK) / WCO
      WVARE2(JNND,JNNK)  =  DSQRT(DABS(WVARE2(JNND,JNNK) / WCO
     + - WVARE(JNND,JNNK) ** 2))
      WRITE(LPRINT, 1709) WVARE(JNND,JNNK), WVARE2(JNND,JNNK)
1709  FORMAT(1H ,'residual variance (mean,se)', 2F14.4)      
      WAIC(JNND,JNNK)  =  WAIC(JNND,JNNK) / WCO 
      WAIC2(JNND,JNNK)  =   DSQRT(DABS(WAIC2(JNND,JNNK) / WCO
     + - WAIC(JNND,JNNK) ** 2)) 
      WRITE(LPRINT, 1710) WAIC(JNND,JNNK), WAIC2(JNND,JNNK)
1710  FORMAT(1H ,'             NAIC (mean,se)', 2F14.4)      
      DO  5527  IIII =  1  ,  NHHQ
      MHHQ  =  LHHQ(IIII)
      WQ(JNND,JNNK,IIII)  =  WQ(JNND,JNNK,IIII) / WCO 
      WQ2(JNND,JNNK,IIII)  =   DSQRT(DABS(WQ2(JNND,JNNK,IIII) / WCO
     + - WQ(JNND,JNNK,IIII) ** 2)) 
      WRITE(LPRINT, 1718) MHHQ, WQ(JNND,JNNK,IIII), WQ2(JNND,JNNK,IIII)
     +, WCQ(JNND,JNNK,IIII)
1718  FORMAT(1H ,'Lag ',I5,5X,'Q (m,se)',2F14.4,5X,'rejects ',F5.0
     +,' times')
5527  continue      
      WQQ(JNND,JNNK)  =  WQQ(JNND,JNNK) / WCO 
      WQQ2(JNND,JNNK)  =   DSQRT(DABS(WQQ2(JNND,JNNK) / WCO
     + - WQQ(JNND,JNNK) ** 2)) 
      WRITE(LPRINT, 1719) WQQ(JNND,JNNK),WQQ2(JNND,JNNK),WCQQ(JNND,JNNK)
1719  FORMAT(1H ,'Test QQ (mean,se)',2F14.4,5X,'rejects ',F5.0,' times')      
       ENDIF
      WRITE(LPRINT, 1707)
1707  FORMAT(1H  ,'/')
701   CONTINUE

      CLOSE(UNIT=LDUM1)
      CLOSE(UNIT=LDUM2)
      CLOSE(UNIT=LPRINT)
      STOP
      END


      REAL*8 FUNCTION FFB(Z, MOB, NHB, NM, ND, R, MK, NK, NK1, NJ
     +, S2, MP1, NP, NP1, MSPAN, NXP, LAHP, X, RES, VFIT, PPP, STDPPP
     +, XMAT, PHI, STDPHI, AUX1, VC1, BB, CC, IP, IQ, KKKN
     +, iprint, lprint, ifault)

C FUNCTION FFB ESTIMATES A SUBSET SELF-EXCITING THRESHOLD AUTOREGRESSIVE
C WITH K REGIMES GIVEN  THRESHOLD LAG, THRESHOLD PARAMETER, ORDER AND 
C LAGS FOR EACH REGIME : OUTPUT IS THE LEAST NAIC MODEL, THE VALUE OF 
C THE FUNCTION IS SET TO THE LEAST NAIC 
C !WARNING! NK1=NK+1, R(1)..R(NK1) ARE ALL THRESHOLDS (TRIVIAL OR NOT)   

      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION Z(NHB), R(NK1), NJ(NK), S2(NK), NXP(NK), LAHP(MK, NP)
     +, X(NHB), RES(NHB), VFIT(NHB), PPP(MK, NP1), STDPPP(MK, NP1)
     +, XMAT(MOB, NP1), PHI(NP1), STDPHI(NP1), AUX1(NP1), VC1(MP1, NP1)
     +, BB(NP1), CC(NP1), IP(NP1), IQ(NP1), KKKN(NHB)  
      DATA  ZERO , TOL, BIG/ 0.0D-000 , 8.43D-37 ,  3.37D+38 /

C        NP IS THE MAX N. OF PARAMETERS AR == THE LARGEST ALLOWABLE LAG
C        THE SUBSET AUTOREGRESSIVE MODEL LAGS ARE STORED IN LAHP

C      write(lprint, 152) 
C152   format(1h   ,'Enter FFB  ')

c        set initial value for FFB

      FFB  = BIG 

c        set error flag : ifault = 0 if normal exit

      IFAULT  =  0

C      WRITE(LPRINT,  155)
C155   FORMAT(1H  ,'SUBSET AR.....')

c +++    subset autoregressive computation starts

      DO  419  IIII = 1 , nk
      DO  419   JJJJ = 1, np1
      PPP(IIII, JJJJ) =  zero
419   STDPPP(IIII, JJJJ) =  zero

      do  12  ii = 1  ,  nk
      nkp =  nxp(ii)	   !numero di parametri dell'AR
      nkp1  =  nkp + 1   !Numero totale di parametri (costante + AR)
      rlow =  r(ii)
      rhigh =  r(ii + 1)
      
c    Builds the matrix XMAT for AR subset parameter estimate
c    It is not necessary to set some integer n0=max(nd,np), as in Tong
c    and Lim, 1980, p. 257, because NM is given as input so that
c    NM >= max(nd,np)
     
      nkb  =  0
      NM1 =  NM + 1
      do  6  j = nm1 ,  nhb  !FONDAMENTALE
      if(z(j - nd) .gt. rlow .and. z(j - nd) .le. rhigh)  then
      nkb =  nkb  + 1
      x(nkb) = z(j)
      KKKN(NKB) =  J
      xmat(nkb, 1) = 1D0
      IF(NKP  .LE.  0) GOTO  77
      do  7  lagh =  1 ,  NKP
      ntp  =  lahp(ii , lagh)
      lag1  =  lagh + 1
      jj  =  j - ntp
      if(jj  .ge.  1)  then
      xmat(nkb , lag1)  =  z(jj)
      else
      xmat(nkb, lag1)  =  zero 
      endif
7     continue 
77    CONTINUE
      endif
6     continue

C      WRITE(LPRINT, 1414) NKB
C1414   FORMAT(1H  ,'NHB PER subset AR', i5) 

      CALL REGRES(X, XMAT, MOB, NKB, PHI, NKP1, AUX1, VC1, MP1, BB, CC
     +, IP, IQ, TOL, MSING)

c       subset ARMA estimate, singular matrix IFAULT = -1

      IF(MSING  .EQ.  2)  THEN
      IFAULT  =  -1
      RETURN
      ENDIF

c        residuals and residual sum of squares calculation 

C      WRITE(LPRINT, 129)  II
C129   FORMAT(1H  ,'SUBSET SETAR: X,VFIT,RES. REGIME ',  I5)

      sskp =  zero
      do  19  jj =  1  ,  nkb
      zo1 =  zero
      do  18  ij  =  1 , nkp1
18    zo1 = zo1 +  phi(ij) * xmat(jj, ij)
      vfit(jj) =  zo1 
      sskp =  sskp + (x(jj) - vfit(jj)) * (x(jj) - vfit(jj))
      j =  kkkn(jj)
      res(j)  =  x(jj) - vfit(jj)	 !CALCOLO NkB RESIDUI

C      WRITE(LPRINT, 130) JJ, J, X(JJ), VFIT(JJ), RES(J)
C130   FORMAT(1H  ,2I5,  3F10.4)

19    continue

c        standard error of the estimated parameters

      hsigma =  dsqrt(dabs(sskp / dble(NKB)))
      do  33312  ij =  1  , NKP1
33312 stdphi(ij) = hsigma * dsqrt(dabs(VC1(ij , ij))) 

      if(iprint .eq. 1)  then
      WRITE(LPRINT, 151) II, NKB
151   FORMAT(1H    ,'....Regime ', I6,5x, 'NHB PER AR', i5)
      SSV  =  SSKP / DBLE(NKB)
      WRITE(LPRINT, 131) SSKP, SSV
131   FORMAT(1H  ,'RESIDUAL SSQ, VAR ', 2E16.5)
      WRITE(LPRINT, 140)
140   FORMAT(1H   ,'PARAMETER ESTIMATES')
      WRITE(LPRINT,  137) (PHI(IJ), IJ=1, NKP1)
137   FORMAT(1H   ,7F10.4)
      WRITE(LPRINT, 147)
147   FORMAT(1H   ,'PARAMETER ESTIMATES STANDARD ERRORS')
      WRITE(LPRINT,  148) (STDPHI(IJ), IJ=1, NKP1)
148   FORMAT(1H   ,7F10.4)
      endif

      DO 417 IJ=1, NKP1
      PPP(II,IJ) = PHI(IJ)       !PARAMETRI PER REGIME
417   STDPPP(II,IJ) = STDPHI(IJ) !DEVIAZIONE STANDARD
      nj(ii)  =  nkb             !NUMERO DI OSSERVAZIONI IN OGNI REGIME
      s2(ii)  =  sskp            !SOMMA DEI QUADRATI

c +++     subset AR computation ends

12    continue            

C     End loop over the regimes 

C      WRITE(LPRINT,  132)
C132   FORMAT(1H  ,'SUBSET AR: Z,RES. ALL REGIMES')
C      DO 133  J =1 , NHB
C133   WRITE(LPRINT, 134)  J, Z(J), RES(J)
C134   FORMAT(1H  ,I5, 2F10.4)  

c +++     NAIC criterion computation starts

      crki =  ZERO
      do 40 ii  =1  ,  Nk
      sskp  =  s2(ii)
      nkp =  nxp(ii)	   !numero di parametri dell'AR
      ntpq =  NKP + 1 !NUMERO TOTALE PARAMETRI
      ik  =  nj(ii)!NUMERO DI OSSERVAZIONI PER REGIME
      chrki = DBLE(IK) * dlog(sskp / dble(ik)) + dble(ntpq) * 2D0 
      crki  =  crki +  chrki    

C      WRITE(LPRINT, 135) II
C135   FORMAT(1H   ,'REGIME ', I5)
C      WRITE(LPRINT,  136) SSKP, NJ(II), NTPQ, IK, CHRKI
C136   FORMAT(1H   ,'SSKP,NJ,NTPQ,IK,CHRKI'/1H   ,E12.4, 3I10, E12.4) 

40    CONTINUE

	n0 =  max0(nd, max0(np, nm))
	crki= crki / dble(nhb-n0)
      FFB  =  crki 

c +++     NAIC criterion computation ends

      if(iprint  .eq.  1)  then
      WRITE(LPRINT, 102) nd
102   FORMAT(1H  ,'delay parameter ND = ', I5)
      WRITE(LPRINT, 103) nk
103   FORMAT(1H  ,'number of regimes nK = ', I5)
      WRITE(LPRINT, 104)
104   FORMAT(1H  ,'threshold vector R')
      WRITE(LPRINT, 105) (R(IK), IK=1,  nk1)
105   format(1h  ,10f7.4)
      WRITE(LPRINT, 106)
106   FORMAT(1H  ,'nobs per regime vector NJ')
      WRITE(LPRINT, 107) (NJ(IK), IK=1,  nk)
107   FORMAT(1H   ,  14I5)
      WRITE(LPRINT, 108) 
108   FORMAT(1H   ,  'sum of squares per regime S2')
      write(lprint , 109)  (s2(IK), IK=1,  nk)
109   format(1h  , 7F10.4)
      write(lprint, 110)
110   format(1h  ,'subset autoregressive for each regime')
      sskp  =  zero
      do  111  ii  =1  ,  nk
      write(lprint, 112) ii
112   format(1h   ,'regime n. ', I5)
      nxxp = nxp(ii)
      write(lprint, 113) nxxp
113   format(1h  ,'AR order nxxp = ', I5)
      write(lprint, 114) 
114   format(1h  ,'subset AR lags')
      write(lprint, 115) (lahp(ii, j), j=1, nxxp)
115   format(1h   ,14I5)
      sskp =  sskp + s2(ii)
111   continue
      nosser= 0
      do 1980 i= 1, nk
1980	nosser= nosser + nj(i)
      ssv  =  sskp / dble( NOSSER)
      write(lprint, 119) sskp, ssv
119 	format(1h  ,'pooled ssq and var =  ', 2E16.5)
      write(lprint, 120) crki
120   format(1h  ,'NAIC value ',  E16.5)
      write(lprint, 122) ffb
122   format(1h   ,'Exit FFB = ', D14.6)
      endif

      RETURN
      END


      SUBROUTINE GRADU(X,XX,XORD,N,NG,NUM)
      IMPLICIT REAL*8(A - H , O -Z)
      DIMENSION X(NUM),XX(NUM),XORD(NUM),N(NUM),NG(NUM)
          big  =   3.37D+38
      DO   1   I   =  1  , NUM
1     XX(I)   =    X(I)
       K   =    0
3     K  =   K   +   1
      AMIN   =   big
	 DO  2   I   =   1   ,   NUM
       IF(XX(I).GE.AMIN)    GOTO  2
      AMIN   =    XX(I)
       J   =   I
2     CONTINUE
      XORD(K)   =    XX(J)
      N(J)   =   K
      NG(K)   =   J
      XX(J)    =     big
      IF(K.LT.NUM)     GOTO  3
      RETURN
      END


      SUBROUTINE REGRES(Y, XMAT, MOB, NOB, P, NP, A, D, MP, B, C, IP, IQ
     +, EPS, MSING)

C   Linear regression ordinary least squares : p = (X'X)^(-1) X'y
C   msing = 1, normal exit; msing = 2, the matrix X'X is singular

      IMPLICIT REAL*8 (A - H , O - Z)
      DIMENSION  Y(NOB), XMAT(MOB, NP), P(NP), A(NP) 
     +, D(MP, NP), B(NP), C(NP), IP(NP), IQ(NP)

C   X'X -> D (here X == XMAT)

      DO  1  I  =1  ,  NP
      DO 1  J  =1  ,  NP
      SUM  =  0.0
      DO  2  K  =1  ,  NOB
2     SUM  =  SUM  +  XMAT(K , I) * XMAT(K , J)
1     D(I , J)  =  SUM

C   (X'X)^(-1) -> D

      CALL  DGJR(D, NP, MP, EPS, MSING, B, C, IP, IQ)
      IF(MSING .EQ. 2)  RETURN

C   X'y -> a

      DO  3  I  =1  ,  NP
      SUM  =  0.0
      DO  4  K  =1  ,  NOB
4     SUM =  SUM + XMAT(K , I) * Y(K)
3     A(I)  =  SUM

C   (X'X)^(-1) X'y == Da -> p

      DO  5  I =1  ,  NP
      SUM  =  0.0
      DO  6  J  =1  ,  NP
6     SUM  =  SUM +  D(I , J) * A(J)
5     P(I) =  SUM
C                                                             End REGRES
      RETURN
      END


      SUBROUTINE DGJR(A,N,MM,EPS,MSING,B,C,P,Q)
C----     GAUSS-JORDAN-RUTISHAUSER MATRIX INVERSION WITH DOUBLE PIVOTING
      IMPLICIT REAL*8 (A - H , O - Z)
      INTEGER P,Q
      DIMENSION A(MM,N),B(N),C(N),P(N),Q(N)
      MSING=1
      DO 10 K=1,N
C----     DETERMINATION OF THE PIVOT ELEMENT
      PIVOT=0.0
      DO 20 I=K,N
      DO 20 J=K,N
      IF(DABS(A(I,J))-DABS(PIVOT)) 20,20,30
30    PIVOT=A(I,J)
      P(K)=I
      Q(K)=J
20    CONTINUE
      IF(DABS(PIVOT)-EPS) 40,40,50
C----     EXCHANGE OF THE PIVOTAL ROW WITH THE K-TH ROW
50    IF(P(K)-K) 60,80,60
60    DO 70 J=1,N
      L=P(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
70    A(K,J)=Z
C----     EXCHANGE OF THE PIVOTAL COLUMN WITH THE K-TH COLUMN
80    IF(Q(K)-K) 85,90,85
85    DO 100 I=1,N
      L=Q(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
100   A(I,K)=Z
90    CONTINUE
C----     JORDAN STEP
      DO 110 J=1,N
      IF(J-K) 130,120,130
120   B(J)=1.0/PIVOT
      C(J)=1.0
      GOTO 140
130   B(J)=-A(K,J)/PIVOT
      C(J)=A(J,K)
140   A(K,J)=0.0
110   A(J,K)=0.0
      DO 10 I=1,N
      DO 10 J=1,N
10    A(I,J)=A(I,J)+C(I)*B(J)
C----     REORDERING THE MATRIX
      DO 155 M=1,N
      K=N-M+1
      IF(P(K)-K) 160,170,160
160   DO 180 I=1,N
      L=P(K)
      Z=A(I,L)
      A(I,L)=A(I,K)
180   A(I,K)=Z
170   IF(Q(K)-K) 190,155,190
190   DO 150 J=1,N
      L=Q(K)
      Z=A(L,J)
      A(L,J)=A(K,J)
150   A(K,J)=Z
155   CONTINUE
151   RETURN
40    CONTINUE
      MSING=2
      GOTO 151
      END
                                                                       

      REAL*8 FUNCTION DOTPRD(P, X, Y)                                   ARI03050
C                                                                       ARI03060
C  ***  RETURN THE INNER PRODUCT OF THE P-VECTORS X AND Y.  ***         ARI03070
C                                                                       ARI03080
C                                                                       ARI03090
C     THIS PROGRAM IS TAKEN FROM :                                      ARI03100
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI03110
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI03120
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI03130
C     SEPTEMBER 1981                                                    ARI03140
C                                                                       ARI03150
      INTEGER P                                                         ARI03160
      REAL*8 X(P), Y(P)                                                 ARI03170
C                                                                       ARI03180
      INTEGER I                                                         ARI03190
      REAL ONE, SQTETA, T, ZERO                                         ARI03200
C/+                                                                     ARI03210
      REAL*8 DMAX1, DABS                                                ARI03220
      REAL  ABS
C/                                                                      ARI03230
      EXTERNAL RMDCON                                                   ARI03240
      REAL RMDCON                                                       ARI03250
C                                                                       ARI03260
C  ***  RMDCON(2) RETURNS A MACHINE-DEPENDENT CONSTANT, SQTETA, WHICH   ARI03270
C  ***  IS SLIGHTLY LARGER THAN THE SMALLEST POSITIVE NUMBER THAT       ARI03280
C  ***  CAN BE SQUARED WITHOUT UNDERFLOWING.                            ARI03290
C                                                                       ARI03300
C/6                                                                     ARI03310
      DATA ONE/1.E+0/, SQTETA/0.E+0/, ZERO/0.E+0/                       ARI03320
C/7                                                                     ARI03330
C     PARAMETER (ONE=1.D+0, ZERO=0.D+0)                                 ARI03340
C     DATA SQTETA/0.D+0/                                                ARI03350
C/                                                                      ARI03360
C                                                                       ARI03370
      DOTPRD = ZERO                                                     ARI03380
      IF (P .LE. 0) GO TO 999                                           ARI03390
      IF (SQTETA .EQ. ZERO) SQTETA = RMDCON(2)                          ARI03400
      DO 20 I = 1, P                                                    ARI03410
         T = DMAX1(DABS(X(I)), DABS(Y(I)))                              ARI03420
         IF (T .GT. ONE) GO TO 10                                       ARI03430
         IF (T .LT. SQTETA) GO TO 20                                    ARI03440
         T = (X(I)/SQTETA)*Y(I)                                         ARI03450
         IF (ABS(T) .LT. SQTETA) GO TO 20                               ARI03460
 10      DOTPRD = DOTPRD + X(I)*Y(I)                                    ARI03470
 20   CONTINUE                                                          ARI03480
C                                                                       ARI03490
 999  RETURN                                                            ARI03500
C  ***  LAST CARD OF DOTPRD FOLLOWS  ***                                ARI03510
      END                                                               ARI03520


      REAL FUNCTION RMDCON(K)                                           ARI14080
                                                                        ARI14090
C  ***  RETURN MACHINE DEPENDENT CONSTANTS                 ***          ARI14100
C                                                                       ARI14110
C     THIS PROGRAM IS TAKEN FROM :                                      ARI14120
C     J.E.DENNIS, D.M.GAY AND R.E.WELSCH, 'ALGORITHM 573 NL2SOL-        ARI14130
C     AN ADAPTIVE NONLINEAR LEAST-SQUARES ALGORITHM E4| ',             ARI14140
C     ACM TRANSECTIONS ON MATHEMATICAL SOFTWARE, VOL.7, NO.3,           ARI14150
C     SEPTEMBER 1981                                                    ARI14160
C                                                                       ARI14170
C +++  COMMENTS BELOW CONTAIN DATA STATEMENTS FOR VARIOUS MACHINES.  +++ARI14180
C +++  TO CONVERT TO ANOTHER MACHINE, PLACE A C IN COLUMN 1 OF THE   +++ARI14190
C +++  DATA STATEMENT LINE(S) THAT CORRESPOND TO THE CURRENT MACHINE +++ARI14200
C +++  AND REMOVE THE C FROM COLUMN 1 OF THE DATA STATEMENT LINE(S)  +++ARI14210
C +++  THAT CORRESPOND TO THE NEW MACHINE.                           +++ARI14220
C                                                                       ARI14230
      INTEGER K                                                         ARI14240
C                                                                       ARI14250
C  ***  THE CONSTANT RETURNED DEPENDS ON K...                           ARI14260
C                                                                       ARI14270
C  ***        K = 1... SMALLEST POS. ETA SUCH THAT -ETA EXISTS.         ARI14280
C  ***        K = 2... SQUARE ROOT OF 1.001*ETA.                        ARI14290
C  ***        K = 3... UNIT ROUNDOFF = SMALLEST POS. NO. MACHEP SUCH    ARI14300
C  ***                 THAT 1 + MACHEP .GT. 1 .AND. 1 - MACHEP .LT. 1.  ARI14310
C  ***        K = 4... SQUARE ROOT OF 0.999*MACHEP.                     ARI14320
C  ***        K = 5... SQUARE ROOT OF 0.999*BIG (SEE K = 6).            ARI14330
C  ***        K = 6... LARGEST MACHINE NO. BIG SUCH THAT -BIG EXISTS.   ARI14340
C                                                                       ARI14350
      REAL BIG, ETA, MACHEP                                             ARI14360
                                                                        ARI14370
      REAL SQRT                                                         ARI14380
                                                                        ARI14390
      REAL ONE001, PT999                                                ARI14400
                                                                        ARI14410
      DATA ONE001/1.001/, PT999/0.999/                                  ARI14420
                                                                        ARI14430
C  +++  IBM 360, IBM 370, OR XEROX  +++                                 ARI14440
C                                                                       ARI14450
C      DATA BIG/Z7FFFFFFF/, ETA/Z00100000/, MACHEP/Z3C100000/           ARI14460
C                                                                       ARI14470
C  +++  DATA GENERAL  +++                                               ARI14480
C                                                                       ARI14490
C     DATA BIG/0.7237E+76/, ETA/0.5398E-78/, MACHEP/0.9537E-06/         ARI14500
C                                                                       ARI14510
C  +++  DEC 11  +++                                                     ARI14520
C                                                                       ARI14530
C     DATA BIG/1.7E+38/, ETA/2.9388E-39/, MACHEP/1.1921E-07/            ARI14540
C                                                                       ARI14550
C  +++  HP3000  +++                                                     ARI14560
C                                                                       ARI14570
C     DATA BIG/1.1579E+77/, ETA/8.6362E-78/, MACHEP/2.3842E-07/         ARI14580
C                                                                       ARI14590
C  +++  HONEYWELL  +++                                                  ARI14600
C                                                                       ARI14610
C     DATA BIG/O376777000000/, ETA/O404400400000/,                      ARI14620
C    1     MACHEP/O716400000000/                                        ARI14630
C                                                                       ARI14640
C  +++  DEC10  +++                                                      ARI14650
C                                                                       ARI14660
C     DATA BIG/"377777777777/, ETA/"000400000021/,                      ARI14670
C    1     MACHEP/"147400000000/                                        ARI14680
C                                                                       ARI14690
C  +++  BURROUGHS  +++                                                  ARI14700
C                                                                       ARI14710
C     DATA BIG/O0777777777777777/, ETA/O1771000000000000/,              ARI14720
C    1     MACHEP/O1301000000000000/                                    ARI14730
C                                                                       ARI14740
C  +++  CONTROL DATA  +++                                               ARI14750
C                                                                       ARI14760
C     DATA BIG/37754000000000000000B/, ETA/00024000000000000000B/,      ARI14770
C    1     MACHEP/16414000000000000000B/                                ARI14780
C                                                                       ARI14790
C  +++  PRIME  +++                                                      ARI14800
C                                                                       ARI14810
C     DATA BIG/1.7E+38/, ETA/1.47E-39/, MACHEP/2.38419E-7/              ARI14820
C                                                                       ARI14830
C  +++  UNIVAC  +++                                                     ARI14840
C                                                                       ARI14850
C     DATA BIG/1.69E+38/, ETA/5.9E-39/, MACHEP/1.4901162E-8/            ARI14860
C                                                                       ARI14870
C  +++  VAX  +++                                                        ARI14880
C                                                                       ARI14890
C     DATA BIG/1.7E+38/, ETA/2.939E-39/, MACHEP/5.9604645E-08/          ARI14900
C
c  approximations of real numbers in floating-point form (1 to 7 digits)        
c  from 8.43E-37 to 3.37E+38 (assumed zero if less/equal than 0.000015)
        big  =  3.37E+38
        eta  =   8.43E-37 
        machep  = 0.000015 
C                                                                       ARI14910
C-------------------------------  BODY  --------------------------------ARI14920
                                                                        ARI14930
      GO TO (10, 20, 30, 40, 50, 60), K                                 ARI14940
                                                                        ARI14950
 10   RMDCON = ETA                                                      ARI14960
      GO TO 999                                                         ARI14970
                                                                        ARI14980
 20   RMDCON = SQRT(ONE001*ETA)                                         ARI14990
      GO TO 999                                                         ARI15000
                                                                        ARI15010
 30   RMDCON = MACHEP                                                   ARI15020
      GO TO 999                                                         ARI15030
                                                                        ARI15040
 40   RMDCON = SQRT(PT999*MACHEP)                                       ARI15050
      GO TO 999                                                         ARI15060
                                                                        ARI15070
 50   RMDCON = SQRT(PT999*BIG)                                          ARI15080
      GO TO 999                                                         ARI15090
                                                                        ARI15100
 60   RMDCON = BIG                                                      ARI15110
                                                                        ARI15120
 999  RETURN                                                            ARI15130
C  ***  LAST CARD OF RMDCON FOLLOWS  ***                                ARI15140
      END                                                               ARI15150
                                                                        ARI15160

      REAL*8 FUNCTION SUMF(X,N)
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(N)                                                    
      SUMF=0.0                                                          
      DO 10 I=1,N                                                       
   10 SUMF=SUMF+X(I)                                                    
      RETURN                                                            
      END                                                               


      REAL*8 FUNCTION RMEAN(X,NOB)                                      ARI01510
C                                                                       ARI01520
C----      DOUBLE PRECISION FUNCTION RMEAN                              ARI01530
C                                                                       ARI01540
C      CALCULATES THE SAMPLE MEAN OF A SERIES OF NOB OBSERVATIONS       ARI01550
C                                                                       ARI01560
C----                                                                   ARI01570
C                                                                       ARI01580
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01590
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01600
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01610
C                                                                       ARI01620
C----                                                                   ARI01630
C                                                                       ARI01640
C      X:  OBSERVED TIME SERIES OF NOB VALUES                           ARI01650
C                                                                       ARI01660
C----                                                                   ARI01670
C                                                                       ARI01680
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB)                                                  ARI01690
      SUM=0                                                             ARI01700
      DO 10 J=1,NOB                                                     ARI01710
  10  SUM=SUM+X(J)                                                      ARI01720
      RMEAN=SUM/FLOAT(NOB)                                              ARI01730
      RETURN                                                            ARI01740
      END                                                               ARI01750


      REAL*8 FUNCTION CPROXY(X,XBAR,Y,YBAR,NOB)                         ARI01760
C                                                                       ARI01770
C----     DOUBLE PRECISION FUNCTION CPROXY                              ARI01780
C                                                                       ARI01790
C      CALCULATES SUM OF PRODUCTS OF DEVIATIONS OF TWO VARIABLES        ARI01800
C      FROM SPECIFIED CENTRAL VALUES                                    ARI01810
C                                                                       ARI01820
C----                                                                   ARI01830
C                                                                       ARI01840
C      THIS PROGRAM IS TAKEN FROM " A COMPUTER PROGRAM FOR THE          ARI01850
C      ANALYSIS OF TIME SERIES MODELS USING THE BOX-JENKINS PHILOSOPHY "ARI01860
C      BY D.J.PACK (1979) AUTOMATIC FORECASTING SYSTEMS, INC.           ARI01870
C                                                                       ARI01880
C----                                                                   ARI01890
C                                                                       ARI01900
C      X,Y:      REAL ARRAYS OF LENGTH NOB.                             ARI01910
C                ON ENTRY CONTAIN VALUES OF THE TWO VARIABLES           ARI01920
C      XBAR,YBAR:X'S AND Y'S MEAN RESPECTIVELY                          ARI01930
C                                                                       ARI01940
C----                                                                   ARI01950
C                                                                       ARI01960
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION X(NOB),Y(NOB)                                           ARI01970
      S=0                                                               ARI01980
      DO 10 I=1,NOB                                                     ARI01990
  10  S=S+(X(I)-XBAR)*(Y(I)-YBAR)                                       ARI02000
      CPROXY=S                                                          ARI02010
      RETURN                                                            ARI02020
      END                                                               ARI02030


      SUBROUTINE ZCOR(C,NOB,NAC,R,SER,DM,DSD,IEXIT)                     ARI02040
C                                                                       ARI02050
C-----     SUBROUTINE ZCOR                                              ARI02060
C                                                                       ARI02070
C     CALCULATES AUTOCORRELATIONS AND THEIR STANDARD ERRORS             ARI02080
C                                                                       ARI02090
C-----                                                                  ARI02100
C                                                                       ARI02110
C     C     SERIES INPUT OF NOB OBS.                                    ARI02120
C     NAC   MAXIMUM LAG                                                 ARI02130
C     R     AUTOCORRELATION FUNCTION OF NAC VALUES                      ARI02140
C     SER  AUTOCOVARIANCE FUNCTION OF NAC VALUES                        ARI02150
C     DM    MEAN OF THE SERIES                                          ARI02160
C     DSD   STANDARD ERROR OF THE SERIES                                ARI02170
C     IEXIT IF NAC>= NOB IEXIT IS SET TO -1                             ARI02180
C           UNLESS THIS ONE ERROR IS DETECTED IEXIT                     ARI02190
C           CONTAINS ZERO ON EXIT                                       ARI02200
C                                                                       ARI02210
C-----                                                                  ARI02220
C                                                                       ARI02230
      IMPLICIT REAL*8(A-H , O-Z)
      DIMENSION C(NOB),R(NAC),SER(NAC)                                  ARI02240
      IEXIT=0                                                           ARI02250
      IF(NOB-NAC) 100,100,20                                            ARI02260
   20 DIV=NOB                                                           ARI02270
      DM=RMEAN(C,NOB)                                                   ARI02280
      DENOM=CPROXY(C,DM,C,DM,NOB)                                       ARI02290
      DSD=DSQRT(DENOM/DIV)                                              ARI02300
      DO 30 K=1,NAC                                                     ARI02310
      M=NOB-K                                                           ARI02320
      HNUM=CPROXY(C(1),DM,C(K+1),DM,M)                                  ARI02330
      SER(K)=HNUM/DIV                                                   ARI02340
      R(K)=HNUM/DENOM                                                   ARI02350
   30 CONTINUE                                                          ARI02360
      NAC1=NAC+1                                                        ARI02370
      DO 40 K=1,NAC                                                     ARI02380
      M=NAC1-K+1                                                        ARI02390
      R(M)=R(M-1)                                                       ARI02400
      SER(M)=SER(M-1)                                                   ARI02410
   40 CONTINUE                                                          ARI02420
      R(1)=1.0                                                          ARI02430
      SER(1)=DSD*DSD                                                    ARI02440
      RETURN                                                            ARI02450
  100 IEXIT=-1                                                          ARI02460
      RETURN                                                            ARI02470
      END                                                               ARI02480


      double precision function DFIN(nu1,nu2,alpha,ifault)
      implicit double precision (a-h,o-z)

C  The percentage points of the F distribution with nu1 (numerator) and
C  nu2 (denominator) degrees of freedom, (1 - alpha  critical values)
C  normal exit if ifault = 0; ifault =1 if either nu1 or nu2 <= 0
C  ifault = 2  if alpha  is located outside the interval (0 , 1)

      p  =  dble(nu1) / 2D0 
      q = dble(nu2) / 2D0
      xlnb = dlog(beta(p,q)) 
      value = xinbta(p,q,xlnb,alpha,ifault)
      DFIN = (dble(nu2) / dble(nu1)) * (value / (1D0 - value))
      return
      end
      

      double precision function xinbta(p,q,beta,alpha,ifault)
      implicit double precision (a-h,o-z)
c
c     algorithm as 109 appl. statist. (1977), vol.26, no.1
c     (replacing algorithm as 64  appl. statist. (1973),
c     vol.22, no.3)
c
c     Remark AS R83 and the correction in vol40(1) p.236 have been 
c     incorporated in this version.
c
c     Computes inverse of the incomplete beta function
c     ratio for given positive values of the arguments
c     p and q, alpha between zero and one.
c     log of complete beta function, beta, is assumed to be known.
c
c     Auxiliary function required: BETAIN = algorithm AS63
c
      logical indx
c
c     Define accuracy and initialise.
c     SAE below is the most negative decimal exponent which does not 
c     cause an underflow; a value of -308 or thereabouts will often be 
c     OK in double precision.
c
c     data acu/1.0d-14/
      data SAE/-37.D0/
      data zero/0.0d0/, one/1.0d0/, two/2.0d0/
      data three/3.0d0/, four/4.0d0/, five/5.0d0/, six/6.0d0/
c
      fpu = 10.d0 ** sae
      xinbta = alpha
c
c     test for admissibility of parameters
c
      ifault = 1
      if (p.le.zero .or. q.le.zero) return
      ifault = 2
      if (alpha.lt.zero .or. alpha.gt.one) return
      ifault = 0
      if (alpha.eq.zero .or. alpha.eq.one) return
c
c     change tail if necessary
c
      if (alpha.le.0.5d0) goto 1
      a = one-alpha
      pp = q
      qq = p
      indx = .true.
      goto 2
    1 a = alpha
      pp = p
      qq = q
      indx = .false.
c
c     calculate the initial approximation
c
    2 r = dsqrt(-dlog(a*a))
      y = r-(2.30753d0+0.27061d0*r)/(one+(0.99229d0+0.04481d0*r)*r)
      if(pp.gt.one .and. qq.gt.one) goto 5
      r = qq+qq
      t = one/(9.0d0*qq)
      t = r*(one-t+y*dsqrt(t))**3
      if(t.le.zero) goto 3
      t = (four*pp+r-two)/t
      if(t.le.one) goto 4
      xinbta = one-two/(t+one)
      goto 6
    3 xinbta = one-dexp((dlog((one-a)*qq)+beta)/qq)
      goto 6
    4 xinbta = dexp((dlog(a*pp)+beta)/pp)
      goto 6
    5 r = (y*y-three)/six
      s = one/(pp+pp-one)
      t = one/(qq+qq-one)
      h = two/(s+t)
      w = y*dsqrt(h+r)/h-(t-s)*(r+five/six-two/(three*h))
      xinbta = pp/(pp+qq*dexp(w+w))
c
c     solve for x by a modified newton-raphson method,
c     using the function betain
c
    6 r = one-pp
      t = one-qq
      yprev = zero
      sq = one
      prev = one
      if(xinbta.lt.0.0001d0) xinbta = 0.0001d0
      if(xinbta.gt.0.9999d0) xinbta = 0.9999d0
      IEX = MAX(-5.D0/PP**2 - 1.D0/A**.2 - 13.D0, SAE)
      ACU = 10.D0 ** IEX
    7 y = betain(xinbta,pp,qq,beta,ifault)
      if(ifault.eq.0) goto 8
      ifault = 3
      return
    8 continue
      xin = xinbta
      y = (y-a)*exp(beta+r*log(xin)+t*log(one-xin))
      if(y*yprev.le.zero) prev = max(sq, fpu)
      g = one
    9 adj = g*y
      sq = adj*adj
      if(sq.ge.prev) goto 10
      tx = xinbta-adj
      if(tx.ge.zero .and. tx.le.one) goto 11
   10 g = g/three
      goto 9
   11 if(prev.le.acu) goto 12
      if(y*y.le.acu) goto 12
      if(tx.eq.zero .or. tx.eq.one) goto 10
      if(tx.eq.xinbta) goto 12
      xinbta = tx
      yprev = y
      goto 7
   12 if (indx) xinbta = one-xinbta
      return
      end


      double precision function betain(x, p, q, beta, ifault)
      implicit double precision (a-h, o-z)
c
c     algorithm as 63  appl. statist. (1973), vol.22, no.3
c
c     computes incomplete beta function ratio for arguments
c     x between zero and one, p and q positive.
c     log of complete beta function, beta, is assumed to be known
c
      logical indx
c
c     define accuracy and initialise
c
      data zero/0.0d0/, one/1.0d0/, acu/0.1d-14/
      betain=x
c
c     test for admissibility of arguments
c
      ifault=1
      if(p.le.zero .or. q.le.zero) return
      ifault=2
      if(x.lt.zero .or. x.gt.one) return
      ifault=0
      if(x.eq.zero .or. x.eq. one) return
c
c     change tail if necessary and determine s
c
      psq=p+q
      cx=one-x
      if(p.ge.psq*x) goto 1
      xx=cx
      cx=x
      pp=q
      qq=p
      indx=.true.
      goto 2
    1 xx=x
      pp=p
      qq=q
      indx=.false.
    2 term=one
      ai=one
      betain=one
      ns=qq+cx*psq
c
c     user soper's reduction formulae.
c
      rx=xx/cx
    3 temp=qq-ai
      if(ns.eq.0) rx=xx
    4 term=term*temp*rx/(pp+ai)
      betain=betain+term
      temp=abs(term)
      if(temp.le.acu .and. temp.le.acu*betain) goto 5
      ai=ai+one
      ns=ns-1
      if(ns.ge.0) goto 3
      temp=psq
      psq=psq+one
      goto 4
c
c     calculate result
c
    5 betain=betain*exp(pp*log(xx)+(qq-one)*log(cx)-beta)/pp
      if(indx) betain=one-betain
      return
      end


      real*8 FUNCTION beta(z,w)
      REAL*8 w , z
CU    USES gammln
      REAL*8 gammln
      beta=dexp(gammln(z)+gammln(w)-gammln(z+w))
      return
      END


      real*8 FUNCTION gammln(xx)
      REAL*8 xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*dlog(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+dlog(stp*ser/x)

      return
      END


      SUBROUTINE KEENAN(Y,Y2,XMAT,MOB,NOB,MP,NP,C2,EPSI,XI,FK,NDF1,NDF2
     +, AUX1,VC1,BB,CC,IP,IQ,EPS,MSING)

C   Keenan's (1985) statistics: FK is distributed as a F random variable
C   with ndf1 = 1 and ndf2 = nob - 2 * np - 2 degrees of freedom

      implicit real*8 (a - h , o - z)
      DIMENSION Y(NOB), Y2(NOB), EPSI(NOB), XI(NOB), XMAT(MOB, NP)
     +, C2(NP), AUX1(NP), VC1(MP, NP), BB(NP), CC(NP), IP(NP), IQ(NP)
      DATA   ZERO/0.0D-000/
c      write(*,*) 'keenan: np ', np
      lprint  =  6
      NP1  =  NP + 1
      DO  5522  I  = 1  ,  NOB
5522  Y2(I) =  Y(I) * Y(I)
       J  =  1
      DO  5527  I  =1  ,  NOB
       XMAT(I , J) = 1D0
5527  CONTINUE
      DO  5524  JJ  =2  ,  NP1
       J  =  JJ - 1
      DO  5523  I  =1  ,  NOB
       IF(J .GE. I)  THEN
       XMAT(I , JJ) = ZERO
       ELSE
       XMAT(I , JJ) =  Y(I - J)
       ENDIF
5523  CONTINUE
5524  CONTINUE
c      write(*,*) 'keenan: np1 ', np1
      CALL REGRES(Y2,XMAT,MOB,NOB,C2,NP1,AUX1,VC1,MP,BB,CC,IP,IQ,EPS
     +,MSING)
      DO  5525  I  =  1  ,  NOB
      SUM  =  ZERO
      DO  5526  J =1 , NP1
5526  SUM =  SUM +  XMAT(I , J) * C2(J)
5525  XI(I) =  Y2(I) -  SUM
c      write(*,*) 'keenan: np1 ', np1
      CALL REGRES(Y,XMAT,MOB,NOB,C2,NP1,AUX1,VC1,MP,BB,CC,IP,IQ,EPS
     +,MSING)
      DO  5528  I  =  1  ,  NOB
      SUM  =  ZERO
      DO  5529  J =1 , NP1
5529  SUM =  SUM +  XMAT(I , J) * C2(J)
5528  EPSI(I) =  Y(I) -  SUM
      NDF1  =  1
c      write(*,*) 'keenan: NOB,np ', NOB,np
      NDF2  =  NOB - 2 * NP - 2
c      write(*,*) 'keenan: NDF2 ', NDF2
      EPSIXI  =  ZERO
      ETA2  =  ZERO
      EPSI2  =  ZERO
      DO  1  I  =  1  ,  NOB
      EPSIXI = EPSIXI + EPSI(I) * XI(I)
      ETA2  =  ETA2 +  XI(I) * XI(I)
      EPSI2  =  EPSI2 +  EPSI(I) * EPSI(I)
1     CONTINUE
c      write(lprint, 1001) EPSIXI
c1001  format(1h  ,  'EPSIXI = ', F20.10)
c      write(lprint, 1002) ETA2
c1002  format(1h  ,  'ETA2 = ', F20.10)
c      write(lprint, 1000) EPSI2
c1000  format(1h  ,  'EPSI2 = ', F20.10)
      ETA2  =  (EPSIXI ** 2) / ETA2
      FK =  ETA2 * DBLE(NDF2) / (EPSI2 - ETA2)
c      write(lprint, 1004) NDF1, NDF2, ETA2, FK
c1004  format(1h  ,  'NDF1,NDF2,ETA2,FK = ', 2I6, 2F20.10)
      RETURN
      END


      SUBROUTINE D2TEST(PHI,THETA,NPI,NP,NQ,VPHI,YNVPHI,MX,XMATDE
     +,VTHE,YNVTHE,XLN,XILN,XMCOV,MV,NV,NOB,PWEIO,BMAT,DELTAN,TEMPY
     +,OMEGA,T1,T2,T3,AHAT,BHAT,XNU,ALPHA,PX,BHHB,CHHC,IIHP,IIHQ,A1,XCO)

C@:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://////////
C
CNota: La circolazione e diffusione dei seguenti programmi e' libera e 
Cgratuita purche' si citi correttamente ed integralmente la fonte.  
CCorduas M. (2000), La metrica Autoregressiva tra modelli ARIMA: 
Cuna procedura in linguaggio GAUSS, Quaderni di Statistica, 2, 1-37
CResta dell'utente ogni responsabilita' per i danni derivanti dall'
Cutilizzo dei programmi qui descritti.
C
C Corduas, M. (2000)
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::://///////// @

      IMPLICIT REAL*8 (A - H, O-Z)
      DIMENSION PHI(NPI), THETA(NPI), VPHI(NPI), YNVPHI(NPI)
     +, XMATDE(MX,NPI),VTHE(NPI),YNVTHE(NPI),XLN(MX,NPI),XILN(MX,NPI)
     +, PWEIO(MX), BMAT(MX, NPI), DELTAN(MX, NPI), TEMPY(MX, NPI)
     +, XMCOV(MV,NV), OMEGA(MV,NV)
     +, BHHB(NPI),CHHC(NPI),IIHP(NPI),IIHQ(NPI)
      DATA  EPS/8.43D-37/

C     Parameters variance-covariance matrix V->XMCOV computation
C     DELTAN and inverse L->XLENNE matrix computation
C     Pi-weights derivatives matrix BMAT computation
C     Vector v->VPHI computation

      LPRINT =  6
C      WRITE(LPRINT,  101)
C101   FORMAT(1H  ,'Enter D2TEST ...')
C      WRITE(LPRINT, 102)
C102   FORMAT(1H   ,'PHI ')
C      WRITE(LPRINT, 1000) (PHI(I) , I = 1 , NP)
C      WRITE(LPRINT, 103)
C103   FORMAT(1H   ,'THETA ')
C      WRITE(LPRINT, 1000) (THETA(I) , I = 1 , NQ)
C      WRITE(LPRINT, 1001)      

      I =  1
      VPHI(I)  =  -1.0
      IF(NP  .GT.  0)  THEN
      DO  10  II =1  ,  NP
      I  =  I +  1
      VPHI(I)  =  PHI(II)
10    CONTINUE
      ENDIF
      IF(I  .LT. NPI)  THEN
      I1  =  I +  1
      DO  11  II  =  I1,  NPI
11    VPHI(II)  =   0.0
      ENDIF

      CALL  POLINV(PHI, NP, YNVPHI, NPI, XCO, A1)

C     XMATDE matrix for XMCOV computation: autoregressive part

      DO  12  I  =1  ,  NPI
      DO  12  J =  1  ,  NPI
12    XMATDE(I , J) =  0.0
      IF(NP .GT.  0)  THEN
      DO  13  J =  1 ,  NP
      I1  =  J +  1
      II  =  0
      DO  14  I  =  I1  , NPI
      II  =  II  + 1
14    XMATDE(I , J) =   YNVPHI(II)
13    CONTINUE
C      ELSE
C      XMATDE(2,1) =  1.0
      ENDIF

C      WRITE(LPRINT, 104)
C104   FORMAT(1H   , 'VPHI ')
C      WRITE(LPRINT, 1000)  (VPHI(I), I=1  ,  NPI)
C      WRITE(LPRINT, 105)
C105   FORMAT(1H   , 'YNVPHI ')
C      WRITE(LPRINT, 1000)  (YNVPHI(I), I=1  ,  NPI)
C      WRITE(LPRINT, 106)
C106   FORMAT(1H   , 'XMATDE ')
C      DO  901  I  =1  ,  NPI
C901   WRITE(LPRINT, 1000)  (XMATDE(I , J), J=1  ,  NPI)
C      WRITE(LPRINT, 1001)

      I =  1
      VTHE(I)  =  1.0
      IF(NQ  .GT.  0)  THEN
      DO  20  II =1  ,  NQ
      I  =  I +  1
      VTHE(I)  =  -THETA(II)
20    CONTINUE
      ENDIF
      IF(I  .LT. NPI)  THEN
      I1  =  I +  1
      DO  21  II  =  I1,  NPI
21    VTHE(II)  =   0.0
      ENDIF

      CALL  POLINV(THETA, NQ, YNVTHE, NPI, XCO, A1)

C     XMATDE matrix for XMCOV computation: moving average part

C      NP1 = MAX0(2, NP + 1)
      NP1  =  NP  + 1
      NP2  =  NP1 + NQ  - 1
      IF(NQ .GT.  0)  THEN
      I1  =  1
      DO  23  J =  NP1 ,  NP2
      I1  =  I1 +  1
      II  =  0
      DO  24  I  =  I1  , NPI
      II  =  II  + 1
24    XMATDE(I , J) =   -YNVTHE(II)
23    CONTINUE
C      ELSE
C      XMATDE(2,NP1) =  -1.0
      ENDIF

C      WRITE(LPRINT, 204)
C204   FORMAT(1H   , 'VTHE ')
C      WRITE(LPRINT, 1000)  (VTHE(I), I=1  ,  NPI)
C      WRITE(LPRINT, 205)
C205   FORMAT(1H   , 'YNVTHE ')
C      WRITE(LPRINT, 1000)  (YNVTHE(I), I=1  ,  NPI)
C      WRITE(LPRINT, 206)
C206   FORMAT(1H   , 'XMATDE ')
C      DO  902  I  =1  ,  NPI
C902   WRITE(LPRINT, 1000)  (XMATDE(I , J), J=1  ,  NPI)
C      WRITE(LPRINT, 1001)

C     Parameters variance covariance matrix V = inv(U'U / n)
C     ->XMCOV = (XMATDE'XMADTE / N)^-1

      DO 25  I  = 1 ,  NV
      DO  25  J  =  1  ,  NV
      ELEH =  0.0
      DO  26  IJ  =  1  ,  NPI
26    ELEH =  ELEH + XMATDE(IJ, I) * XMATDE(IJ, J)
      XMCOV(I, J)  =  ELEH 
25    CONTINUE

C      WRITE(LPRINT, 210)
C210   FORMAT(1H  ,'XMCOV ')
C      DO  905  I  =1  ,  NV
C905   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)

      CALL DGJR(XMCOV,NV,MV,EPS,MSING,BHHB,CHHC,IIHP,IIHQ)

C      WRITE(LPRINT, 209)
C209   FORMAT(1H  ,'inv(XMCOV) ')
C      DO  910  I  =1  ,  NV
C910   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)

c      DO 211 I = 1 ,  NV
c      DO  211  J  =1  ,  NV
c211   XMCOV(I , J)  =  XMCOV(I , J) / DBLE(NOB)

C      WRITE(LPRINT, 208) NOB
C208   FORMAT(1H  ,'NOB ', I6)
c      WRITE(LPRINT, 250)
c250   FORMAT(1H  ,'inv(XMCOV)/NOB ')
c      DO  950  I  =1  ,  NV
c950   WRITE(LPRINT, 1000)  (XMCOV(I , J), J=1  ,  NV)
C      WRITE(LPRINT, 1001)

C     Build matrix Lenne = lowmat(toeplitz(vthe))
C     and its inverse ILenne

      DO  32  I  =1  ,  NPI
      DO  32  J =  1  ,  NPI
32    XLN(I , J) =  0.0
      DO 33  J  =1  ,  NPI
      J1  =  J
      II  =  0
      DO  34  I  =  J1 , NPI
      II  =  II +  1
34    XLN(I , J)  =  VTHE(II)
33    CONTINUE
      DO  35  I  =1  ,  NPI
      DO  35  J =  1  ,  NPI
35    XILN(I , J) =  XLN(I , J)
      CALL DGJR(XILN,NPI,MX,EPS,MSING,BHHB,CHHC,IIHP,IIHQ)

C      WRITE(LPRINT, 306)
C306   FORMAT(1H   , 'Lenne->XLN ')
C      DO  903  I  =1  ,  NPI
C903   WRITE(LPRINT, 1000)  (XLN(I , J), J=1  ,  NPI)
C      WRITE(LPRINT, 307)
C307   FORMAT(1H   , 'ILenne->XILN ')
C      DO  904  I  =1  ,  NPI
C904   WRITE(LPRINT, 1000)  (XILN(I , J), J=1  ,  NPI)
C      WRITE(LPRINT, 1001)
      		
C     Matrix B->Bmat computation

      DO  41  I = 1  ,  NPI
      ELEH  =  0.0
      DO  42  J  = 1   ,  NPI
42    ELEH  =  ELEH  + XILN(I, J) * VPHI(J)
      PWEIO(I)  =  ELEH
41    CONTINUE

C      WRITE(LPRINT, 401)
C401   FORMAT(1H   ,'Pweio ')
C      WRITE(LPRINT, 1000) (PWEIO(I) , I = 1  ,  NPI)

      DO  44  I  =1  ,  NPI
      DO  44  J =  1  ,  NPI
44    BMAT(I , J) =  0.0

      IF(NP  .GT.  0)  THEN
      JJ =  1
      DO  43  J  =  1  ,  NP
      JJ =  JJ +  1
      DO  45   I  =  1  ,  NPI
45    BMAT(I , J) =  XILN(I , JJ)
43    CONTINUE
      ENDIF  

C      WRITE(LPRINT, 402)
C402   FORMAT(1H   , 'BMAT after autoregression ')
C      DO  906  I  =1  ,  NPI
C906   WRITE(LPRINT, 1000)  (BMAT(I , J), J=1  ,  NPI)

C      WRITE(LPRINT, 403)
C403   FORMAT(1H  ,'Building BMAT : MA part ')

      IF(NQ  .GT.  0)  THEN

      DO   46  J  = 1 ,  NQ

      DO   47  II  =  1  ,  NPI
      DO  47    IJ  =  1,  NPI
      IF(II  .EQ.  J + IJ) THEN
      DELTAN(II ,  IJ) =  -1.0
      ELSE
      DELTAN(II ,  IJ) =  0.0
      ENDIF
47    CONTINUE

C      WRITE(LPRINT, 404) J
C404   FORMAT(1H   , 'MA param n. ', I5)
C      WRITE(LPRINT, 405) 
C405   FORMAT(1H   , 'DELTAN ' )
C      DO  907  I  =1  ,  NPI
C907   WRITE(LPRINT, 1000)  (DELTAN(I , JI), JI =1  ,  NPI)
      
      DO  48  II  =  1 , NPI
      DO  48  JJ  =  1 ,  NPI
      ELEH  =  0.0
      DO   49  IJ =  1  ,  NPI
49    ELEH  = ELEH + XILN(II , IJ) * DELTAN(IJ , JJ)
      TEMPY(II ,  JJ) =  -ELEH
48    CONTINUE

      IJ  =  NP  + J
      DO  50  II  =  1 ,  NPI
      ELEH  =  0.0
      DO  51   JJ  =  1  ,  NPI
51    ELEH =  ELEH + TEMPY(II , JJ) * PWEIO(JJ)
      BMAT(II , IJ)  =  ELEH
50    CONTINUE

C      WRITE(LPRINT, 406) 
C406   FORMAT(1H   , 'BMAT in progress ... ' )
C      DO  908  I  =1  ,  NPI
C908   WRITE(LPRINT, 1000)  (BMAT(I , JI), JI =1  ,  NPI)

46    CONTINUE

      ENDIF

C      WRITE(LPRINT, 407) 
C407   FORMAT(1H   , 'BMAT ' )
C      DO  909  I  =1  ,  NPI
C909   WRITE(LPRINT, 1000)  (BMAT(I , JI), JI =1  ,  NPI)
C      WRITE(LPRINT, 1001)

C     CALCTRACM0:--->CALCOLA LE TRACCE t1, t2, t3
C     INPUT: matrici B->BMAT e V->XMCOV ottenute per il modello M0
C     OUTPUT: tracce t1, t2, t3
C     H0: (pix-pi0) asympt N(0, Sigma)  Sigma = A B V0 B' A'
C     Qui A=I (identity matrix), B e V0 si riferiscono al modello M0
C     tr(Sigma^k)=tr[(B'B V)^k], k=1,2,3

      DO 55  I  = 1 ,  NV
      DO  55  J  =  1  ,  NV
      ELEH =  0.0
      DO  56  IJ  =  1  ,  NPI
56    ELEH =  ELEH + BMAT(IJ, I) * BMAT(IJ, J)
      TEMPY(I, J)  =  ELEH 
55    CONTINUE

C      WRITE(LPRINT, 507) 
C507   FORMAT(1H   , 'transpose(BMAT) BMAT ' )
C      DO  917  I  =1  ,  NV
C917   WRITE(LPRINT, 1000)  (TEMPY(I , J), J =1  , NV)

      DO  57  I =  1 ,  NV
      DO  57  J  =1  ,  NV
      ELEH  = 0.0
      DO  58  IJ  =  1  ,  NV
58    ELEH  =  ELEH +  TEMPY(I , IJ) * XMCOV(IJ , J)
      OMEGA(I , J)  =  ELEH
57    CONTINUE
      T1  =  0.0
      DO  59  I  = 1 , NV
59    T1  = T1  +  OMEGA(I , I)

C      WRITE(LPRINT, 508) 
C508   FORMAT(1H   , 'OMEGA = transpose(BMAT) BMAT XMCOV' )
C      DO  918  I  =1  ,  NV
C918   WRITE(LPRINT, 1000)  (OMEGA(I , J), J =1  , NV)
C      WRITE(LPRINT, 518)  T1 
C518   FORMAT(1H   , 'tr(OMEGA) ' , F12.6)

      DO  60  I =  1 ,  NV
      DO  60  J  =1  ,  NV
      ELEH  = 0.0
      DO  61  IJ  =  1  ,  NV
61    ELEH  =  ELEH +  OMEGA(I , IJ) * OMEGA(IJ , J)
      TEMPY(I , J)  =  ELEH
60    CONTINUE
      T2  =  0.0
      DO  62  I  = 1 , NV
62    T2  = T2  +  TEMPY(I , I)

C      WRITE(LPRINT, 509) 
C509   FORMAT(1H   , 'OMEGA^2' )
C      DO  919  I  =1  ,  NV
C919   WRITE(LPRINT, 1000)  (TEMPY(I , J), J =1  , NV)
C      WRITE(LPRINT, 519)  T2 
C519   FORMAT(1H   , 'tr(OMEGA^2) ' , F12.6)

      DO  63  I =  1 ,  NV
      DO  63  J  =1  ,  NV
      ELEH  = 0.0
      DO  64  IJ  =  1  ,  NV
64    ELEH  =  ELEH +  TEMPY(I , IJ) * OMEGA(IJ , J)
      DELTAN(I , J)  =  ELEH
63    CONTINUE
      T3  =  0.0
      DO  65  I  = 1 , NV
65    T3  = T3  +  DELTAN(I , I)

C      WRITE(LPRINT, 510) 
C510   FORMAT(1H   , 'OMEGA^3' )
C      DO  920  I  =1  ,  NV
C920   WRITE(LPRINT, 1000)  (DELTAN(I , J), J =1  , NV)
C      WRITE(LPRINT, 520)  T3 
C520   FORMAT(1H   , 'tr(OMEGA^3) ' , F12.6)
C      WRITE(LPRINT, 1001)

      AHAT = T3 / T2
      AHAT =  AHAT  / DBLE(NOB)
      BHAT =  T1 - (T2 * T2 / T3)
      BHAT =  BHAT  / DBLE(NOB)
      XNU = (T2 * T2 * T2) / (T3 * T3)
      HHNI2  =  XNU / 2D0
      GGGG  =  ALOGAM(HHNI2 , IFAUL2)
      PPOINT  =  1D0  -  ALPHA
	  PX = PPCHI2(PPOINT, XNU, GGGG, IFAULT) * AHAT + BHAT

      WRITE(LPRINT, 511) 
511   FORMAT(1H  ,'AHAT,BHAT,XNU,HHNI2,GGGG,ALPHA,PPOINT ')
      WRITE(LPRINT, 1005) AHAT, BHAT, XNU, HHNI2, GGGG, ALPHA, PPOINT
1005  FORMAT(1H  ,2D12.4, 2F10.4, D12.4, 2F6.2)
      WRITE(LPRINT, 512)  PX
512   FORMAT(1H  ,'Percentile ', D14.5)
      WRITE(LPRINT, 1001)

C      WRITE(LPRINT, 107)
C107   FORMAT(1H   ,'Exit D2TEST ...')

      RETURN
1000  FORMAT(1H  , 7F10.4)
1001  FORMAT(1H   ,'//'  )
      END


      SUBROUTINE  POLINV(PHI, NP, YNVPHI, NPI, XCO, A1)

C     Polynomial inversion:
C     (A1 + XCO * PHI(1) * B + ... + XCO * PHI(NP) * B^NP)^-1 =
C     A1 + YNVPHI(1) * B + ... + YNVPHI(NPI) * B^NPI

      IMPLICIT REAL*8 (A - H, O-Z)
      DIMENSION PHI(NP), YNVPHI(NPI)

      YNVPHI(1) =  A1
      YNVPHI(2)  =  -XCO * PHI(1)

      IF(NPI .GT.  2)  THEN
      DO   10  I  = 3 ,  NPI
      IJ  =  I  -  1
      YNVPHI(I)  =  -XCO * PHI(IJ)
      II  =  I  -  2
      DO  20  J  =1  ,  II
      JJ  =  II - J  + 2
20    YNVPHI(I) =  YNVPHI(I) - XCO * PHI(J) * YNVPHI(JJ)
10    CONTINUE
      ENDIF

      RETURN
      END


	real*8 function ppchi2(p  ,  v  ,   g,  ifault)

c     algorithm AS 91 Applied Statistics (1975) vol. 24, p. 385

c     to evaluate the percentage points of the chi-squared 
c     probability distribution function.
c     p  must lie in the range 0.000002 to  0.999998,
c     v  must be positive,
c     g  must be supplied and should be equal to  ln(gamma(v/2.0))

c       real p, v, g, gammds, ppnd,  aa, e , zero, half, one , two,
       real*8 p, v, g, gammad, ppnd16,  aa, e , zero, half, one , two,
     $   three,  six , pmin, pmax, c1, c2, c3, c4, c5, c6, c7, c8,
     $  c9, c10, c11, c12, c13, c14, c15, c16, c17, c18, c19, c20,
     $   c21, c22, c23, c24, c25, c26, c27, c28, c29, c30, c31,
     $   c32, c33, c34, c35, c36, c37, c38,  a , b,  c, ch , p1, p2,
     $   q, s1, s2 , s3,  s4,  s5,  s6, t, x  ,   xx,
     $   zabs,  zexp  ,  zlog  ,   zsqrt

c         aa  =   ln(2)     ;     c2   =   2/9
c    e = 1.5E-5 is replacing e = 0.5E-6 to keep the routine away from
c    looping indefinitely due to lack of precision  

       data             aa  ,         e  ,     pmin,        pmax
     $       /0.6931471806 ,     1.5e-5 ,  0.000002 ,    0.999998/
c     $       /0.6931471806 ,     0.5e-6 ,  0.000002 ,    0.999998/
       data  zero,  half, one, two,   three,   six
     $      /0.0  ,  0.5  ,  1.0  ,   2.0  ,  3.0  ,   6.0/
       data       c1,      c2,      c3,      c4,      c5,       c6,
     $            c7,      c8,      c9,     c10,     c11,      c12,
     $           c13,     c14,     c15,     c16,     c17,      c18,
     $           c19,     c20,     c21,     c22,     c23,      c24,
     $           c25,     c26,     c27,     c28,     c29,      c30,
     $           c31,     c32,     c33,     c34,     c35,      c36,
     $           c37,     c38/
     $          0.01, 0.222222,   0.32,     0.4,    1.24,      2.2,
     $          4.67,     6.66,   6.73,   13.32,    60.0,      70.0,
     $         84.0,     105.0,  120.0,   127.0,   140.0,     175.0,
     $        210.0,     252.0,  264.0,   294.0,   346.0,     420.0,
     $        462.0,     606.0,  672.0,   707.0,   735.0,     889.0,
     $        932.0,     966.0, 1141.0,  1182.0,  1278.0,    1740.0,
     $       2520.0,    5040.0/

	   zabs(x)   =    dabs(x)
	   zexp(x)   =   dexp(x)
	   zlog(x)   =   dlog(x)
	   zsqrt(x)   =   dsqrt(x)

c           test arguments and initialize

	   ppchi2  =   -one
	   ifault   =  1
	   if(p.lt.pmin.or.p.gt.pmax)   return
	   ifault   =   2
	   if  (v.le.zero)   return
	   ifault   =     0
	   xx   =   half  *   v
	   c  =   xx  -   one

c           starting approximation for small chi-squared

	   if(v  .ge.   -c5 * zlog(p))    goto  1
	   ch = (p * xx *zexp(g + xx * aa)) ** (one / xx)
	   if(ch .lt. e)   goto  6
	   goto     4

c          starting approximation for v less than or equal to 0.32 

1         if(v  .gt.   c3)    goto   3
	  ch  =    c4
	  a  =   zlog(one  -  p)
2          q   =    ch
	  p1  =  one  +  ch * (c7 +  ch)
	  p2  =  ch *  (c9 + ch * (c8  +  ch))
	  t  =  -half + (c7 + two * ch)/ p1 - (c9 + ch * (c10  +
     $       three * ch)) / p2
	  ch = ch - (one - zexp(a + g + half * ch + c * aa) *
     $       p2 / p1) /  t
	 if(zabs(q / ch - one) .gt. c1)    goto   2
	   goto  4

c      call to algorithm AS 111 - note that p has been tested above

3          x  =    ppnd16(p  ,    if1)

c       starting approximation using Wilson and Hilferty estimate

	     p1  =   c2  /   v
	     ch =  v * (x * zsqrt(p1) + one - p1) ** 3

c       starting approximation for p tending to 1

	    if(ch .gt.  c6 * v + six)
     $  ch = -two * (zlog(one - p) - c * zlog(half * ch) + g)

c  call to algorithm AS 147 and calculation of seven term Taylor series
c   the real function gammds(y,p,ifault) computes the incomplete gamma 
c  integral G(y,p)= (1/Gamma(p)) Int{0,y} u^(p-1) exp(-u) du (Lau,1980)
c  gammds is replaced here by the algorithm AS 239 (Shea, 1988)
c  real function gammad(x,p,ifault) x : the value of the upper integral
c  limit x, p : the value of the parameter p, ifault :a fault indicator

4       q   =     ch
       p1   =   half * ch
c       p2  =   p   -   gammds(p1  ,    xx,    if1)
	p2  =   p    -   gammad(p1  ,    xx,    if1)
       if(  if1  .eq.   0)    goto   5
       ifault   =     3
       return
5       t = p2 * zexp(xx * aa + g + p1 - c * zlog(ch))
	b  =   t / ch
	a    =  half * t -  b * c
       s1 = (c19 + a * (c17 + a* (c14 + a *(c13 +  a* (c12  +
     $    c11 * a)))))  /  c24
       s2 =  (c24 + a * (c29 + a * (c32 + a * (c33 + c35 *
     $     a))))  /  c37
       s3  =  (c19 + a * (c25 + a * (c28 + c31 * a))) / c37
       s4 = (c20 + a * (c27 + c34 * a) + c * (c22 + a * (c30 +
     $  c36 * a))) /  c38
       s5 = (c13 + c21 * a + c * (c18 + c26 * a)) / c37
       s6  =  (c15 + c * (c23 + c16 * c)) / c38
       ch = ch + t * (one + half * t * s1 - b * c * (s1 - b *
     $   (s2 - b * (s3 - b * (s4 - b * (s5 - b * s6))))))
	if(zabs(q / ch - one) .gt.  e)    goto   4

6        ppchi2    =    ch
	 return
	 end


      REAL*8 FUNCTION ALOGAM(X,IFAULT)                                                 
      implicit real*8(a - h , o - z)
C                                                                               
C      ALGORITHM ACM 291, COMM. ACM. (1966) VOL.9, P.684                        
C                                                                               
C      EVALUATES NATURAL LOGARITHM OF GAMMA(X)                                  
C      FOR X GREATER THAN ZERO                                                  
C                                                                               
C                                                                               
C      THE FOLLOWING CONSTANTS ARE ALOG(2PI)/2,                                 
C      1/1680, 1/1260, 1/360  AND 1/12                                          
C                                                                               
      DATA A1,A2,A3,A4,A5                                                       
     +  /0.918938533204673, 0.000595238095238,                        
     +   0.000793650793651, 0.002777777777778,                        
     +   0.083333333333333/                                                     
      DATA HALF,ZERO,ONE,SEVEN/0.5,0.0,1.0,7.0/             
C                                                                               
      ZLOG(F)=DLOG(F)                                                           
C                                                                               
      ALOGAM=ZERO                                                               
      IFAULT=1                                                                  
      IF(X.LE.ZERO)RETURN                                                       
      IFAULT=0                                                                  
      Y=X                                                                       
      F=ZERO                                                                    
      IF(Y.GE.SEVEN) GOTO 30                                                    
      F=Y                                                                       
10    Y=Y+ONE                                                                   
      IF(Y.GE.SEVEN) GOTO 20                                                    
      F=F*Y                                                                     
      GOTO 10                                                                   
20    F=-ZLOG(F)                                                                
30    Z=ONE/(Y*Y)                                                               
      ALOGAM=F+(Y-HALF)*ZLOG(Y)-Y+A1+(((-A2*Z+A3)*Z-A4)*Z+A5)/Y                 
      RETURN                                                                    
      END                                                                       


      REAL*8  FUNCTION QTEST(R, NAC, NOB)
      IMPLICIT  REAL*8 (A - H , O - Z)
      DIMENSION  R(NAC)
      NAC1  =  NAC + 1
      SUM  =  0D0
      DO  1  K  = 2 ,  NAC1
1     SUM  =  SUM  +  R(K) * R(K) / DBLE(NOB - K + 1)  
      QTEST = DBLE(NOB) * DBLE(NOB + 1) * SUM
      RETURN
      END
   

	 real*8 function  gammad(x  ,  p  ,  ifault)

c    algorithm AS 239 Applied Statistics (1988) Vol. 37, no. 3

c    computation of the Incomplete Gamma Integral
c    G(x , p)  =  (1 / Gamma(p))  Int{0 , x} t^(p - 1) exp(-t) dt

	  integer  ifault
	  real*8   pn1, pn2, pn3, pn4, pn5, pn6, x, tol, oflo, xbig,
     *             arg, c, rn, p, a , b, one, zero, alogam,
     *             an, two,  elimit, plimit, alnorm, three, nine
	  intrinsic  dabs, dlog, dexp, dsqrt, dmin1
	  external    alogam,   alnorm
	  data zero, one, two, oflo, three, nine, tol, plimit, xbig,
     *  elimit/0.0,1.0,2.0,1.0E30,3.0,9.0,1.0E-7,1000.0,1.0E6,-88.0E0/

	    gammad   =   zero

c      Check that we have valid values for X and P

	 if(p.le.zero.or.x.lt.zero)   then
	      ifault  =   1
	      return
	 endif
	 ifault  =   0
	 if(x  .eq.  zero)   then
	      gammad  =  zero
	      return
	 endif

c      Use  a Normal  approximation if P  .gt.  PLIMIT

	  if(p  .gt.  plimit)   then
      pn1= three* dsqrt(p) * ((x/p)**(one/three) + one/(nine * p) - one)
	  gammad =   alnorm(pn1  ,  .false.)
	     return
	  endif

c     If  X is extremely large compared to  P then set GAMMAD   to  ONE

	  if(x  .gt. xbig)  then
	       gammad  =   one
	       return
	  endif

	 if(x.le.one  .or.  x.lt.p) then

c     Use Pearson's series expansion
c     (Note that P is not large enough to force overflow in ALOGAM)
c     No need to test IFAULT on exit since P .gt. zero

	 arg  =  p * dlog(x) - x - alogam(p + one , ifault)
	 c    =   one
	 gammad =    one
	 a   =   p
40       a   =    a   +   one
	 c  =   c * x / a
	 gammad   =   gammad  +   c
	 if(c  .gt.   tol)    goto    40
	 arg  =   arg  +  dlog(gammad)
	 gammad    =    zero
	 if(arg  .ge.   elimit)   gammad  =   dexp(arg)

       else

c      Use  a  continued  fraction  expansion

	 arg  =  p * dlog(x) - x - alogam(p  ,   ifault)
	 a =   one  -  p
	 b  =   a  +  x  +  one
	 c   =   zero
	 pn1  =   one
	 pn2   =   x
	 pn3  = x  +  one
	 pn4  =   x * b
	 gammad  =   pn3 / pn4
60       a  =  a  +  one
	 b  =   b   +   two
	 c   =  c  +  one
	 an  =    a * c
	 pn5  =   b * pn3  -  an * pn1
	 pn6 =   b * pn4  -  an * pn2
	 if(dabs(pn6)  .gt.  zero)    then
	     rn  =  pn5 / pn6
	    if(dabs(gammad - rn) .le. dmin1(tol  ,  tol * rn))  goto  80
	     gammad  =   rn
	 endif

	 pn1  =   pn3
	 pn2  =  pn4
	 pn3   =   pn5
	 pn4   =   pn6
	 if(dabs(pn5)  .ge.  oflo)    then

c          Re-scale terms in continued fraction if terms are large

	     pn1  =  pn1 / oflo
	     pn2 =   pn2 / oflo
	     pn3  =   pn3 / oflo
	     pn4 =  pn4 / oflo
	 endif
	 goto   60
80      arg  =   arg  +  dlog(gammad)
	gammad   =   one
	if(arg  .ge.  elimit)  gammad  =  one  -  dexp(arg)
      endif

	 end


	      real*8  function  alnorm(x  ,   upper)

c             algorithm AS 66 Applied Statistics (1973) Vol. 22, p. 424

c             evaluates the tail area of the standardized normal curve
c             from x to infinity if upper is .true. or
c             from minus infinity to x if upper is .false.

	  real*8 ltone , utzero , zero , half , one , con , a1 , a2 , a3 ,
     $   a4 , a5 , a6 , a7 , b1 , b2 , b3 , b4 , b5 , b6 , b7 , b8 , b9,
     $   b10 , b11 , b12 , x , y , z , zexp
	  logical   upper  ,   up

c           ltone and utzero must be set to suit the particular computer
c           (see introductory text)

	    data  ltone  ,   utzero / 7.0  ,  18.66 /
	    data  zero , half , one , con / 0.0 , 0.5 , 1.0 , 1.28 /
	    data              a1,              a2,                a3,
     $                        a4,              a5,                a6,
     $                        a7
     $        /   0.398942280444,  0.399903438504,     5.75885480458,
     $             29.8213557808,   2.62433121679,     48.6959930692,
     $             5.92885724438  /
	    data              b1,              b2,                  b3,
     $                        b4,              b5,                  b6,
     $                        b7,              b8,                  b9,
     $                       b10,             b11,                 b12
     $         /  0.398942280385,       3.8052E-8,       1.00000615302,
     $             3.98064794E-4,   1.98615381364,      0.151679116635,
     $             5.29330324926,    4.8385912808,       15.1508972451,
     $            0.742380924027,    30.789933034,       3.99019417011 /

	       zexp(z)    =     exp(z)

	       up   =    upper
	       z    =  x
	       if(z  .ge.  zero)     goto   10
	       up   =   .not.  up
	       z      =    -z
10      if(z .le. ltone .or. up . and. z .le. utzero)   goto   20
	       alnorm   =   zero
	       goto     40
20             y  =   half  *  z   *  z
	   if(z  .  gt.    con)    goto    30

      alnorm = half - z*(a1 - a2*y/(y + a3 - a4/(y + a5 + a6/(y + a7))))
		  goto    40

30    alnorm = b1 * zexp( -y) / (z - b2 + b3 / (z + b4 + b5 / (z -
     $   b6 + b7 / (z + b8 - b9 / (z + b10 + b11 / (z + b12 ))))))

40           if(.not.   up)    alnorm   =   one  -   alnorm
		 return
		   end


       SUBROUTINE VSUNIF(ISEME,P2)
      IMPLICIT INTEGER*4 (I-N)
      REAL*8 CC0,CC1,CC2,CC3,CC4,P2
      DATA CC2/16807.D0/,CC3/2147483647.D0/
      SAVE
      CC1=ISEME
      CC1=CC1*CC2
      CC4=DMOD(CC1,CC3)
      ISEME=CC4
      CC0=CC4
      P2=CC0/CC3
      RETURN
      END


      REAL*8 function  random(l)

c        algorithm as 183 Appl. Statist. (1982) Vol. 31, no. 2
c
c        returns a pseudo-random number rectangularly distributed 
c        between  0  and 1.
c
c        ix, iy and iz should be set to integer values between 
c        1 and 30000 before first entry
c
c        integer arithmetic up to 30323  is required

      IMPLICIT REAL*8 (A -H , O - Z)
	common /rand/  ix, iy,  iz
	ix = 171 * mod(ix, 177) - 2 * (ix / 177)
	iy = 172 * mod(iy, 176) - 35 * (iy / 176)
	iz = 170 * mod(iz, 178) - 63 * (iz / 178)

	if (ix .lt. 0) ix = ix + 30269
	if (iy .lt. 0) iy = iy + 30307
	if (iz .lt. 0) iz = iz + 30323

c        if integer arithmetic up to 5212632 is available, 
c        the preceding 6 statements may be replaced by
c
c        ix = mod(171 * ix, 30269)
c        iy = mod(172 * iy, 30307) 
c        iz = mod(170 * iz, 30323)
c
c        on some machines, this may slightly increase
c        the speed. the results will be identical.

	random  = DMOD(DBLE(ix) / 30269D0 + DBLE(iy) / 30307D0 +
     *                 DBLE(iz) / 30323D0, 1D0)

	return
	end


        DOUBLE PRECISION FUNCTION PPND16 (P, IFAULT)
C
C       ALGORITHM AS241  APPL. STATIST. (1988) VOL. 37, NO. 3
C
C       Produces the normal deviate Z corresponding to a given lower
C       tail area of P; Z is accurate to about 1 part in 10**16.
C
C       The hash sums below are the sums of the mantissas of the
C       coefficients.   They are included for use in checking
C       transcription.
C
        DOUBLE PRECISION ZERO, ONE, HALF, SPLIT1, SPLIT2, CONST1,
     *          CONST2, A0, A1, A2, A3, A4, A5, A6, A7, B1, B2, B3,
     *          B4, B5, B6, B7,
     *          C0, C1, C2, C3, C4, C5, C6, C7, D1, D2, D3, D4, D5,
     *          D6, D7, E0, E1, E2, E3, E4, E5, E6, E7, F1, F2, F3,
     *          F4, F5, F6, F7, P, Q, R
        PARAMETER (ZERO = 0.D0, ONE = 1.D0, HALF = 0.5D0,
     *          SPLIT1 = 0.425D0, SPLIT2 = 5.D0,
     *          CONST1 = 0.180625D0, CONST2 = 1.6D0)
C
C       Coefficients for P close to 0.5
C
        PARAMETER (A0 = 3.38713 28727 96366 6080D0,
     *             A1 = 1.33141 66789 17843 7745D+2,
     *             A2 = 1.97159 09503 06551 4427D+3,
     *             A3 = 1.37316 93765 50946 1125D+4,
     *             A4 = 4.59219 53931 54987 1457D+4,
     *             A5 = 6.72657 70927 00870 0853D+4,
     *             A6 = 3.34305 75583 58812 8105D+4,
     *             A7 = 2.50908 09287 30122 6727D+3,
     *             B1 = 4.23133 30701 60091 1252D+1,
     *             B2 = 6.87187 00749 20579 0830D+2,
     *             B3 = 5.39419 60214 24751 1077D+3,
     *             B4 = 2.12137 94301 58659 5867D+4,
     *             B5 = 3.93078 95800 09271 0610D+4,
     *             B6 = 2.87290 85735 72194 2674D+4,
     *             B7 = 5.22649 52788 52854 5610D+3)
C       HASH SUM AB    55.88319 28806 14901 4439
C
C       Coefficients for P not close to 0, 0.5 or 1.
C
        PARAMETER (C0 = 1.42343 71107 49683 57734D0,
     *             C1 = 4.63033 78461 56545 29590D0,
     *             C2 = 5.76949 72214 60691 40550D0,
     *             C3 = 3.64784 83247 63204 60504D0,
     *             C4 = 1.27045 82524 52368 38258D0,
     *             C5 = 2.41780 72517 74506 11770D-1,
     *             C6 = 2.27238 44989 26918 45833D-2,
     *             C7 = 7.74545 01427 83414 07640D-4,
     *             D1 = 2.05319 16266 37758 82187D0,
     *             D2 = 1.67638 48301 83803 84940D0,
     *             D3 = 6.89767 33498 51000 04550D-1,
     *             D4 = 1.48103 97642 74800 74590D-1,
     *             D5 = 1.51986 66563 61645 71966D-2,
     *             D6 = 5.47593 80849 95344 94600D-4,
     *             D7 = 1.05075 00716 44416 84324D-9)
C       HASH SUM CD    49.33206 50330 16102 89036
C
C       Coefficients for P near 0 or 1.
C
        PARAMETER (E0 = 6.65790 46435 01103 77720D0,
     *             E1 = 5.46378 49111 64114 36990D0,
     *             E2 = 1.78482 65399 17291 33580D0,
     *             E3 = 2.96560 57182 85048 91230D-1,
     *             E4 = 2.65321 89526 57612 30930D-2,
     *             E5 = 1.24266 09473 88078 43860D-3,
     *             E6 = 2.71155 55687 43487 57815D-5,
     *             E7 = 2.01033 43992 92288 13265D-7,
     *             F1 = 5.99832 20655 58879 37690D-1,
     *             F2 = 1.36929 88092 27358 05310D-1,
     *             F3 = 1.48753 61290 85061 48525D-2,
     *             F4 = 7.86869 13114 56132 59100D-4,
     *             F5 = 1.84631 83175 10054 68180D-5,
     *             F6 = 1.42151 17583 16445 88870D-7,
     *             F7 = 2.04426 31033 89939 78564D-15)
C       HASH SUM EF    47.52583 31754 92896 71629
C
        IFAULT = 0
        Q = P - HALF
        IF (ABS(Q) .LE. SPLIT1) THEN
          R = CONST1 - Q * Q
          PPND16 = Q * (((((((A7 * R + A6) * R + A5) * R + A4) * R + A3)
     *                  * R + A2) * R + A1) * R + A0) /
     *                (((((((B7 * R + B6) * R + B5) * R + B4) * R + B3)
     *                  * R + B2) * R + B1) * R + ONE)
          RETURN
        ELSE
          IF (Q .LT. ZERO) THEN
            R = P
          ELSE
            R = ONE - P
          END IF
          IF (R .LE. ZERO) THEN
            IFAULT = 1
            PPND16 = ZERO
            RETURN
          END IF
          R = SQRT(-LOG(R))
          IF (R .LE. SPLIT2) THEN
            R = R - CONST2
            PPND16 = (((((((C7 * R + C6) * R + C5) * R + C4) * R + C3)
     *                  * R + C2) * R + C1) * R + C0) /
     *               (((((((D7 * R + D6) * R + D5) * R + D4) * R + D3)
     *                  * R + D2) * R + D1) * R + ONE)
          ELSE
            R = R - SPLIT2
            PPND16 = (((((((E7 * R + E6) * R + E5) * R + E4) * R + E3)
     *                  * R + E2) * R + E1) * R + E0) /
     *               (((((((F7 * R + F6) * R + F5) * R + F4) * R + F3)
     *                  * R + F2) * R + F1) * R + ONE)
          END IF
          IF (Q .LT. ZERO) PPND16 = - PPND16
          RETURN
        END IF
        END


	real*8 function uniform()
c
c	Generate uniformly distributed random numbers using the 32-bit
c	generator from figure 3 of:
c	L'Ecuyer, P. Efficient and portable combined random number
c	generators, C.A.C.M., vol. 31, 742-749 & 774-?, June 1988.
c
c	The cycle length is claimed to be 2.30584E+18
c
c	Seeds can be set by calling the routine set_uniform
c
c	It is assumed that the Fortran compiler supports long variable
c	names, and integer*4.
c
	integer*4 z, k, s1, s2
	common /unif_seeds/ s1, s2
	save /unif_seeds/
c
	k = s1 / 53668
	s1 = 40014 * (s1 - k * 53668) - k * 12211
	if (s1 .lt. 0) s1 = s1 + 2147483563
c
	k = s2 / 52774
	s2 = 40692 * (s2 - k * 52774) - k * 3791
	if (s2 .lt. 0) s2 = s2 + 2147483399
c
	z = s1 - s2
	if (z .lt. 1) z = z + 2147483562
c
	uniform = z / 2147483563.
	return
	end


	subroutine set_uniform(seed1, seed2)
c
c	Set seeds for the uniform random number generator.
c
	integer*4 s1, s2, seed1, seed2
	common /unif_seeds/ s1, s2
	save /unif_seeds/

	s1 = seed1
	s2 = seed2
	return
	end











  